/*
 * Attack.java
 *
 * Created on April 17, 2004, 1:18 AM
 */

package simulations.core;

import java.util.ArrayList;

/**
 * This class contains infos about an attack
 * ie the attacking player and the players to
 * ask support
 * @author  tom
 */
public class Attack {
    
    /** The attacking player **/
    private Player attackingPlayer;
    
    /** The attacked player **/
    private Player attackedPlayer;
    
    /** The players list to ask support **/
    private ArrayList askingList;
    
    /** Creates a new instance of Attack
     * @param attackingPlayer The attacking player
     * @param attackedPlayer The attacked player
     * @param askingList The list of players to ask support
     */
    public Attack(Player attackingPlayer, Player attackedPlayer, ArrayList askingList) {
        this.attackingPlayer=attackingPlayer;
        this.attackedPlayer=attackedPlayer;
        this.askingList=askingList;
    }
    
    /** Getter for property askingList.
     * @return Value of property askingList.
     *
     */
    public java.util.ArrayList getAskingList() {
        return askingList;
    }
    
    /** Setter for property askingList.
     * @param askingList New value of property askingList.
     *
     */
    public void setAskingList(java.util.ArrayList askingList) {
        this.askingList = askingList;
    }
        
    /** Getter for property attackedPlayer.
     * @return Value of property attackedPlayer.
     *
     */
    public simulations.core.Player getAttackedPlayer() {
        return attackedPlayer;
    }
    
    /** Setter for property attackedPlayer.
     * @param attackedPlayer New value of property attackedPlayer.
     *
     */
    public void setAttackedPlayer(simulations.core.Player attackedPlayer) {
        this.attackedPlayer = attackedPlayer;
    }
    
    /** Getter for property attackingPlayer.
     * @return Value of property attackingPlayer.
     *
     */
    public simulations.core.Player getAttackingPlayer() {
        return attackingPlayer;
    }
    
    /** Setter for property attackingPlayer.
     * @param attackingPlayer New value of property attackingPlayer.
     *
     */
    public void setAttackingPlayer(simulations.core.Player attackingPlayer) {
        this.attackingPlayer = attackingPlayer;
    }
    
}
