/*
 * GameHistory.java
 *
 * Created on March 20, 2004, 10:14 PM
 */

package simulations.core.history;

import java.util.ArrayList;
import java.util.Iterator;

import simulations.core.Player;

/** This class describes the whole game history
 * @author tom
 */
public class GameHistory {
    
    private ArrayList turnList;
    
    /** Creates a new instance of GameHistory
     * @param turnList The list of all turns of game
     */
    public GameHistory(ArrayList turnList) {
        this.turnList=turnList;
    }
    
    /** Contructor */    
    public GameHistory() {
        turnList=new ArrayList();
    }
    
    /** Add a turn in the game history
     * @param turn The turn to add
     */    
    public void add(Turn turn) {
        turnList.add(turn);
    }
    
    /** Print the turn */    
    public void print() {
        Iterator it = turnList.iterator();
        String s="";
        int cpt=1;
        while (it.hasNext()) {
            System.out.println("turn #"+cpt);
            cpt++;
            Turn t = (Turn)it.next();
            t.print();
        }
    }
        
    /** Getter for property turnList.
     * @return Value of property turnList.
     *
     */
    public java.util.ArrayList getTurnList() {
        return turnList;
    }
    
    /** Setter for property turnList.
     * @param turnList New value of property turnList.
     *
     */
    public void setTurnList(java.util.ArrayList turnList) {
        this.turnList = turnList;
    }
    
}
