/*
 * AttackedPlayerElement.java
 *
 * Created on April 13, 2004, 1:37 AM
 */

package simulations.core.history;

import simulations.core.Player;

/**
 * This class is used to memorize the number of time that a player attack another
 * the number of times that a player ask support to another
 * the number of times that a player accept to support my attack
 * @author  tom
 */
public class PlayerStatElement {
    
    /** The player **/
    private Player player;
    
    /** The number of times **/
    private int nb;
    
    /** Creates a new instance of AttackedPlayerElement
     * @param player The concerned player
     * @param nb The number associated to memorize
     */
    public PlayerStatElement(Player player, int nb) {
        this.player=player;
        this.nb=nb;
    }
    
    /** Getter for property nb.
     * @return Value of property nb.
     *
     */
    public int getNb() {
        return nb;
    }
    
    /** Setter for property nb.
     * @param nb New value of property nb.
     *
     */
    public void setNb(int nb) {
        this.nb = nb;
    }
    
    /** Getter for property player.
     * @return Value of property player.
     *
     */
    public simulations.core.Player getPlayer() {
        return player;
    }
    
    /** Setter for property player.
     * @param player New value of property player.
     *
     */
    public void setPlayer(simulations.core.Player player) {
        this.player = player;
    }
    
    /** Redefinition of toString method
     * @return The String representing the element
     **/
    public String toString() {
        return player.toString()+" : "+nb;
    }
    
}
