/*
 * PlayerIntElement.java
 *
 * Created on April 23, 2004, 1:35 AM
 */

package simulations.core.strategy;

import simulations.core.Player;

/**
 * This class is used to store an int associated to a player
 * @author  tom 
 */
public class PlayerIntElement {
    
    /** The player **/
    private Player player;
    
    /** The associated integer **/
    private int nb;
    
    /** Creates a new instance of PlayerIntElement */
    public PlayerIntElement() {
    }
    
    /** Creates a new instance of PlayerIntElement 
     * @param player The player
     * @param nb The associated integer
     **/
    public PlayerIntElement(Player player, int nb) {
        this.player=player;
        this.nb=nb;
    }
    
    /**
     * Getter for property nb.
     * @return Value of property nb.
     */
    public int getNb() {
        return nb;
    }
    
    /**
     * Setter for property nb.
     * @param nb New value of property nb.
     */
    public void setNb(int nb) {
        this.nb = nb;
    }
    
    /**
     * Getter for property player.
     * @return Value of property player.
     */
    public simulations.core.Player getPlayer() {
        return player;
    }
    
    /**
     * Setter for property player.
     * @param player New value of property player.
     */
    public void setPlayer(simulations.core.Player player) {
        this.player = player;
    }
    
    /**
     * Override of toString() method
     * @return the player and the nb
     **/
    public String toString() {
        return player.toString()+" : "+nb;
    }
    
}
