/*
 * PlayerObjectElement.java
 *
 * Created on May 5, 2004, 12:04 AM
 */

package simulations.core.strategy;

import simulations.core.Player;

/**
 * This class describes an object used to store an object 
 * associated to a player
 * @author  tom
 */
public class PlayerObjectElement {
    
    /** The player **/
    private Player player;
    
    /** The associated object **/
    private Object object;
    
    /**
     * Creates a new instance of PlayerObjectElement
     * @param player The player
     * @param object The object to associate to player
     */
    public PlayerObjectElement(Player player, Object object) {
        this.player=player;
        this.object=object;
    }
    
    /**
     * Getter for property object.
     * @return Value of property object.
     */
    public java.lang.Object getObject() {
        return object;
    }
    
    /**
     * Setter for property object.
     * @param object New value of property object.
     */
    public void setObject(java.lang.Object object) {
        this.object = object;
    }
    
    /**
     * Getter for property player.
     * @return Value of property player.
     */
    public simulations.core.Player getPlayer() {
        return player;
    }
    
    /**
     * Setter for property player.
     * @param player New value of property player.
     */
    public void setPlayer(simulations.core.Player player) {
        this.player = player;
    }
    
}
