/*
 * AttackWeakestStrategy.java
 *
 * Created on April 9, 2004, 2:33 AM
 */

package simulations.core.strategy.attackStrategy;

import simulations.core.Player;
import java.util.ArrayList;
import java.util.Iterator;
import simulations.core.history.Turn;

/** This class describes an attack strategy that always attack the weaker of the
 * remaining players
 * @author tom
 */
public class AttackWeakestStrategy extends AttackStrategy {
    
    /** Creates a new instance of AttackWeakestStrategy */
    public AttackWeakestStrategy() {
        super();
        name="AttackWeakestStrategy";
        memoryParam=false;
        abr="8";
    }
    
    /** return the player to attack
     * @param player The attacking player
     * @param playerList The list of <B>avalaible</B> player
     * @return The player to attack
     */    
    public ArrayList getPlayerToAttack(Player player, ArrayList playerList) {
        Iterator it = playerList.iterator();
        float min=Float.MAX_VALUE;
        ArrayList l = new ArrayList();
        while (it.hasNext()) {
            Player p = (Player)it.next();
            if (p.equals(player)) {
                continue;
            }
            if (p.getHitPoints()<min) {
                l.clear();
                l.add(p);
                min=p.getHitPoints();
            } else if (p.getHitPoints()==min) {
                l.add(p);
            }
        }
        if (negative) {
            ArrayList l2 = new ArrayList();
            it = playerList.iterator();
            while (it.hasNext()) {
                Player p = (Player)it.next();
                if (p.equals(player)) {
                    continue;
                }
                if (!(l.contains(p))) {
                    l2.add(p);
                }
            }
            return l2;
        } else {
            return l;
        }
    }
    
    /** This method is called by the judge to inform players of the last turn
     * @param turn The turn
     * @param player The owner of the strategy
     * @param remainingPlayers The list of the remaining players
     */    
    public void updateLastTurn(Turn turn, Player player, ArrayList remainingPlayers) {
    }
    
    /** return the description of this attack strategy
     * @return return the description of this attack strategy
     **/
    public String getDescription() {
        if (negative) {
            return "Attack strategy :\n"+
            "I always attack the weakest of the list\n"+
            "COMPLEMENTARY";
        } else {
            return "Attack strategy :\n"+
            "I always attack the weakest of the list\n";
        }
    }
    
}
