/*
 * AdvancedCoalitionalDef3Strategy.java
 *
 * Created on 24 juin 2004, 23:55
 */

package simulations.core.strategy.completeStrategy;

import java.util.Random;
import java.util.ArrayList;

import simulations.core.Player;
import simulations.core.history.Turn;

import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.SpitefulAttackStrategy2;
import simulations.core.strategy.attackStrategy.AttackWeakestStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.attackStrategy.CoalitionalDef3AttackStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.askingSupportStrategy.CoalitionalDef3AskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.CoalitionalDef3DecisionStrategy;

/**
 *
 * @author  tom
 */
public class AdvancedCoalitionalDef3Strategy extends GenericComposedStrategy {
    
    /** Creates a new instance of AdvancedCoalitionalDef3Strategy */
    public AdvancedCoalitionalDef3Strategy() {
        super();
        name="AdvancedCoalitionalDef3Strategy";
        attackStrategyVector.addElement(new CoalitionalDef3AttackStrategy());
        AttackStrategy attStrat = new SpitefulAttackStrategy2();
        attStrat.setMemory(5);
        attackStrategyVector.addElement(attStrat);
        AttackStrategy attStrat2 = new AttackWeakestStrategy();
        attStrat2.setMemory(5);
        attackStrategyVector.addElement(attStrat2);
        attackStrategyVector.addElement(new AttackRandomlyStrategy());
        askingStrategyVector.addElement(new CoalitionalDef3AskingStrategy());
        decisionStrategyVector.addElement(new CoalitionalDef3DecisionStrategy());
    }

    /**
     * This method is called by the judge after the decision of players to attack and to ask supports
     * to inform the strategy
     * @param player The owner of the strategy
     * @param attacksList The list of attacks
     */
    public void updateAttacksInfos(Player player, ArrayList attacksList) {
    }
    
}
