/*
 * PersistentStrategy2Memory5.java
 *
 * Created on 24 juin 2004, 23:08
 */

package simulations.core.strategy.completeStrategy;

import java.util.Random;
import java.util.ArrayList;

import simulations.core.Player;
import simulations.core.history.Turn;

import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.attackStrategy.AttackAttackedPlayersStrategy2;
import simulations.core.strategy.attackStrategy.AttackTheMostAttackedPlayerStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingEveryoneStrategy;
import simulations.core.strategy.askingSupportStrategy.RandomAskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.RandomSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.AcceptPlayersDontAttackMeStrategy2;

/**
 *
 * @author  tom
 */
public class PersistentStrategy2Memory5 extends GenericComposedStrategy {
    
    /** Creates a new instance of PersistentStrategy2Memory5 */
    public PersistentStrategy2Memory5() {
        super();
        name="PersistentStrategy2Memory5";
        AttackStrategy attStrat = new AttackAttackedPlayersStrategy2();
        attStrat.setMemory(5);
        attackStrategyVector.addElement(attStrat);
        AttackStrategy attStrat2 = new AttackTheMostAttackedPlayerStrategy();
        attStrat.setMemory(5);
        attackStrategyVector.addElement(attStrat2);
        attackStrategyVector.addElement(new AttackRandomlyStrategy());
        askingStrategyVector.addElement(new AskingEveryoneStrategy());
        DecisionSupportStrategy decStrat = new AcceptPlayersDontAttackMeStrategy2();
        decStrat.setMemory(5);
        decisionStrategyVector.addElement(decStrat);
    }

    /**
     * This method is called by the judge after the decision of players to attack and to ask supports
     * to inform the strategy
     * @param player The owner of the strategy
     * @param attacksList The list of attacks
     */
    public void updateAttacksInfos(Player player, ArrayList attacksList) {
    }
    
}
