/*
 * SimpleCoalitionalDef1Strategy.java
 *
 * Created on 24 juin 2004, 23:26
 */

package simulations.core.strategy.completeStrategy;

import java.util.Random;
import java.util.ArrayList;

import simulations.core.Player;
import simulations.core.history.Turn;

import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.attackStrategy.CoalitionalDef1AttackStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.askingSupportStrategy.CoalitionalDef1AskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.CoalitionalDef1DecisionStrategy;

/**
 *
 * @author  tom
 */
public class SimpleCoalitionalDef1Strategy extends GenericComposedStrategy {
    
    /** Creates a new instance of SimpleCoalitionalDef1Strategy */
    public SimpleCoalitionalDef1Strategy() {
        super();
        name="SimpleCoalitionalDef1Strategy";
        attackStrategyVector.addElement(new CoalitionalDef1AttackStrategy());
        attackStrategyVector.addElement(new AttackRandomlyStrategy());
        askingStrategyVector.addElement(new CoalitionalDef1AskingStrategy());
        decisionStrategyVector.addElement(new CoalitionalDef1DecisionStrategy());
    }

    /**
     * This method is called by the judge after the decision of players to attack and to ask supports
     * to inform the strategy
     * @param player The owner of the strategy
     * @param attacksList The list of attacks
     */
    public void updateAttacksInfos(Player player, ArrayList attacksList) {
    }
    
}
