/*
 * SimpleCoalitionalDef4Strategy.java
 *
 * Created on 24 juin 2004, 23:47
 */

package simulations.core.strategy.completeStrategy;

import java.util.Random;
import java.util.ArrayList;

import simulations.core.Player;
import simulations.core.history.Turn;

import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.attackStrategy.CoalitionalDef4AttackStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.askingSupportStrategy.CoalitionalDef4AskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.CoalitionalDef4DecisionStrategy;



/**
 *
 * @author  tom
 */
public class SimpleCoalitionalDef4Strategy extends GenericComposedStrategy {
    
    /** Creates a new instance of SimpleCoalitionalDef4Strategy */
    public SimpleCoalitionalDef4Strategy() {
        super();
        name="SimpleCoalitionalDef4Strategy";
        attackStrategyVector.addElement(new CoalitionalDef4AttackStrategy());
        attackStrategyVector.addElement(new AttackRandomlyStrategy());
        askingStrategyVector.addElement(new CoalitionalDef4AskingStrategy());
        decisionStrategyVector.addElement(new CoalitionalDef4DecisionStrategy());
    }

    /**
     * This method is called by the judge after the decision of players to attack and to ask supports
     * to inform the strategy
     * @param player The owner of the strategy
     * @param attacksList The list of attacks
     */
    public void updateAttacksInfos(Player player, ArrayList attacksList) {
    }
    
    
}
