/*
 * SimpleCoalitionalDef5Strategy.java
 *
 * Created on 24 juin 2004, 23:44
 */

package simulations.core.strategy.completeStrategy;

import java.util.Random;
import java.util.ArrayList;

import simulations.core.Player;
import simulations.core.history.Turn;

import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.attackStrategy.CoalitionalDef5AttackStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.askingSupportStrategy.CoalitionalDef5AskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.CoalitionalDef5DecisionStrategy;


/**
 *
 * @author  tom
 */
public class SimpleCoalitionalDef5Strategy extends GenericComposedStrategy {
    
    /** Creates a new instance of SimpleCoalitionalDef5Strategy */
    public SimpleCoalitionalDef5Strategy() {
        super();
        name="SimpleCoalitionalDef5Strategy";
        attackStrategyVector.addElement(new CoalitionalDef5AttackStrategy());
        attackStrategyVector.addElement(new AttackRandomlyStrategy());
        askingStrategyVector.addElement(new CoalitionalDef5AskingStrategy());
        decisionStrategyVector.addElement(new CoalitionalDef5DecisionStrategy());
    }

    /**
     * This method is called by the judge after the decision of players to attack and to ask supports
     * to inform the strategy
     * @param player The owner of the strategy
     * @param attacksList The list of attacks
     */
    public void updateAttacksInfos(Player player, ArrayList attacksList) {
    }
    
        
}
