/*
 * SpitefulStrategy2Memory10.java
 *
 * Created on 24 juin 2004, 22:39
 */

package simulations.core.strategy.completeStrategy;

import java.util.Random;
import java.util.ArrayList;

import simulations.core.Player;
import simulations.core.history.Turn;

import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.attackStrategy.SpitefulAttackStrategy2;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingPlayersDontAttackMeStrategy2;
import simulations.core.strategy.askingSupportStrategy.RandomAskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.RandomSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.AcceptPlayersDontAttackMeStrategy2;

/**
 *
 * @author  tom
 */
public class SpitefulStrategy2Memory10 extends GenericComposedStrategy {
    
    /** Creates a new instance of SpitefulStrategy2Memory10 */
    public SpitefulStrategy2Memory10() {
        super();
        name="SpitefulStrategy2Memory10";
        AttackStrategy attStrat = new SpitefulAttackStrategy2();
        attStrat.setMemory(10);
        attackStrategyVector.addElement(attStrat);
        attackStrategyVector.addElement(new AttackRandomlyStrategy());
        AskingStrategy askStrat = new AskingPlayersDontAttackMeStrategy2();
        askStrat.setMemory(10);
        askingStrategyVector.addElement(askStrat);
        DecisionSupportStrategy decStrat = new AcceptPlayersDontAttackMeStrategy2();
        decStrat.setMemory(10);
        decisionStrategyVector.addElement(decStrat);
    }

    /**
     * This method is called by the judge after the decision of players to attack and to ask supports
     * to inform the strategy
     * @param player The owner of the strategy
     * @param attacksList The list of attacks
     */
    public void updateAttacksInfos(Player player, ArrayList attacksList) {
    }
    
    
    
}
