/*
 * SpitefulStrategyMemory5.java
 *
 * Created on 24 juin 2004, 22:21
 */

package simulations.core.strategy.completeStrategy;

import java.util.Random;
import java.util.ArrayList;

import simulations.core.Player;
import simulations.core.history.Turn;

import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.attackStrategy.SpitefulAttackStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingPlayersDontAttackMeStrategy;
import simulations.core.strategy.askingSupportStrategy.RandomAskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.RandomSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.AcceptPlayersDontAttackMeStrategy;

/**
 *
 * @author  tom
 */
public class SpitefulStrategyMemory5 extends  GenericComposedStrategy {
    
    /** Creates a new instance of SpitefulStrategyMemory5 */
    public SpitefulStrategyMemory5() {
        super();
        name="SpitefulStrategyMemory5";
        AttackStrategy attStrat = new SpitefulAttackStrategy();
        attStrat.setMemory(5);
        attackStrategyVector.addElement(attStrat);
        attackStrategyVector.addElement(new AttackRandomlyStrategy());
        AskingStrategy askStrat = new AskingPlayersDontAttackMeStrategy();
        askStrat.setMemory(5);
        askingStrategyVector.addElement(askStrat);
        DecisionSupportStrategy decStrat = new AcceptPlayersDontAttackMeStrategy();
        decStrat.setMemory(5);
        decisionStrategyVector.addElement(decStrat);
    }

    /**
     * This method is called by the judge after the decision of players to attack and to ask supports
     * to inform the strategy
     * @param player The owner of the strategy
     * @param attacksList The list of attacks
     */
    public void updateAttacksInfos(Player player, ArrayList attacksList) {
    }
    
    
}
