/*
 * Communication.java
 *
 * Created on 3 juin 2004, 00:43
 */

package simulations.database.core;

import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.DriverManager; 
import java.sql.SQLException; 

/**
 *
 * @author  tom
 */
public class Communication {
    
    public Connection connection;
    
    /** Creates a new instance of Communication */
    public Communication() {
        try { 
            // The newInstance() call is a work around for some 
            // broken Java implementations
            Class.forName("com.mysql.jdbc.Driver").newInstance(); 
        } catch (Exception ex) { 
            // handle the error 
        }
        try {
            connection = DriverManager.getConnection("jdbc:mysql://localhost/simulations?user=root");
        } catch (SQLException ex) {
            // handle any errors 
            System.out.println("SQLException: " + ex.getMessage()); 
            System.out.println("SQLState: " + ex.getSQLState()); 
            System.out.println("VendorError: " + ex.getErrorCode()); 
        }
    }
    
    public void close() {
        try {
            connection.close();
        }catch(SQLException e) {
            e.printStackTrace();
        }
    }
    
    public ResultSet execQuery(String query) {
        //System.out.println("query : "+query);
        Statement stmt = null; 
        ResultSet rs = null; 
        try {
            stmt = connection.createStatement(); 
            rs = stmt.executeQuery(query); 
        }catch(SQLException e) {
            e.printStackTrace();
            System.exit(0);
        }
        return rs;
    }
    
    public int execUpdate(String query) {
        //System.out.println("query : "+query);
        Statement stmt = null; 
        int rs = 0;
        //int rs = 0;
        try {
            stmt = connection.createStatement(); 
            rs = stmt.executeUpdate(query); 
            stmt.close();
        }catch(SQLException e) {
            e.printStackTrace();
            System.exit(0);
        }
        return rs;
    }
}
