/*
 * Querys.java
 *
 * Created on 3 juin 2004, 21:18
 */

package simulations.database.core;

import java.util.ArrayList;
import java.util.Vector;
import java.util.Iterator;
import java.sql.ResultSet;
import java.sql.SQLException;

/**
 *
 * @author  tom
 */
public class Querys {
    
    private Communication com;
    
    /** Creates a new instance of Querys */
    public Querys() {
        com = new Communication();
    }
    
    public void close() {
        com.close();
    }
    
    public ArrayList getAllTests() {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM TEST");
            while(rs.next()) {
                l.add(new Test(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllTests()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllExps(int idT) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM EXP WHERE ID_TEST="+idT);
            while(rs.next()) {
                l.add(new Exp(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllExp()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllExps() {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM EXP");
            while(rs.next()) {
                l.add(new Exp(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllExp()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllAttackStrat() {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM ATTACK_STRAT");
            while(rs.next()) {
                l.add(new AttackStrat(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllAttackStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllAskingStrat() {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM ASKING_STRAT");
            while(rs.next()) {
                l.add(new AskingStrat(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllAskingStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllDecisionStrat() {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM DECISION_STRAT");
            while(rs.next()) {
                l.add(new DecisionStrat(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllDecisionStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllSeries(int idE) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM SERIE WHERE ID_EXP="+idE);
            while(rs.next()) {
                l.add(new Serie(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllSerie()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllGames(int idS) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM GAME WHERE ID_SERIE="+idS);
            while(rs.next()) {
                l.add(new Game(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllGame()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllGamesByStrat(ArrayList attackList, ArrayList askingList, ArrayList decisionList) {
        ArrayList l = getAllStrategies(attackList,askingList,decisionList);
        ArrayList playersList = getAllPlayers(l);
        ArrayList gameList = getAllGames(playersList);
        return gameList;
    }
    
    public ArrayList getAllGames(ArrayList playersList) {
        ArrayList l = new ArrayList();
        Iterator it = playersList.iterator();
        while (it.hasNext()) {
            Player p = (Player)it.next();
            Game g = getGame(p.getIdGame());
            if (!(l.contains(g))) {
                l.add(g);
            }
        }
        return l;
    }
    
    public ArrayList getAllPlayers(ArrayList stratList) {
        ArrayList l = new ArrayList();
        Iterator it = stratList.iterator();
        while (it.hasNext()) {
            Strategy strat = (Strategy)it.next();
            ArrayList l2 = getAllPlayersByStrat(strat.getIdStrategy());
            Iterator it2 = l2.iterator();
            while (it2.hasNext()) {
                l.add(it2.next());
            }
        }
        return l;
    }
    
    public ArrayList getAllPlayersByStrat(int idS) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM PLAYER WHERE ID_STRATEGY="+idS);
            while(rs.next()) {
                l.add(new Player(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllPlayersByStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllStrategies(ArrayList attackList, ArrayList askingList, ArrayList decisionList) {
        ArrayList ret = new ArrayList();
        ArrayList l = getAllStrategiesByAttack(attackList);
        Iterator it = l.iterator();
        while (it.hasNext()) {
            Strategy strat = (Strategy)it.next();
            ret.add(strat);
        }
        ArrayList l2 = getAllStrategiesByAsking(askingList);
        it = l2.iterator();
        while (it.hasNext()) {
            Strategy strat = (Strategy)it.next();
            if (!(ret.contains(strat))) {
                ret.add(strat);
            }
        }
        ArrayList l3 = getAllStrategiesByDecision(decisionList);
        it = l3.iterator();
        while (it.hasNext()) {
            Strategy strat = (Strategy)it.next();
            if (!(ret.contains(strat))) {
                ret.add(strat);
            }
        }
        return ret;
    }
    
    public ArrayList getAllStrategiesByAttack(ArrayList attackList) {
        ArrayList l = new ArrayList();
        Iterator it = attackList.iterator();
        while (it.hasNext()) {
            AttackStrat attStrat = (AttackStrat)it.next();
            ArrayList l2 = getAllCompoStratByAttack(attStrat.getIdAttackStrat());
            Iterator it2 = l2.iterator();
            while (it2.hasNext()) {
                CompoStrat comp = (CompoStrat)it2.next();
                if (!(l.contains(comp))) {
                    l.add(comp);
                }
            }
        }
        ArrayList stratList = new ArrayList();
        it = l.iterator();
        while (it.hasNext()) {
            CompoStrat comp = (CompoStrat)it.next();
            Strategy strat = getStrategy(comp.getIdStrategy());
            if (!(stratList.contains(strat))) {
                stratList.add(strat);
            }
        }
        return stratList;
    }
    
    public ArrayList getAllStrategiesByAsking(ArrayList askingList) {
        ArrayList l = new ArrayList();
        Iterator it = askingList.iterator();
        while (it.hasNext()) {
            AskingStrat askStrat = (AskingStrat)it.next();
            ArrayList l2 = getAllCompoStratByAsking(askStrat.getIdAskingStrat());
            Iterator it2 = l2.iterator();
            while (it2.hasNext()) {
                CompoStrat comp = (CompoStrat)it2.next();
                if (!(l.contains(comp))) {
                    l.add(comp);
                }
            }
        }
        ArrayList stratList = new ArrayList();
        it = l.iterator();
        while (it.hasNext()) {
            CompoStrat comp = (CompoStrat)it.next();
            Strategy strat = getStrategy(comp.getIdStrategy());
            if (!(stratList.contains(strat))) {
                stratList.add(strat);
            }
        }
        return stratList;
    }
    
    public ArrayList getAllStrategiesByDecision(ArrayList decisionList) {
        ArrayList l = new ArrayList();
        Iterator it = decisionList.iterator();
        while (it.hasNext()) {
            DecisionStrat decStrat = (DecisionStrat)it.next();
            ArrayList l2 = getAllCompoStratByDecision(decStrat.getIdDecisionStrat());
            Iterator it2 = l2.iterator();
            while (it2.hasNext()) {
                CompoStrat comp = (CompoStrat)it2.next();
                if (!(l.contains(comp))) {
                    l.add(comp);
                }
            }
        }
        ArrayList stratList = new ArrayList();
        it = l.iterator();
        while (it.hasNext()) {
            CompoStrat comp = (CompoStrat)it.next();
            Strategy strat = getStrategy(comp.getIdStrategy());
            if (!(stratList.contains(strat))) {
                stratList.add(strat);
            }
        }
        return stratList;
    }
    
    public ArrayList getAllCompoStratByAttack(int idAtt) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM COMPO_ATTACK_STRAT WHERE ID_ATTACK_STRAT="+idAtt);
            while(rs.next()) {
                l.add(new CompoAttackStrat(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllCompoStratByAttack()");
            e.printStackTrace();
            System.exit(0);
        }
        ArrayList l2 = new ArrayList();
        Iterator it = l.iterator();
        while (it.hasNext()) {
            CompoAttackStrat comp = (CompoAttackStrat)it.next();
            ArrayList l3 = getAllCompoStratByAttack2(comp.getIdCompoAttackStrat());
            Iterator it2 = l3.iterator();
            while (it2.hasNext()) {
                CompoStrat comp2 = (CompoStrat)it2.next();
                if (!(l2.contains(comp2))) {
                    l2.add(comp2);
                }
            }
        }
        return l2;
    }
    
    public ArrayList getAllCompoStratByAttack2(int idCompoAttStrat) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM COMPO_STRAT WHERE ID_COMPO_ATTACK_STRAT="+idCompoAttStrat);
            while(rs.next()) {
                l.add(new CompoStrat(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllCompoStratByAttack2()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllCompoStratByAsking2(int idCompoAskStrat) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM COMPO_STRAT WHERE ID_COMPO_ASKING_STRAT="+idCompoAskStrat);
            while(rs.next()) {
                l.add(new CompoStrat(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllCompoStratByAsking2()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllCompoStratByDecision2(int idCompoDecStrat) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM COMPO_STRAT WHERE ID_COMPO_DECISION_STRAT="+idCompoDecStrat);
            while(rs.next()) {
                l.add(new CompoStrat(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllCompoStratByDecision2()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllCompoStratByAsking(int idAsk) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM COMPO_ASKING_STRAT WHERE ID_ASKING_STRAT="+idAsk);
            while(rs.next()) {
                l.add(new CompoAskingStrat(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllCompoStratByAsking()");
            e.printStackTrace();
            System.exit(0);
        }
        ArrayList l2 = new ArrayList();
        Iterator it = l.iterator();
        while (it.hasNext()) {
            CompoAskingStrat comp = (CompoAskingStrat)it.next();
            ArrayList l3 = getAllCompoStratByAsking2(comp.getIdCompoAskingStrat());
            Iterator it2 = l3.iterator();
            while (it2.hasNext()) {
                CompoStrat comp2 = (CompoStrat)it2.next();
                if (!(l2.contains(comp2))) {
                    l2.add(comp2);
                }
            }
        }
        return l2;
    }
    
    public ArrayList getAllCompoStratByDecision(int idDec) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM COMPO_DECISION_STRAT WHERE ID_DECISION_STRAT="+idDec);
            while(rs.next()) {
                l.add(new CompoDecisionStrat(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllCompoStratByDecision()");
            e.printStackTrace();
            System.exit(0);
        }
        ArrayList l2 = new ArrayList();
        Iterator it = l.iterator();
        while (it.hasNext()) {
            CompoDecisionStrat comp = (CompoDecisionStrat)it.next();
            ArrayList l3 = getAllCompoStratByDecision2(comp.getIdCompoDecisionStrat());
            Iterator it2 = l3.iterator();
            while (it2.hasNext()) {
                CompoStrat comp2 = (CompoStrat)it2.next();
                if (!(l2.contains(comp2))) {
                    l2.add(comp2);
                }
            }
        }
        return l2;
    }
    
    public ArrayList getAllGamesByTurn(int nb) {
        ArrayList l = getAllPlayersRankingByTurn(nb);
        ArrayList idList = new ArrayList();
        Iterator it = l.iterator();
        while (it.hasNext()) {
            PlayersRanking plr = (PlayersRanking)it.next();
            Integer integer = new Integer(plr.getIdGame());
            if (!(idList.contains(integer))) {
                idList.add(integer);
            }
        }
        ArrayList l2 = new ArrayList();
        it = idList.iterator();
        while (it.hasNext()) {
            Integer id = (Integer)it.next();
            l2.add(getGame(id.intValue()));
        }
        return l2;
    }
    
    public ArrayList getAllGamesSerie(int idS, String name) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM GAME WHERE (ID_SERIE="+idS+" AND NAME LIKE'"+name+"')");
            while(rs.next()) {
                l.add(new Game(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllGameSerie()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllGames(String name) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM GAME WHERE NAME LIKE'"+name+"'");
            while(rs.next()) {
                l.add(new Game(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllGames()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllDistinctGames() {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT DISTINCT ID_GAME, ID_SERIE, NAME FROM GAME ORDER BY NAME");
            while(rs.next()) {
                l.add(new Game(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllDistinctGames()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllGames(int idT, String name) {
        ArrayList l3 = new ArrayList();
        ArrayList l = getAllExps(idT);
        Iterator it = l.iterator();
        while (it.hasNext()) {
            Exp exp = (Exp)it.next();
            ArrayList l2 = getAllSeries(exp.getIdExp());
            Iterator it2 = l2.iterator();
            while (it2.hasNext()) {
                Serie serie = (Serie)it2.next();
                l3 = getAllGamesSerie(serie.getIdSerie(),name);
            }
        }
        return l3;
    }
    
    public ArrayList getAllPlayers(int idG) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM PLAYER WHERE ID_GAME="+idG);
            while(rs.next()) {
                l.add(new Player(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllTPlayers()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllPlayersInCoal(int idCoal) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM COALITION WHERE ID_COALITION="+idCoal);
            while(rs.next()) {
                l.add(new Coalition(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getCoalition()");
            e.printStackTrace();
            System.exit(0);
        }
        ArrayList l2 = new ArrayList();
        Iterator it = l.iterator();
        while (it.hasNext()) {
            Coalition coal = (Coalition)it.next();
            l2.add(getPlayer(coal.getIdPlayer()));
        }
        return l2;
    }
    
    public ArrayList getAllPlayersRanking(int idG) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM PLAYERS_RANKING WHERE ID_GAME="+idG+" ORDER BY RANK");
            while(rs.next()) {
                l.add(new PlayersRanking(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllPlayersRanking()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllPlayersRankingByTurn(int nb) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM PLAYERS_RANKING WHERE LAST_TURN>="+nb);
            while(rs.next()) {
                l.add(new PlayersRanking(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllPlayersRanking()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public ArrayList getAllCoalitionsRanking(int idG) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM COALITIONS_RANKING WHERE ID_GAME="+idG+" ORDER BY RANK");
            while(rs.next()) {
                l.add(new CoalitionsRanking(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllCoalitionsRanking()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public CompoStrat getCompoStrat(int idS) {
        ResultSet rs  = com.execQuery("SELECT * FROM COMPO_STRAT WHERE ID_STRATEGY="+idS);
        if (rs==null) {
            return null;
        }
        CompoStrat compo = null;
        try {
            rs.next();
            compo = new CompoStrat(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getCompoStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        return compo;
    }
    
    public ArrayList getAllAttackStrat(int idAttS) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM COMPO_ATTACK_STRAT WHERE ID_COMPO_ATTACK_STRAT="+idAttS+" ORDER BY RANK");
            while(rs.next()) {
                l.add(new CompoAttackStrat(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllAttackStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        ArrayList l2 = new ArrayList();
        Iterator it = l.iterator();
        while (it.hasNext()) {
            CompoAttackStrat comp = (CompoAttackStrat)it.next();
            AttackStrat strat = getAttackStrat(comp.getIdAttackStrat());
            l2.add(strat);
        }
        return l2;
    }
    
    public CompoAttackStrat getAttackStratRank(ArrayList l, int rank) {
        Iterator it = l.iterator();
        while (it.hasNext()) {
            CompoAttackStrat strat = (CompoAttackStrat)it.next();
            if (strat.getRank()==rank) {
                return strat;
            }
        }
        return null;
    }
    
    public CompoAskingStrat getAskingStratRank(ArrayList l, int rank) {
        Iterator it = l.iterator();
        while (it.hasNext()) {
            CompoAskingStrat strat = (CompoAskingStrat)it.next();
            if (strat.getRank()==rank) {
                return strat;
            }
        }
        return null;
    }
    
    public CompoDecisionStrat getDecisionStratRank(ArrayList l, int rank) {
        Iterator it = l.iterator();
        while (it.hasNext()) {
            CompoDecisionStrat strat = (CompoDecisionStrat)it.next();
            if (strat.getRank()==rank) {
                return strat;
            }
        }
        return null;
    }
    
    public ArrayList getAllAskingStrat(int idAttS) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM COMPO_ASKING_STRAT WHERE ID_COMPO_ASKING_STRAT="+idAttS+" ORDER BY RANK");
            while(rs.next()) {
                l.add(new CompoAskingStrat(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllAskingStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        ArrayList l2 = new ArrayList();
        Iterator it = l.iterator();
        while (it.hasNext()) {
            CompoAskingStrat comp = (CompoAskingStrat)it.next();
            AskingStrat strat = getAskingStrat(comp.getIdAskingStrat());
            l2.add(strat);
        }
        return l2;
    }
    
    public ArrayList getAllDecisionStrat(int idDecS) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM COMPO_DECISION_STRAT WHERE ID_COMPO_DECISION_STRAT="+idDecS+" ORDER BY RANK");
            while(rs.next()) {
                l.add(new CompoDecisionStrat(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAllDecisionStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        ArrayList l2 = new ArrayList();
        Iterator it = l.iterator();
        while (it.hasNext()) {
            CompoDecisionStrat comp = (CompoDecisionStrat)it.next();
            DecisionStrat strat = getDecisionStrat(comp.getIdDecisionStrat());
            l2.add(strat);
        }
        return l2;
    }
    
    public ArrayList getStrategy(String name) {
        ArrayList l = new ArrayList();
        try {
            ResultSet rs = com.execQuery("SELECT * FROM STRATEGY WHERE NAME LIKE '"+name+"'");
            while(rs.next()) {
                l.add(new Strategy(rs));
            }
            rs.close();
        }catch(SQLException e) {
            System.out.println("getStrategy()");
            e.printStackTrace();
            System.exit(0);
        }
        return l;
    }
    
    public Strategy getStrategy(simulations.core.strategy.completeStrategy.CompleteStrategy strategy) {
        ArrayList l = getStrategy(strategy.getName());
        if (l.size()==0) {
            return null;
        }
        Vector attackVector = strategy.getAttackStrategyVector();
        Vector askingVector = strategy.getAskingStrategyVector();
        Vector decisionVector = strategy.getDecisionStrategyVector();
        Iterator it = l.iterator();
        while (it.hasNext()) {
            Strategy strat = (Strategy)it.next();
            CompoStrat compo = getCompoStrat(strat.getIdStrategy());
            ArrayList attackList = getAllAttackStrat(compo.getIdCompoAttackStrat());
            ArrayList askingList = getAllAskingStrat(compo.getIdCompoAskingStrat());
            ArrayList decisionList = getAllDecisionStrat(compo.getIdCompoDecisionStrat());
            if (attackList.size()!=attackVector.size()) {
                continue;
            }
            if (askingList.size()!=askingVector.size()) {
                continue;
            }
            if (decisionList.size()!=decisionVector.size()) {
                continue;
            }
            if (!(isAttackListEquals(attackVector, attackList))) {
                continue;
            }
            if (!(isAskingListEquals(askingVector, askingList))) {
                continue;
            }
            if (!(isDecisionListEquals(decisionVector, decisionList))) {
                continue;
            }
            return strat;
        }
        return null;
    }
    
    public boolean isAttackListEquals(Vector attackVector, ArrayList attackList) {
        for(int i=0;i<attackList.size();i++) {
            AttackStrat strat = (AttackStrat)attackList.get(i);
            if (!(isAttackEquals(strat,(simulations.core.strategy.attackStrategy.AttackStrategy)attackVector.get(i)))) {
                return false;
            }
        }
        return true;
    }
    
    public boolean isAttackEquals(AttackStrat strat1, simulations.core.strategy.attackStrategy.AttackStrategy strat2) {
        if (!(strat1.getName().equals(strat2.getName()))) {
            return false;
        }
        if (strat1.getMemory()!=strat2.getMemory()) {
            return false;
        }
        if (strat1.isNegative()!=strat2.isNegative()) {
            return false;
        }
        //System.out.println(strat1.getName()+" : "+strat1.getMemory()+" : "+strat1.isNegative());
        //System.out.println(strat2.getName()+" : "+strat2.getMemory()+" : "+strat2.isNegative());
        //System.out.println("EQUALS");
        return true;
    }
    
    public boolean isAskingEquals(AskingStrat strat1, simulations.core.strategy.askingSupportStrategy.AskingStrategy strat2) {
        if (!(strat1.getName().equals(strat2.getName()))) {
            return false;
        }
        if (strat1.getMemory()!=strat2.getMemory()) {
            return false;
        }
        if (strat1.isNegative()!=strat2.isNegative()) {
            return false;
        }
        //System.out.println(strat1.getName()+" : "+strat1.getMemory()+" : "+strat1.isNegative());
        //System.out.println(strat2.getName()+" : "+strat2.getMemory()+" : "+strat2.isNegative());
        //System.out.println("EQUALS");
        return true;
    }
    
    public boolean isDecisionEquals(DecisionStrat strat1, simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy strat2) {
        if (!(strat1.getName().equals(strat2.getName()))) {
            return false;
        }
        if (strat1.getMemory()!=strat2.getMemory()) {
            return false;
        }
        if (strat1.isNegative()!=strat2.isNegative()) {
            return false;
        }
        //System.out.println(strat1.getName()+" : "+strat1.getMemory()+" : "+strat1.isNegative());
        //System.out.println(strat2.getName()+" : "+strat2.getMemory()+" : "+strat2.isNegative());
        //System.out.println("EQUALS");
        return true;
    }
    
    public boolean isAskingListEquals(Vector askingVector, ArrayList askingList) {
        for(int i=0;i<askingList.size();i++) {
            AskingStrat strat = (AskingStrat)askingList.get(i);
            if (!(isAskingEquals(strat,(simulations.core.strategy.askingSupportStrategy.AskingStrategy)askingVector.get(i)))) {
                return false;
            }
        }
        return true;
    }
    
    public boolean isDecisionListEquals(Vector decisionVector, ArrayList decisionList) {
        for(int i=0;i<decisionList.size();i++) {
            DecisionStrat strat = (DecisionStrat)decisionList.get(i);
            if (!(isDecisionEquals(strat,(simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy)decisionVector.get(i)))) {
                return false;
            }
        }
        return true;
    }
    
    public Strategy getStrategy(int idS) {
        ResultSet rs  = com.execQuery("SELECT * FROM STRATEGY WHERE ID_STRATEGY="+idS);
        if (rs==null) {
            return null;
        }
        Strategy strat = null;
        try {
            rs.next();
            strat = new Strategy(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getStrategy()");
            e.printStackTrace();
            System.exit(0);
        }
        return strat;
    }
    
    public String getStrategyDescription(int idS) {
        CompoStrat compo = getCompoStrat(idS);
        ArrayList attackList = getAllAttackStrat(compo.getIdCompoAttackStrat());
        ArrayList askingList = getAllAskingStrat(compo.getIdCompoAskingStrat());
        ArrayList decisionList = getAllDecisionStrat(compo.getIdCompoDecisionStrat());
        String s = getStrategy(idS).getName()+"\n";
        s = s+"Attack : \n";
        Iterator it = attackList.iterator();
        int cpt = 1;
        while (it.hasNext()) {
            AttackStrat strat = (AttackStrat)it.next();
            s = s+(cpt+" : "+strat.getName()+" ("+strat.getMemory()+") neg = "+strat.isNegative()+"\n");
            cpt++;
        }
        it = askingList.iterator();
        s = s+"Asking : \n";
        cpt = 1;
        while (it.hasNext()) {
            AskingStrat strat = (AskingStrat)it.next();
            s = s+(cpt+" : "+strat.getName()+" ("+strat.getMemory()+") neg = "+strat.isNegative()+"\n");
            cpt++;
        }
        it = decisionList.iterator();
        s = s+"Decision : \n";
        cpt = 1;
        while (it.hasNext()) {
            DecisionStrat strat = (DecisionStrat)it.next();
            s = s+(cpt+" : "+strat.getName()+" ("+strat.getMemory()+") neg = "+strat.isNegative()+"\n");
            cpt++;
        }
        return s;
    }
    
    public AttackStrat getAttackStrat(simulations.core.strategy.attackStrategy.AttackStrategy strat) {
        ArrayList l = getAllAttackStrat();
        Iterator it = l.iterator();
        while (it.hasNext()) {
            AttackStrat strat2 = (AttackStrat)it.next();
            if (isAttackEquals(strat2,strat)) {
                return strat2;
            }
        }
        return null;
    }
    
    public AskingStrat getAskingStrat(simulations.core.strategy.askingSupportStrategy.AskingStrategy strat) {
        ArrayList l = getAllAskingStrat();
        Iterator it = l.iterator();
        while (it.hasNext()) {
            AskingStrat strat2 = (AskingStrat)it.next();
            if (isAskingEquals(strat2,strat)) {
                return strat2;
            }
        }
        return null;
    }
    
    public DecisionStrat getDecisionStrat(simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy strat) {
        ArrayList l = getAllDecisionStrat();
        Iterator it = l.iterator();
        while (it.hasNext()) {
            DecisionStrat strat2 = (DecisionStrat)it.next();
            if (isDecisionEquals(strat2,strat)) {
                return strat2;
            }
        }
        return null;
    }
    
    
    
    public AttackStrat getAttackStrat(int idAttS) {
        ResultSet rs  = com.execQuery("SELECT * FROM ATTACK_STRAT WHERE ID_ATTACK_STRAT="+idAttS);
        if (rs==null) {
            return null;
        }
        AttackStrat strat = null;
        try {
            rs.next();
            strat = new AttackStrat(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAttackStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        return strat;
    }
    
    public AskingStrat getAskingStrat(int idAskS) {
        ResultSet rs  = com.execQuery("SELECT * FROM ASKING_STRAT WHERE ID_ASKING_STRAT="+idAskS);
        if (rs==null) {
            return null;
        }
        AskingStrat strat = null;
        try {
            rs.next();
            strat = new AskingStrat(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getAskingStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        return strat;
    }
    
    public DecisionStrat getDecisionStrat(int idDecS) {
        ResultSet rs  = com.execQuery("SELECT * FROM DECISION_STRAT WHERE ID_DECISION_STRAT="+idDecS);
        if (rs==null) {
            return null;
        }
        DecisionStrat strat = null;
        try {
            rs.next();
            strat = new DecisionStrat(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getDecisionStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        return strat;
    }
    
    public Test getTest(int idTest, String name) {
        ResultSet rs  = com.execQuery("SELECT * FROM TEST WHERE (ID_TEST="+idTest+" AND NAME LIKE '"+name+"')");
        if (rs==null) {
            return null;
        }
        Test t = null;
        try {
            rs.next();
            t = new Test(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getTest()");
            e.printStackTrace();
            System.exit(0);
        }
        return t;
    }
    
    public Test getTest(int idTest) {
        ResultSet rs  = com.execQuery("SELECT * FROM TEST WHERE ID_TEST="+idTest);
        if (rs==null) {
            return null;
        }
        Test t = null;
        try {
            rs.next();
            t = new Test(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getTest()");
            e.printStackTrace();
            System.exit(0);
        }
        return t;
    }
    
    public Exp getExp(int idTest, String name, int seed) {
        ResultSet rs = com.execQuery("SELECT * FROM EXP WHERE (ID_TEST="+idTest+" AND NAME LIKE '"+name+"' AND SEED="+seed+")");
        if (rs==null) {
            return null;
        }
        Exp exp = null;
        try {
            rs.next();
            exp = new Exp(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getExp()");
            e.printStackTrace();
            System.exit(0);
        }
        return exp;
    }
    
    public Exp getExp(int idExp) {
        ResultSet rs = com.execQuery("SELECT * FROM EXP WHERE ID_EXP="+idExp);
        if (rs==null) {
            return null;
        }
        Exp exp = null;
        try {
            rs.next();
            exp = new Exp(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getExp()");
            e.printStackTrace();
            System.exit(0);
        }
        return exp;
    }
    
    public Serie getSerie(int idExp, String name) {
        ResultSet rs = com.execQuery("SELECT * FROM SERIE WHERE (ID_EXP="+idExp+" AND NAME LIKE '"+name+"')");
        if (rs==null) {
            return null;
        }
        Serie serie = null;
        try {
            rs.next();
            serie = new Serie(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getSerie()");
            e.printStackTrace();
            System.exit(0);
        }
        return serie;
    }
    
    public Serie getSerie(int idS) {
        ResultSet rs = com.execQuery("SELECT * FROM SERIE WHERE ID_SERIE="+idS);
        if (rs==null) {
            return null;
        }
        Serie serie = null;
        try {
            rs.next();
            serie = new Serie(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getSerie()");
            e.printStackTrace();
            System.exit(0);
        }
        return serie;
    }
    
    public Game getGame(int idSerie, String name) {
        ResultSet rs = com.execQuery("SELECT * FROM GAME WHERE (ID_SERIE="+idSerie+" AND NAME LIKE '"+name+"')");
        if (rs==null) {
            return null;
        }
        Game game = null;
        try {
            rs.next();
            game = new Game(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getGame()");
            e.printStackTrace();
            System.exit(0);
        }
        return game;
    }
    
    public Game getGame(int idG) {
        ResultSet rs = com.execQuery("SELECT * FROM GAME WHERE ID_GAME="+idG);
        if (rs==null) {
            return null;
        }
        Game game = null;
        try {
            rs.next();
            game = new Game(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getGame()");
            e.printStackTrace();
            System.exit(0);
        }
        return game;
    }
    
    public Strategy getLastStrategy(String name) {
        ResultSet rs = com.execQuery("SELECT MAX(ID_STRATEGY) AS ID_STRATEGY, NAME FROM STRATEGY WHERE NAME LIKE '"+name+"' GROUP BY NAME");
        if (rs==null) {
            return null;
        }
        Strategy strat = null;
        try {
            rs.next();
            strat = new Strategy(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getLastStrategy()");
            e.printStackTrace();
            System.exit(0);
        }
        return strat;
    }
    
    public AttackStrat getLastAttackStrat(String name, int mem, boolean neg) {
        int negative=0;
        if (neg) {
            negative=1;
        }
        ResultSet rs = com.execQuery("SELECT MAX(ID_ATTACK_STRAT) AS ID_ATTACK_STRAT, NAME, MEMORY, NEGATIVE FROM ATTACK_STRAT "+
        "WHERE (NAME LIKE '"+name+"' AND MEMORY="+mem+" AND NEGATIVE="+negative+") GROUP BY NAME");
        if (rs==null) {
            return null;
        }
        AttackStrat strat = null;
        try {
            rs.next();
            strat = new AttackStrat(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getLastAttackStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        return strat;
    }
    
    public AskingStrat getLastAskingStrat(String name, int mem, boolean neg) {
        int negative=0;
        if (neg) {
            negative=1;
        }
        ResultSet rs = com.execQuery("SELECT MAX(ID_ASKING_STRAT) AS ID_ASKING_STRAT, NAME, MEMORY, NEGATIVE FROM ASKING_STRAT "+
        "WHERE (NAME LIKE '"+name+"' AND MEMORY="+mem+" AND NEGATIVE="+negative+") GROUP BY NAME");
        if (rs==null) {
            return null;
        }
        AskingStrat strat = null;
        try {
            rs.next();
            strat = new AskingStrat(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getLastAskingStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        return strat;
    }
    
    public DecisionStrat getLastDecisionStrat(String name, int mem, boolean neg) {
        int negative=0;
        if (neg) {
            negative=1;
        }
        ResultSet rs = com.execQuery("SELECT MAX(ID_DECISION_STRAT) AS ID_DECISION_STRAT, NAME, MEMORY, NEGATIVE FROM DECISION_STRAT "+
        "WHERE (NAME LIKE '"+name+"' AND MEMORY="+mem+" AND NEGATIVE="+negative+") GROUP BY NAME");
        if (rs==null) {
            return null;
        }
        DecisionStrat strat = null;
        try {
            rs.next();
            strat = new DecisionStrat(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getLastDecisionStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        return strat;
    }
    
    public CompoAttackStrat getLastCompoAttackStrat(int idAtt, int rank) {
        ResultSet rs = com.execQuery("SELECT MAX(ID_COMPO_ATTACK_STRAT) AS ID_COMPO_ATTACK_STRAT, ID_ATTACK_STRAT, RANK "+
        "FROM COMPO_ATTACK_STRAT WHERE (ID_ATTACK_STRAT="+idAtt+" AND RANK="+rank+") GROUP BY ID_ATTACK_STRAT");
        if (rs==null) {
            return null;
        }
        CompoAttackStrat strat = null;
        try {
            rs.next();
            strat = new CompoAttackStrat(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getLastCompoAttackStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        return strat;
    }
    
    public CompoAskingStrat getLastCompoAskingStrat(int idAsk, int rank) {
        ResultSet rs = com.execQuery("SELECT MAX(ID_COMPO_ASKING_STRAT) AS ID_COMPO_ASKING_STRAT, ID_ASKING_STRAT, RANK "+
        "FROM COMPO_ASKING_STRAT WHERE (ID_ASKING_STRAT="+idAsk+" AND RANK="+rank+") GROUP BY ID_ASKING_STRAT");
        if (rs==null) {
            return null;
        }
        CompoAskingStrat strat = null;
        try {
            rs.next();
            strat = new CompoAskingStrat(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getLastCompoAskingStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        return strat;
    }
    
    public CompoDecisionStrat getLastCompoDecisionStrat(int idDec, int rank) {
        ResultSet rs = com.execQuery("SELECT MAX(ID_COMPO_DECISION_STRAT) AS ID_COMPO_DECISION_STRAT, ID_DECISION_STRAT, RANK "+
        "FROM COMPO_DECISION_STRAT WHERE (ID_DECISION_STRAT="+idDec+" AND RANK="+rank+") GROUP BY ID_DECISION_STRAT");
        if (rs==null) {
            return null;
        }
        CompoDecisionStrat strat = null;
        try {
            rs.next();
            strat = new CompoDecisionStrat(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getLastCompoDecisionStrat()");
            e.printStackTrace();
            System.exit(0);
        }
        return strat;
    }
    
    public Player getLastPlayer(int idG, int idS, String name) {
        ResultSet rs = com.execQuery("SELECT MAX(ID_PLAYER) AS ID_PLAYER, ID_GAME, ID_STRATEGY, NAME "+
        "FROM PLAYER WHERE (ID_GAME="+idG+" AND ID_STRATEGY="+idS+" AND NAME LIKE '"+name+"') GROUP BY NAME");
        if (rs==null) {
            return null;
        }
        Player pl = null;
        try {
            rs.next();
            pl = new Player(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getLastPlayer()");
            e.printStackTrace();
            System.exit(0);
        }
        return pl;
    }
    
    public int getNbTimesInCoalitions(int idP) {
        ResultSet rs = com.execQuery("SELECT count(*) AS NB FROM COALITION WHERE ID_PLAYER="+idP);
        if (rs==null) {
            return 0;
        }
        int ret = 0;
        try {
            rs.next();
            ret = rs.getInt(1);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getLastPlayer()");
            e.printStackTrace();
            System.exit(0);
        }
        return ret;
    }
    
    public Coalition getLastCoalition(int idP) {
        ResultSet rs = com.execQuery("SELECT MAX(ID_COALITION) AS ID_COALITION, ID_PLAYER FROM COALITION "+
        "WHERE ID_PLAYER="+idP+" GROUP BY ID_PLAYER");
        if (rs==null) {
            return null;
        }
        Coalition coal = null;
        try {
            rs.next();
            coal = new Coalition(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getLastCoalition()");
            e.printStackTrace();
            System.exit(0);
        }
        return coal;
    }
    
    public Player getPlayer(int idG, String name) {
        ResultSet rs = com.execQuery("SELECT * "+
        "FROM PLAYER WHERE (ID_GAME="+idG+" AND NAME LIKE '"+name+"')");
        if (rs==null) {
            return null;
        }
        Player pl = null;
        try {
            rs.next();
            pl = new Player(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getPlayer()");
            e.printStackTrace();
            System.exit(0);
        }
        return pl;
    }
    
    public Player getPlayer(int idP) {
        ResultSet rs = com.execQuery("SELECT * "+
        "FROM PLAYER WHERE ID_PLAYER="+idP);
        if (rs==null) {
            return null;
        }
        Player pl = null;
        try {
            rs.next();
            pl = new Player(rs);
            rs.close();
        }catch(SQLException e) {
            System.out.println("getPlayer()");
            e.printStackTrace();
            System.exit(0);
        }
        return pl;
    }
    
    public int insertExp(int idTest, String name, int seed) {
        int ret = com.execUpdate("INSERT INTO EXP (ID_TEST,NAME,SEED) VALUES("+
        idTest+",'"+name+"',"+seed+")");
        return ret;
    }
    
    public int insertTest(String name) {
        int ret = com.execUpdate("INSERT INTO TEST (NAME) VALUES('"+name+"')");
        return ret;
    }
    
    public int insertSerie(int idExp, String name) {
        int ret = com.execUpdate("INSERT INTO SERIE (ID_EXP,NAME) VALUES("+
        idExp+",'"+name+"')");
        return ret;
    }
    
    public int insertGame(int idS, String name) {
        int ret = com.execUpdate("INSERT INTO GAME (ID_SERIE,NAME) VALUES("+
        idS+",'"+name+"')");
        return ret;
    }
    
    public int insertStrategy(String name) {
        int ret = com.execUpdate("INSERT INTO STRATEGY (NAME) VALUES('"+name+"')");
        return ret;
    }
    
    public int insertCoalition(int idP) {
        int ret = com.execUpdate("INSERT INTO COALITION (ID_PLAYER) VALUES("+idP+")");
        return ret;
    }
    
    public int insertCoalition(int idC, int idP) {
        int ret = com.execUpdate("INSERT INTO COALITION (ID_COALITION,ID_PLAYER) VALUES("+idC+","+idP+")");
        return ret;
    }
    
    public int insertPlayer(int idG, int idS, String name) {
        int ret = com.execUpdate("INSERT INTO PLAYER (ID_GAME,ID_STRATEGY,NAME) VALUES("+idG+","+idS+",'"+name+"')");
        return ret;
    }
    
    public int insertAttackStrat(String name,int mem,boolean neg) {
        int negative = 0;
        if (neg) {
            negative=1;
        }
        int ret = com.execUpdate("INSERT INTO ATTACK_STRAT (NAME,MEMORY,NEGATIVE) VALUES "+
        "('"+name+"',"+mem+","+negative+")");
        return ret;
    }
    
    public int insertAskingStrat(String name,int mem,boolean neg) {
        int negative = 0;
        if (neg) {
            negative=1;
        }
        int ret = com.execUpdate("INSERT INTO ASKING_STRAT (NAME,MEMORY,NEGATIVE) VALUES "+
        "('"+name+"',"+mem+","+negative+")");
        return ret;
    }
    
    public int insertDecisionStrat(String name,int mem,boolean neg) {
        int negative = 0;
        if (neg) {
            negative=1;
        }
        int ret = com.execUpdate("INSERT INTO DECISION_STRAT (NAME,MEMORY,NEGATIVE) VALUES "+
        "('"+name+"',"+mem+","+negative+")");
        return ret;
    }
    
    public int insertCompoAttackStrat(int idCompoAtt, int idAttStrat, int rank) {
        int ret = com.execUpdate("INSERT INTO COMPO_ATTACK_STRAT (ID_COMPO_ATTACK_STRAT,ID_ATTACK_STRAT,RANK) VALUES "+
        "("+idCompoAtt+","+idAttStrat+","+rank+")");
        return ret;
    }
    
    public int insertCompoAskingStrat(int idCompoAsk, int idAskStrat, int rank) {
        int ret = com.execUpdate("INSERT INTO COMPO_ASKING_STRAT (ID_COMPO_ASKING_STRAT,ID_ASKING_STRAT,RANK) VALUES "+
        "("+idCompoAsk+","+idAskStrat+","+rank+")");
        return ret;
    }
    
    public int insertCompoDecisionStrat(int idCompoDec, int idDecStrat, int rank) {
        int ret = com.execUpdate("INSERT INTO COMPO_DECISION_STRAT (ID_COMPO_DECISION_STRAT,ID_DECISION_STRAT,RANK) VALUES "+
        "("+idCompoDec+","+idDecStrat+","+rank+")");
        return ret;
    }
    
    public int insertCompoAttackStrat(int idAttStrat, int rank) {
        int ret = com.execUpdate("INSERT INTO COMPO_ATTACK_STRAT (ID_ATTACK_STRAT,RANK) VALUES "+
        "("+idAttStrat+","+rank+")");
        return ret;
    }
    
    public int insertCompoAskingStrat(int idAskStrat, int rank) {
        int ret = com.execUpdate("INSERT INTO COMPO_ASKING_STRAT (ID_ASKING_STRAT,RANK) VALUES "+
        "("+idAskStrat+","+rank+")");
        return ret;
    }
    
    public int insertCompoDecisionStrat(int idDecStrat, int rank) {
        int ret = com.execUpdate("INSERT INTO COMPO_DECISION_STRAT (ID_DECISION_STRAT,RANK) VALUES "+
        "("+idDecStrat+","+rank+")");
        return ret;
    }
    
    public int insertCompoStrat(int idStrat, int idAttStrat, int idAskStrat, int idDecStrat) {
        int ret = com.execUpdate("INSERT INTO COMPO_STRAT (ID_STRATEGY,ID_COMPO_ATTACK_STRAT,ID_COMPO_ASKING_STRAT,"+
        "ID_COMPO_DECISION_STRAT) VALUES ("+idStrat+","+idAttStrat+","+idAskStrat+","+idDecStrat+")");
        return ret;
    }
    
    public int insertPlayersRanking(int idG, int idP, int rank, int lastTurn) {
        int ret = com.execUpdate("INSERT INTO PLAYERS_RANKING (ID_GAME,ID_PLAYER,RANK,LAST_TURN) VALUES("+
        idG+","+idP+","+rank+","+lastTurn+")");
        return ret;
    }
    
    public int insertCoalitionsRanking(int idC, int idG, int rank, int nbOcc, int nbSeq, int lg) {
        int ret = com.execUpdate("INSERT INTO COALITIONS_RANKING (ID_COALITION,ID_GAME,RANK,NB_OCC,NB_SEQ_OCC,LG_MAX) VALUES("+
        idC+","+idG+","+rank+","+nbOcc+","+nbSeq+","+lg+")");
        return ret;
    }
}
