/*
 * NewDataExpDialog.java
 *
 * Created on 3 juin 2004, 01:26
 */

package simulations.database.gui;

import simulations.database.core.Communication;
import simulations.database.core.Test;
import simulations.database.core.Exp;
import simulations.database.core.Serie;
import simulations.database.core.Game;
import simulations.database.core.Querys;
import simulations.database.core.Player;
import simulations.database.core.Coalition;
import simulations.database.core.AskingStrat;
import simulations.database.core.AttackStrat;
import simulations.database.core.DecisionStrat;


import java.util.Iterator;
import java.util.ArrayList;
import java.util.Vector;

import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import java.sql.ResultSet;
import java.sql.SQLException;

import javax.swing.JFileChooser;

/**
 *
 * @author  tom
 */
public class NewDataExpDialog extends javax.swing.JDialog {
    
    private Communication com;
    
    private Test test;
    
    private Exp exp;
    
    private Serie serie;
    
    private Game game;
    
    private Querys querys;
    
    /** Creates new form NewDataExpDialog */
    public NewDataExpDialog(java.awt.Frame parent, boolean modal, Querys querys) {
        super(parent, modal);
        this.com=com;
        initComponents();
        this.querys = querys;
        ArrayList l = querys.getAllTests();
        Iterator it = l.iterator();
        while (it.hasNext()) {
            testComboBox.addItem(it.next());
        }
        if (l.size()==0) {
            insertButton.setEnabled(false);
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        folderTextField = new javax.swing.JTextField();
        folderButton = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        testComboBox = new javax.swing.JComboBox();
        insertButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        closeButton = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Insert Data from Exp");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel4.setLayout(new java.awt.GridBagLayout());

        jLabel2.setText("Source folder : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(jLabel2, gridBagConstraints);

        folderTextField.setColumns(20);
        folderTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(folderTextField, gridBagConstraints);

        folderButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        folderButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        folderButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                folderButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(folderButton, gridBagConstraints);

        jLabel3.setText("Test : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(jLabel3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(testComboBox, gridBagConstraints);

        insertButton.setText("Insert");
        insertButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                insertButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        jPanel4.add(insertButton, gridBagConstraints);

        jPanel1.add(jPanel4, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel2.add(closeButton);

        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents
    
    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed
    
    private void folderButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_folderButtonActionPerformed
        // Add your handling code here:
        JFileChooser chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            folderTextField.setText(chooser.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_folderButtonActionPerformed
    
    private void insertButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_insertButtonActionPerformed
        // Add your handling code here:
        if (folderTextField.getText().equals("")) {
            return;
        }
        File rootFolder = new File(folderTextField.getText());
        File[] list = rootFolder.listFiles();
        ArrayList expList = new ArrayList();
        for(int i=0;i<list.length;i++) {
            File f = list[i];
            if (f.isDirectory()) {
                if (f.getName().indexOf("experimentation")<0) {
                    continue;
                }
                expList.add(f);
            }
        }
        test = (Test)testComboBox.getSelectedItem();
        Iterator it = expList.iterator();
        //System.out.println("Exp files size = "+expList.size());
        while (it.hasNext()) {
            File expFile = (File)it.next();
            insertExp(expFile);
        }
    }//GEN-LAST:event_insertButtonActionPerformed
    
    private void insertExp(File expFile) {
        String s = "";
        try {
            File f = new File(expFile.getPath()+"/description.txt");
            FileReader reader = new FileReader(f);
            s = nextLine(reader);
            s = nextLine(reader);
        }catch(IOException e) {
            e.printStackTrace();
        }
        String[] str = s.split(" ");
        String strSeed = str[2];
        strSeed = strSeed.substring(0,strSeed.length()-1);
        int seed = new Integer(strSeed).intValue();
        querys.insertExp(test.getIdTest(), expFile.getName(), seed);
        exp = querys.getExp(test.getIdTest(), expFile.getName(), seed);
        //System.out.println("recup exp = "+exp.getIdExp()+" | "+exp.getIdTest()+" | "+exp.getName()+" | "+exp.getSeed());
        //exp = querys.getExp(com,test.getIdTest(),expFile.getName());
        File[] list = expFile.listFiles();
        ArrayList serieList = new ArrayList();
        for(int i=0;i<list.length;i++) {
            File f2 = list[i];
            if (f2.isDirectory()) {
                if (f2.getName().indexOf("serie")<0) {
                    continue;
                }
                serieList.add(f2);
            }
        }
        Iterator it = serieList.iterator();
        //System.out.println("Serie files size = "+serieList.size());
        while (it.hasNext()) {
            File serieFile = (File)it.next();
            insertSerie(serieFile);
        }
    }
    
    private void insertSerie(File serieFile) {
        querys.insertSerie(exp.getIdExp(),serieFile.getName());
        serie = querys.getSerie(exp.getIdExp(),serieFile.getName());
        //System.out.println("recup serie = "+serie.getIdSerie()+" | "+serie.getIdExp()+" | "+serie.getName());
        File xmlGamesFolder = new File(serieFile.getPath()+"/xmlGameFiles");
        File historyFolder = new File(serieFile.getPath()+"/history");
        insertGames(xmlGamesFolder,historyFolder);
    }
    
    private void insertGames(File xmlGamesFolder, File historyFolder) {
        File[] xmlList = xmlGamesFolder.listFiles();
        //System.out.println("XML files size = "+xmlList.length);
        for(int i=0;i<xmlList.length;i++) {
            File xmlFile = (File)xmlList[i];
            //System.out.println("xml file game : "+xmlFile.getName());
            String[] str = xmlFile.getName().split(".xml");
            String name = str[0];
            String num = name.substring(4,name.length());
            //System.out.println("num = "+num);
            File[] historyList = historyFolder.listFiles();
            File historyFile = null;
            File summaryFile = null;
            File rankingFile = null;
            File coalitionFile = null;
            int cpt=0;
            // searching files
            while ((historyFile==null)||(summaryFile==null)||(rankingFile==null)||(coalitionFile==null)) {
                File f = historyList[cpt];
                name = f.getName();
                //System.out.println("name = "+name);
                String[] tab = name.split(num);
                if (tab.length<=1) {
                    cpt++;
                    continue;
                }
                //System.out.println("tab length = "+tab.length);
                if (tab[1].equals(".txt")) {
                    historyFile = f;
                } else if (tab[1].equals("_summary.txt")) {
                    summaryFile = f;
                } else if (tab[1].equals("_players_ranking.html")) {
                    rankingFile = f;
                } else if (tab[1].equals("_coalition_ranking.html")) {
                    coalitionFile = f;
                }
                cpt++;
            }
            insertGame(xmlFile,historyFile,summaryFile,rankingFile,coalitionFile);
        }
    }
    
    public void insertGame(File xmlFile, File historyFile, File summaryFile, File rankingFile, File coalitionFile) {
        querys.insertGame(serie.getIdSerie(),xmlFile.getName());
        game = querys.getGame(serie.getIdSerie(),xmlFile.getName());
        //System.out.println("recup game = "+game.getIdGame()+" | "+game.getIdSerie()+" | "+game.getName());
        System.out.println("Analizing game "+game.getName()+" from serie "+serie.getName()+" from exp "+exp.getName()+" from test "+test.getName());
        String s = "";
        simulations.xml.DocumentTracer parser = new simulations.xml.DocumentTracer(xmlFile.getPath());
        // insert
        ArrayList playerList = new ArrayList();
        Iterator it = parser.getPlayerList().iterator();
        while (it.hasNext()) {
            simulations.core.Player pl = (simulations.core.Player)it.next();
            // insert strat
            simulations.core.strategy.completeStrategy.CompleteStrategy strat =
            (simulations.core.strategy.completeStrategy.CompleteStrategy)pl.getStrategy();
            Vector attVector = strat.getAttackStrategyVector();
            Vector askVector = strat.getAskingStrategyVector();
            Vector decVector = strat.getDecisionStrategyVector();
            Vector idAttVector = new Vector();
            Vector idAskVector = new Vector();
            Vector idDecVector = new Vector();
            // dj dedans???
            simulations.database.core.Strategy recupStrat = querys.getStrategy(strat);
            if (recupStrat!=null) {
                // oui !
                querys.insertPlayer(game.getIdGame(),recupStrat.getIdStrategy(),pl.getName());
                playerList.add(querys.getLastPlayer(game.getIdGame(),recupStrat.getIdStrategy(),pl.getName()));
                continue;
            }
            querys.insertStrategy(strat.getName());
            simulations.database.core.Strategy strategy = querys.getLastStrategy(strat.getName());
            //System.out.println("recup strategy = "+strategy.getIdStrategy()+" | "+strategy.getName());
            // insert sub strat
            Iterator it2 = attVector.iterator();
            while (it2.hasNext()) {
                simulations.core.strategy.attackStrategy.AttackStrategy attStrat =
                (simulations.core.strategy.attackStrategy.AttackStrategy)it2.next();
                //System.out.println(attStrat.getName()+" dj dedans ?");
                AttackStrat attStratRecup = querys.getAttackStrat(attStrat);
                if (attStratRecup!=null) {
                    //System.out.println(attStrat.getName()+" dj dedans");
                    idAttVector.add(attStratRecup);
                } else {
                    querys.insertAttackStrat(attStrat.getName(),attStrat.getMemory(),attStrat.isNegative());
                    idAttVector.add(
                    querys.getLastAttackStrat(
                    attStrat.getName(), attStrat.getMemory(), attStrat.isNegative()));
                }
            }
            it2 = askVector.iterator();
            while (it2.hasNext()) {
                simulations.core.strategy.askingSupportStrategy.AskingStrategy askStrat =
                (simulations.core.strategy.askingSupportStrategy.AskingStrategy)it2.next();
                //System.out.println(askStrat.getName()+" dj dedans?");
                AskingStrat askStratRecup = querys.getAskingStrat(askStrat);
                if (askStratRecup!=null) {
                    //System.out.println(askStrat.getName()+" dj dedans");
                    idAskVector.add(askStratRecup);
                } else {
                    querys.insertAskingStrat(askStrat.getName(),askStrat.getMemory(),askStrat.isNegative());
                    idAskVector.add(
                    querys.getLastAskingStrat(
                    askStrat.getName(), askStrat.getMemory(), askStrat.isNegative()));
                }
            }
            it2 = decVector.iterator();
            while (it2.hasNext()) {
                simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy decStrat =
                (simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy)it2.next();
                //System.out.println(decStrat.getName()+" dj dedans?");
                DecisionStrat decStratRecup = querys.getDecisionStrat(decStrat);
                if (decStratRecup!=null) {
                    //System.out.println(decStrat.getName()+" dj dedans");
                    idDecVector.add(decStratRecup);
                } else {
                    querys.insertDecisionStrat(decStrat.getName(),decStrat.getMemory(),decStrat.isNegative());
                    idDecVector.add(
                    querys.getLastDecisionStrat(
                    decStrat.getName(), decStrat.getMemory(), decStrat.isNegative()));
                }
            }
            // insert compo
            it2 = idAttVector.iterator();
            int idAtt = ((AttackStrat)it2.next()).getIdAttackStrat();
            int rank = 1;
            querys.insertCompoAttackStrat(idAtt,rank);
            int idCompoAtt = (querys.getLastCompoAttackStrat(idAtt,rank)).getIdCompoAttackStrat();
            rank++;
            while (it2.hasNext()) {
                idAtt = ((AttackStrat)it2.next()).getIdAttackStrat();
                querys.insertCompoAttackStrat(idCompoAtt,idAtt,rank);
                rank++;
            }
            it2 = idAskVector.iterator();
            int idAsk = ((AskingStrat)it2.next()).getIdAskingStrat();
            rank = 1;
            querys.insertCompoAskingStrat(idAsk,rank);
            int idCompoAsk = querys.getLastCompoAskingStrat(idAsk,rank).getIdCompoAskingStrat();
            rank++;
            while (it2.hasNext()) {
                idAsk = ((AskingStrat)it2.next()).getIdAskingStrat();
                querys.insertCompoAskingStrat(idCompoAsk,idAsk,rank);
                rank++;
            }
            it2 = idDecVector.iterator();
            int idDec = ((DecisionStrat)it2.next()).getIdDecisionStrat();
            rank = 1;
            querys.insertCompoDecisionStrat(idDec,rank);
            int idCompoDec = querys.getLastCompoDecisionStrat(idDec,rank).getIdCompoDecisionStrat();
            rank++;
            while (it2.hasNext()) {
                idDec = ((DecisionStrat)it2.next()).getIdDecisionStrat();
                querys.insertCompoDecisionStrat(idCompoDec,idDec,rank);
                rank++;
            }
            querys.insertCompoStrat(strategy.getIdStrategy(),idCompoAtt,idCompoAsk,idCompoDec);
            // insert pl
            querys.insertPlayer(game.getIdGame(),strategy.getIdStrategy(),pl.getName());
            playerList.add(querys.getLastPlayer(game.getIdGame(),strategy.getIdStrategy(),pl.getName()));
        }
        // insert pl ranking
        insertPlayerRanking(playerList,summaryFile);
        insertCoalitionRanking(playerList,coalitionFile);
    }
    
    public void insertCoalitionRanking(ArrayList playerList, File coalitionFile) {
        try {
            FileReader reader = new FileReader(coalitionFile);
            String s = "";
            for(int i=0;i<8;i++) {
                s=nextLine(reader);
            }
            while (!(s.equals("</table></center>\n"))) {
                String[] str = s.split("<td>");
                String strRank = str[1];//1</td>
                String strCoal = str[2];//[vdsvds,kvosdk,...]</td>
                String strNbOcc = str[3];//NB</td>
                String strNbSeq = str[4];//NB</td>
                String strLgMax = str[5];//NB</td></tr>\n
                strRank = strRank.substring(0,strRank.length()-5);
                strCoal = strCoal.substring(1,strCoal.length()-6);//vdsvd, vdsvds, dsvsd
                strNbOcc = strNbOcc.substring(0,strNbOcc.length()-5);
                strNbSeq = strNbSeq.substring(0,strNbSeq.length()-5);
                strLgMax = strLgMax.substring(0,strLgMax.length()-11);
                int rank = new Integer(strRank).intValue();
                int nbOcc = new Integer(strNbOcc).intValue();
                int nbSeq = new Integer(strNbSeq).intValue();
                int lgMax = new Integer(strLgMax).intValue();
                if (nbOcc<=2) {
                    break;
                }
                String[] strCoals = strCoal.split(",");
                ArrayList coalList = new ArrayList();
                coalList.add(strCoals[0]);
                for(int i=1;i<strCoals.length;i++) {
                    String coal = strCoals[i].substring(1,strCoals[i].length());
                    coalList.add(coal);
                }
                
                Iterator it = coalList.iterator();
                Player pl = querys.getPlayer(game.getIdGame(),it.next().toString());
                querys.insertCoalition(pl.getIdPlayer());
                //com.execUpdate("INSERT INTO COALITION (ID_PLAYER) VALUES ("+pl.getIdPlayer()+")");
                int idCoal = ((Coalition)querys.getLastCoalition(pl.getIdPlayer())).getIdCoalition();
                while (it.hasNext()) {
                    Player p = querys.getPlayer(game.getIdGame(),it.next().toString());
                    querys.insertCoalition(idCoal,p.getIdPlayer());
                }
                querys.insertCoalitionsRanking(idCoal,game.getIdGame(),rank,nbOcc,nbSeq,lgMax);
                s = nextLine(reader);
            }
            reader.close();
        }catch(IOException e) {
            e.printStackTrace();
        }
    }
    
    public void insertPlayerRanking(ArrayList playerList, File summaryFile) {
        try {
            FileReader reader = new FileReader(summaryFile);
            for(int i=0;i<playerList.size();i++) {
                String s = nextLine(reader);
                s=s.substring(0,s.length()-1);
                int rank = new Integer(s).intValue();
                s = nextLine(reader);
                s=s.substring(0,s.length()-1);
                String name = s;
                s = nextLine(reader);
                s=s.substring(0,s.length()-1);
                int lastTurn = new Integer(s).intValue();
                while (!(s.equals("\n"))) {
                    s = nextLine(reader);
                }
                //querys.insertPlayersRanking(game.getIdGame(),((Player)playerList.get(i)).getIdPlayer(),rank,lastTurn);
                querys.insertPlayersRanking(game.getIdGame(),querys.getPlayer(game.getIdGame(),name).getIdPlayer(),rank,lastTurn);
            }
            reader.close();
        }catch(IOException e) {
            e.printStackTrace();
        }
    }
    
    public boolean isInPlayerList(ArrayList playerList, Player p) {
        return true;
    }
    
    public String nextLine(FileReader reader) throws IOException {
        String s="";
        try {
            int c;
            char ch;
            while ((c=reader.read())>=0) {
                ch=(char)c;
                s=s.concat(s.valueOf(ch));
                if (ch=='\n') {
                    break;
                }
            }
        }catch(IOException e) {
            throw e;
        }
        return s;
    }
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JButton folderButton;
    private javax.swing.JTextField folderTextField;
    private javax.swing.JButton insertButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JComboBox testComboBox;
    // End of variables declaration//GEN-END:variables
    
}
