/*
 * ViewCoalitionStats.java
 *
 * Created on 3 novembre 2004, 15:42
 */

package simulations.database.gui;

import simulations.database.core.Querys;
import simulations.database.core.Game;
import simulations.database.core.Player;
import simulations.database.core.Strategy;
import simulations.database.core.PlayersRanking;

import java.util.ArrayList;
import java.util.Vector;
import javax.swing.JTable;


/**
 *
 * @author  tom
 */
public class ViewCoalitionStats extends javax.swing.JDialog {
    
    private Querys querys;
    
    private Game game;
    
    /** Creates new form ViewCoalitionStats */
    public ViewCoalitionStats(java.awt.Frame parent, boolean modal,Querys query, Game game) {
        super(parent, modal);
        this.querys=query;
        this.game=game;
        //System.out.println(game.toString());
        //System.out.println(querys.toString());
        initComponents();
        init();
    }
    
    private void init() {
        Vector titleList = new Vector();
        titleList.addElement("Rank");
        titleList.addElement("Player");
        titleList.addElement("Strategy");
        titleList.addElement("nb turns");
        titleList.addElement("% turns in coal");
        Vector data = new Vector();
        ArrayList l = querys.getAllPlayersRanking(game.getIdGame());
        for(int i=0;i<l.size();i++) {
            PlayersRanking plr = (PlayersRanking)l.get(i);
            Player p = querys.getPlayer(plr.getIdPlayer());
            Strategy strat = querys.getStrategy(p.getIdStrategy());
            Vector line = new Vector();
            line.add(""+plr.getRank());
            line.add(p.getName());
            line.add(strat.getName());
            line.add(""+plr.getLastTurn());
            line.add(""+(new Double((new Double(querys.getNbTimesInCoalitions(plr.getIdPlayer())).doubleValue()/
            new Double(plr.getLastTurn()).doubleValue())).doubleValue()*100));
            data.add(line);
        }
        statsTable = new JTable(data,titleList);
        scrollPane.setViewportView(statsTable);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        scrollPane = new javax.swing.JScrollPane();
        statsTable = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        closeButton = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Coalition stats");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        jPanel1.setLayout(new java.awt.BorderLayout());

        statsTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null}
            },
            new String [] {
                "Rank", "Player", "Strategy", "nb turns", "% turns in coal"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.Integer.class, java.lang.Double.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        scrollPane.setViewportView(statsTable);

        jPanel1.add(scrollPane, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        closeButton.setText("Fermer");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel2.add(closeButton);

        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane scrollPane;
    private javax.swing.JTable statsTable;
    // End of variables declaration//GEN-END:variables
    
}
