/*
 * ViewGameByTurnDialog.java
 *
 * Created on 11 juin 2004, 23:45
 */

package simulations.database.gui;

import simulations.database.core.Game;
import simulations.database.core.Serie;
import simulations.database.core.Exp;
import simulations.database.core.Test;
import simulations.database.core.Querys;

import javax.swing.SpinnerNumberModel;

import java.util.ArrayList;

/**
 *
 * @author  tom
 */
public class ViewGameByTurnDialog extends javax.swing.JDialog {
    
    private Game game;
    
    private Querys querys;
    
    private java.awt.Frame parent;
    
    /** Creates new form ViewGameByTurnDialog */
    public ViewGameByTurnDialog(java.awt.Frame parent, boolean modal, Querys querys) {
        super(parent, modal);
        this.parent=parent;
        this.querys=querys;
        initComponents();
        nbTurnsSpinner.setModel(new SpinnerNumberModel(10000,1,1000000,10));
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        descriptionButton = new javax.swing.JButton();
        rankingButton = new javax.swing.JButton();
        coalitionButton = new javax.swing.JButton();
        closeDialog = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        nbTurnsSpinner = new javax.swing.JSpinner();
        searchButton = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        serieLabel = new javax.swing.JLabel();
        expLabel = new javax.swing.JLabel();
        testLabel = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        gameJList = new javax.swing.JList();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Games");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        descriptionButton.setText("Game description");
        descriptionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                descriptionButtonActionPerformed(evt);
            }
        });

        jPanel1.add(descriptionButton);

        rankingButton.setText("Players ranking");
        rankingButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rankingButtonActionPerformed(evt);
            }
        });

        jPanel1.add(rankingButton);

        coalitionButton.setText("Coalition ranking");
        coalitionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                coalitionButtonActionPerformed(evt);
            }
        });

        jPanel1.add(coalitionButton);

        closeDialog.setText("Close");
        closeDialog.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeDialogActionPerformed(evt);
            }
        });

        jPanel1.add(closeDialog);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jLabel2.setText("Min nb turns : ");
        jPanel3.add(jLabel2);

        jPanel3.add(nbTurnsSpinner);

        searchButton.setText("Search");
        searchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchButtonActionPerformed(evt);
            }
        });

        jPanel3.add(searchButton);

        jPanel2.add(jPanel3, java.awt.BorderLayout.NORTH);

        jPanel4.setLayout(new java.awt.BorderLayout());

        jPanel5.setLayout(new javax.swing.BoxLayout(jPanel5, javax.swing.BoxLayout.Y_AXIS));

        serieLabel.setText("Serie : ");
        jPanel5.add(serieLabel);

        expLabel.setText("Exp : ");
        jPanel5.add(expLabel);

        testLabel.setText("Test : ");
        jPanel5.add(testLabel);

        jPanel4.add(jPanel5, java.awt.BorderLayout.EAST);

        jPanel6.setLayout(new java.awt.BorderLayout());

        gameJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                gameJListValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(gameJList);

        jPanel6.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel4.add(jPanel6, java.awt.BorderLayout.CENTER);

        jPanel2.add(jPanel4, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void searchButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchButtonActionPerformed
        // Add your handling code here:
        int nb = ((Integer)nbTurnsSpinner.getValue()).intValue();
        ArrayList l = querys.getAllGamesByTurn(nb);
        gameJList.setListData(l.toArray());
    }//GEN-LAST:event_searchButtonActionPerformed

    private void coalitionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_coalitionButtonActionPerformed
        // Add your handling code here:
        ViewCoalitionRankingDialog dialog = new ViewCoalitionRankingDialog(parent, false, querys, game);
        dialog.setVisible(true);
    }//GEN-LAST:event_coalitionButtonActionPerformed

    private void rankingButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rankingButtonActionPerformed
        // Add your handling code here:
         ViewPlayersRankingDialog dialog = new ViewPlayersRankingDialog(parent, false, querys, game);
         dialog.setVisible(true);
    }//GEN-LAST:event_rankingButtonActionPerformed

    private void gameJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_gameJListValueChanged
        // Add your handling code here:
        if (gameJList.getSelectedValue()!=null) {
            game=(Game)gameJList.getSelectedValue();
            Serie serie = querys.getSerie(game.getIdSerie());
            Exp exp = querys.getExp(serie.getIdExp());
            Test test = querys.getTest(exp.getIdTest());
            serieLabel.setText(serie.getName());
            expLabel.setText(exp.getName());
            testLabel.setText(test.getName());
        }
    }//GEN-LAST:event_gameJListValueChanged

    private void descriptionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_descriptionButtonActionPerformed
        // Add your handling code here:
        ViewGameDescriptionDialog dialog = new ViewGameDescriptionDialog(parent, false, game, querys);
        dialog.setVisible(true);
    }//GEN-LAST:event_descriptionButtonActionPerformed

    private void closeDialogActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeDialogActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeDialogActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeDialog;
    private javax.swing.JButton coalitionButton;
    private javax.swing.JButton descriptionButton;
    private javax.swing.JLabel expLabel;
    private javax.swing.JList gameJList;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSpinner nbTurnsSpinner;
    private javax.swing.JButton rankingButton;
    private javax.swing.JButton searchButton;
    private javax.swing.JLabel serieLabel;
    private javax.swing.JLabel testLabel;
    // End of variables declaration//GEN-END:variables
    
}
