/*
 * ViewSameGameDialog.java
 *
 * Created on 14 juin 2004, 16:08
 */

package simulations.database.gui;

import simulations.database.core.Querys;
import simulations.database.core.Game;
import simulations.database.core.Serie;
import simulations.database.core.Exp;
import simulations.database.core.Test;

import java.util.ArrayList;

/**
 *
 * @author  tom
 */
public class ViewSameGameDialog extends javax.swing.JDialog {
    
    private Querys querys;
    
    private Game game;
    
    /** Creates new form ViewSameGameDialog */
    public ViewSameGameDialog(java.awt.Frame parent, boolean modal, Querys querys) {
        super(parent, modal);
        initComponents();
        this.querys=querys;
        init();
    }
    
    public void init() {
        ArrayList l = querys.getAllDistinctGames();
        gamesByNameJList.setListData(l.toArray());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        descritionButton = new javax.swing.JButton();
        playersButton = new javax.swing.JButton();
        coalitionButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        gamesByNameJList = new javax.swing.JList();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        allGamesJList = new javax.swing.JList();
        jPanel5 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        serieLabel = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        expLabel = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        testLabel = new javax.swing.JLabel();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("View same game");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        descritionButton.setText("Game description");
        descritionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                descritionButtonActionPerformed(evt);
            }
        });

        jPanel1.add(descritionButton);

        playersButton.setText("Players ranking");
        playersButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                playersButtonActionPerformed(evt);
            }
        });

        jPanel1.add(playersButton);

        coalitionButton.setText("Coalition ranking");
        coalitionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                coalitionButtonActionPerformed(evt);
            }
        });

        jPanel1.add(coalitionButton);

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.GridLayout(1, 3));

        jPanel3.setLayout(new java.awt.BorderLayout());

        gamesByNameJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                gamesByNameJListValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(gamesByNameJList);

        jPanel3.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel2.add(jPanel3);

        jPanel4.setLayout(new java.awt.BorderLayout());

        allGamesJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                allGamesJListValueChanged(evt);
            }
        });

        jScrollPane2.setViewportView(allGamesJList);

        jPanel4.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jPanel2.add(jPanel4);

        jPanel5.setLayout(new java.awt.GridLayout(0, 2));

        jLabel2.setText("Serie : ");
        jPanel5.add(jLabel2);

        jPanel5.add(serieLabel);

        jLabel4.setText("Exp : ");
        jPanel5.add(jLabel4);

        jPanel5.add(expLabel);

        jLabel6.setText("Test : ");
        jPanel5.add(jLabel6);

        jPanel5.add(testLabel);

        jPanel2.add(jPanel5);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void coalitionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_coalitionButtonActionPerformed
        // Add your handling code here:
        ViewCoalitionRankingDialog dialog = new ViewCoalitionRankingDialog(null, false, querys, game);
        dialog.setVisible(true);
    }//GEN-LAST:event_coalitionButtonActionPerformed

    private void playersButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_playersButtonActionPerformed
        // Add your handling code here:
        ViewPlayersRankingDialog dialog = new ViewPlayersRankingDialog(null, false, querys, game);
        dialog.setVisible(true);
    }//GEN-LAST:event_playersButtonActionPerformed

    private void descritionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_descritionButtonActionPerformed
        // Add your handling code here:
        ViewGameDescriptionDialog dialog = new ViewGameDescriptionDialog(null, false, game, querys);
        dialog.setVisible(true);
    }//GEN-LAST:event_descritionButtonActionPerformed

    private void gamesByNameJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_gamesByNameJListValueChanged
        // Add your handling code here:
        if (gamesByNameJList.getSelectedValue()!=null) {
            Game g = (Game)gamesByNameJList.getSelectedValue();
            ArrayList l = querys.getAllGames(g.getName());
            allGamesJList.setListData(l.toArray());
        }
    }//GEN-LAST:event_gamesByNameJListValueChanged

    private void allGamesJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_allGamesJListValueChanged
        // Add your handling code here:
        if (allGamesJList.getSelectedValue()!=null) {
            game = (Game)allGamesJList.getSelectedValue();
            Serie serie = querys.getSerie(game.getIdSerie());
            Exp exp = querys.getExp(serie.getIdExp());
            Test test = querys.getTest(exp.getIdTest());
            serieLabel.setText(serie.getName());
            expLabel.setText(exp.getName());
            testLabel.setText(test.getName());
        } else {
            serieLabel.setText("");
            expLabel.setText("");
            testLabel.setText("");
        }
    }//GEN-LAST:event_allGamesJListValueChanged

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JList allGamesJList;
    private javax.swing.JButton closeButton;
    private javax.swing.JButton coalitionButton;
    private javax.swing.JButton descritionButton;
    private javax.swing.JLabel expLabel;
    private javax.swing.JList gamesByNameJList;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JButton playersButton;
    private javax.swing.JLabel serieLabel;
    private javax.swing.JLabel testLabel;
    // End of variables declaration//GEN-END:variables
    
}
