/*
 * BuildFinalsDialog.java
 *
 * Created on 17 juin 2004, 21:25
 */

package simulations.gui;

import java.util.ArrayList;
import java.util.Iterator;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import simulations.core.Player;
import simulations.core.strategy.completeStrategy.CompleteStrategy;
import simulations.core.strategy.ObjectIntElement;

import javax.swing.SpinnerNumberModel;
import javax.swing.JFileChooser;

/**
 *
 * @author  tom
 */
public class BuildFinalsDialog extends javax.swing.JDialog {
    
    private ArrayList playersList;
    
    /** Creates new form BuildFinalsDialog */
    public BuildFinalsDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        randomSeedSpinner.setModel(new SpinnerNumberModel(0,0,10000,1));
        nbPlayerSpinner.setModel(new SpinnerNumberModel(30,3,1000,1));
        //sourceTextField.setText("/home/tom/test1");
        //init();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        generateButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        sourceTextField = new javax.swing.JTextField();
        sourceButton = new javax.swing.JButton();
        destinationButton = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        destinationTextField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        randomSeedSpinner = new javax.swing.JSpinner();
        jLabel5 = new javax.swing.JLabel();
        nbPlayerSpinner = new javax.swing.JSpinner();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Generate finals");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        generateButton.setText("Generate");
        generateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                generateButtonActionPerformed(evt);
            }
        });

        jPanel1.add(generateButton);

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jLabel2.setText("Source :");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        jPanel2.add(jLabel2, gridBagConstraints);

        sourceTextField.setColumns(20);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        jPanel2.add(sourceTextField, gridBagConstraints);

        sourceButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        sourceButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sourceButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        jPanel2.add(sourceButton, gridBagConstraints);

        destinationButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        destinationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                destinationButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        jPanel2.add(destinationButton, gridBagConstraints);

        jLabel3.setText("Destination :");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel2.add(jLabel3, gridBagConstraints);

        destinationTextField.setColumns(20);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        jPanel2.add(destinationTextField, gridBagConstraints);

        jLabel4.setText("Random seed :");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        jPanel2.add(jLabel4, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        jPanel2.add(randomSeedSpinner, gridBagConstraints);

        jLabel5.setText("Nb players / game :");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        jPanel2.add(jLabel5, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        jPanel2.add(nbPlayerSpinner, gridBagConstraints);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents
    
    private void init() {
        playersList = new ArrayList();
        File sourceFolder = new File(sourceTextField.getText());
        //File sourceFolder = new File("/home/tom/test1");
        File[] expList = sourceFolder.listFiles();
        File expFile = new File(sourceTextField.getText()+"/experimentations1");
        File[] serieList = expFile.listFiles();
        for(int j=0;j<serieList.length;j++) {
            File serieFile = (File)serieList[j];
            if (serieFile.getName().startsWith("serie")) {
                File[] xmlFolder = new File(serieFile.getPath()+"/xmlGameFiles").listFiles();
                for(int k=0;k<xmlFolder.length;k++) {
                    File xmlFile = (File)xmlFolder[k];
                    String name = xmlFile.getName();
                    String[] str = name.split(".xml");
                    String num = str[0].substring(4,str[0].length());
                    ArrayList rankingList = new ArrayList();
                    for(int l=1;l<=6;l++) {
                        File f = new File(sourceTextField.getText()+"/experimentations"+l+"/"+serieFile.getName()+"/xmlGameFiles/game"+num+".xml");
                        System.out.println(f.getPath());
                        simulations.xml.DocumentTracer parser = new simulations.xml.DocumentTracer(f.getPath());
                        File historyFile = new File(sourceTextField.getText()+"/experimentations"+l+"/"+serieFile.getName()+"/history/history"+num+"_summary.txt");
                        System.out.println(historyFile.getPath());
                        try {
                            FileReader reader = new FileReader(historyFile);
                            for(int m=0;m<30;m++) {
                                nextLine(reader);
                                String playerName = nextLine(reader);
                                try {
                                    playerName = playerName.substring(0,playerName.length()-1);
                                }catch(ArrayIndexOutOfBoundsException e) {
                                    break;
                                }catch(StringIndexOutOfBoundsException e) {
                                    break;
                                }
                                System.out.println("player name = "+playerName);
                                addToList(rankingList,getPlayer(parser.getPlayerList(), playerName),m+1);
                                while (nextLine(reader).length()>1) {
                                    //nextLine(reader);
                                }
                            }
                            reader.close();
                        }catch(IOException e) {
                            System.out.println(e.toString());
                            System.exit(0);
                        }
                    }
                    // select three best
                    insertThreeBestStrat(rankingList);
                }
            }
        }
        System.out.println(playersList.toString());
    }
    
    private void generateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_generateButtonActionPerformed
        // Add your handling code here:
        init();
        createScript();
    }//GEN-LAST:event_generateButtonActionPerformed
    
    private void insertThreeBestStrat(ArrayList l) {
        Iterator it = l.iterator();
        int min=100000;
        ObjectIntElement minElt = null;
        while (it.hasNext()) {
            ObjectIntElement elt = (ObjectIntElement)it.next();
            if (elt.getNb()<=min) {
                min=elt.getNb();
                minElt=elt;
            }
        }
        playersList.add(minElt.getObject());
        System.out.println("first : "+((Player)minElt.getObject()).getName()+" : "+((Player)minElt.getObject()).getStrategy().getName());
        l.remove(minElt);
        min=100000;
        minElt = null;
        it = l.iterator();
        while (it.hasNext()) {
            ObjectIntElement elt = (ObjectIntElement)it.next();
            if (elt.getNb()<=min) {
                min=elt.getNb();
                minElt=elt;
            }
        }
        playersList.add(minElt.getObject());
        System.out.println("second : "+((Player)minElt.getObject()).getName()+" : "+((Player)minElt.getObject()).getStrategy().getName());
        l.remove(minElt);
        min=100000;
        minElt = null;
        it = l.iterator();
        while (it.hasNext()) {
            ObjectIntElement elt = (ObjectIntElement)it.next();
            if (elt.getNb()<=min) {
                min=elt.getNb();
                minElt=elt;
            }
        }
        playersList.add(minElt.getObject());
        System.out.println("third : "+((Player)minElt.getObject()).getName()+" : "+((Player)minElt.getObject()).getStrategy().getName());
        l.remove(minElt);
    }
    
    private void addToList(ArrayList list, Player p, int rank) {
        Iterator it = list.iterator();
        while (it.hasNext()) {
            ObjectIntElement elt = (ObjectIntElement)it.next();
            if (((Player)elt.getObject()).equals(p)) {
                elt.setNb(elt.getNb()+rank);
                return;
            }
        }
        list.add(new ObjectIntElement(p,rank));
    }
    
    private void createScript() {
        System.out.println(playersList.size()+" players");
        File destFolder = new File(destinationTextField.getText());
        File serieFolder = new File(destFolder.getPath()+"/serie1");
        serieFolder.mkdir();
        File historyFolder = new File(serieFolder.getPath()+"/history");
        historyFolder.mkdir();
        File xmlFolder = new File(serieFolder.getPath()+"/xmlGameFiles");
        xmlFolder.mkdir();
        File scriptFolder = new File(serieFolder.getPath()+"/scripts");
        scriptFolder.mkdir();
        int nbPByGame = ((Integer)nbPlayerSpinner.getValue()).intValue();
        int nbGame = playersList.size()/nbPByGame+1;
        File scriptFile = new File(scriptFolder.getPath()+"/script1.sh");
        FileWriter writer = null;
        try {
            writer = new FileWriter(scriptFile);
            writer.write("#!/bin/sh\n");
        }catch(IOException e) {
            System.out.println(e.toString());
            System.exit(0);
        }
        for(int i=0;i<nbGame;i++) {
            ArrayList pList = new ArrayList();
            if (playersList.size()>=30) {
                for(int j=0;j<30;j++) {
                    Player p = (Player)playersList.remove(0);
                    System.out.println("playersList.size() = "+playersList.size());
                    if (!(containsStrat(pList,p.getStrategy()))) {
                        p.setName("Player #"+j);
                        pList.add(p);
                    }
                }
            } else {
                for(int j=0;j<playersList.size();j++) {
                    Player p = (Player)playersList.get(j);
                    System.out.println("playersList.size() = "+playersList.size());
                    if (!(containsStrat(pList,p.getStrategy()))) {
                        p.setName("Player #"+j);
                        pList.add(p);
                    }
                }
            }
            /**for(int j=0;j<playersList.size();j++) {
                Player p = (Player)playersList.get(j);
                p.setName("Player #"+j);
                pList.add(p);
            }**/
            simulations.xml.XMLGameWriter xmlWriter = new simulations.xml.XMLGameWriter();
            xmlWriter.create(new File(xmlFolder.getPath()+"/game"+i+".xml"), ((Integer)randomSeedSpinner.getValue()).intValue(),
            1, 1, 0, 0, 1, false, new File("../history/history"+i+".txt"), null, pList);
            try {
                writer.write("echo \"Launching game #"+i+" on "+nbGame+"\"\n");
                writer.write("java -jar ../../simulations.jar "+
                "../xmlGameFiles/game"+i+".xml -noHistory\n\n");
            }catch(IOException e) {
                System.out.println(e.toString());
                System.exit(0);
            }
            System.out.println("game"+i+".xml");
        }
        try {
            writer.close();
        }catch(IOException e) {
            System.out.println(e.toString());
            System.exit(0);
        }
    }
    
    private boolean containsStrat(ArrayList list, CompleteStrategy strat) {
        Iterator it = list.iterator();
        while (it.hasNext()) {
            Player p = (Player)it.next();
            if (p.getStrategy().getName().equals(strat.getName())) {
                return true;
            }
        }
        return false;
    }
    
    private Player getPlayer(ArrayList list, String name) {
        Iterator it = list.iterator();
        while (it.hasNext()) {
            Player p = (Player)it.next();
            if (p.getName().equals(name)) {
                return p;
            }
        }
        System.out.println("getPlayer() null!!!");
        return null;
    }
    
    public String nextLine(FileReader reader) throws IOException {
        String s="";
        try {
            int c;
            char ch;
            while ((c=reader.read())>=0) {
                ch=(char)c;
                s=s.concat(s.valueOf(ch));
                if (ch=='\n') {
                    break;
                }
            }
        }catch(IOException e) {
            throw e;
        }
        //System.out.println("next line = "+s);
        return s;
    }
    
    private void destinationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_destinationButtonActionPerformed
        // Add your handling code here:
        JFileChooser chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            destinationTextField.setText(chooser.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_destinationButtonActionPerformed
    
    private void sourceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sourceButtonActionPerformed
        // Add your handling code here:
        JFileChooser chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            sourceTextField.setText(chooser.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_sourceButtonActionPerformed
    
    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JButton destinationButton;
    private javax.swing.JTextField destinationTextField;
    private javax.swing.JButton generateButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JSpinner nbPlayerSpinner;
    private javax.swing.JSpinner randomSeedSpinner;
    private javax.swing.JButton sourceButton;
    private javax.swing.JTextField sourceTextField;
    // End of variables declaration//GEN-END:variables
    
}
