/*
 * ClassementDialog.java
 *
 * Created on May 16, 2004, 7:55 PM
 */

package simulations.gui;

import java.util.ArrayList;
import java.util.Iterator;

import simulations.core.strategy.PlayerIntElement;

import javax.swing.JLabel;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JFileChooser;

/**
 * This class represents the dialog shown at the end of the game with the classement
 * @author  tom
 */
public class ClassementDialog extends javax.swing.JDialog {
    
    /** The players ranking **/
    private ArrayList classement;
    
    /**
     * Creates new form ClassementDialog
     * @param parent The parent window
     * @param modal True if the dialog is modal
     * @param classement The classement of the game
     */
    public ClassementDialog(java.awt.Frame parent, boolean modal, ArrayList classement) {
        super(parent, modal);
        initComponents();
        this.classement=classement;
        //jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        //jLabel2.setText("Classement of the game");
        //jLabel2.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        java.awt.GridBagConstraints gbc = new java.awt.GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 2;
        gbc.gridwidth = 1;
        gbc.fill = java.awt.GridBagConstraints.HORIZONTAL;
        //centerPanel.add(jLabel2, gbc);
        Iterator it = classement.iterator();
        int cpt=1;
        while (it.hasNext()) {
            PlayerIntElement elt = (PlayerIntElement)it.next();
            JLabel label1 = new JLabel(elt.getPlayer().getName());
            label1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
            label1.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
            gbc.gridx=0;
            gbc.gridy=cpt+1;
            centerPanel.add(label1,gbc);
            
            JLabel label2 = new JLabel(elt.getPlayer().getStrategy().getName());
            label2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
            label2.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
            gbc.gridx=1;
            centerPanel.add(label2,gbc);
            
            JLabel label3 = new JLabel(""+cpt);
            label3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
            label3.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
            gbc.gridx=2;
            centerPanel.add(label3,gbc);
            
            JLabel label4 = new JLabel(""+elt.getNb());
            label4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
            label4.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
            gbc.gridx=3;
            centerPanel.add(label4,gbc);
            
            cpt++;
        }
        centerPanel.repaint();
        this.setSize(500,400);
        this.setLocationRelativeTo(parent);
        this.repaint();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        saveButton = new javax.swing.JButton();
        okButton = new javax.swing.JButton();
        scrollPane = new javax.swing.JScrollPane();
        centerPanel = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Game over");
        jLabel1.setFont(new java.awt.Font("Dialog", 1, 18));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/ksmiletris.png")));
        jLabel1.setText("Game over");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        saveButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/save.png")));
        saveButton.setText("Save");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        jPanel1.add(saveButton);

        okButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/apply.png")));
        okButton.setText("OK");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        jPanel1.add(okButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        centerPanel.setLayout(new java.awt.GridBagLayout());

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText("Classement of the game");
        jLabel2.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        centerPanel.add(jLabel2, gridBagConstraints);

        jLabel3.setText("Player's name");
        jLabel3.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        centerPanel.add(jLabel3, gridBagConstraints);

        jLabel4.setText("Strategy");
        jLabel4.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        centerPanel.add(jLabel4, gridBagConstraints);

        jLabel5.setText("Rank");
        jLabel5.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        centerPanel.add(jLabel5, gridBagConstraints);

        jLabel6.setText("Last turn");
        jLabel6.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        centerPanel.add(jLabel6, gridBagConstraints);

        scrollPane.setViewportView(centerPanel);

        getContentPane().add(scrollPane, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    /** Save the players ranking table in f
     * @param f The file to save the table 
     **/
    public void save(File f) {
        try {
            if (simulations.SimulationParameters.debug) {
                System.out.println("saving classement in "+f.getPath());
            }
            FileWriter writer = new FileWriter(f);
            writer.write("<html>\n");
            writer.write("<title>Coalition ranking</title>\n");
            writer.write("<body>\n");
            writer.write("<h2><center>Coalition ranking</center></h2>\n");
            writer.write("<br>\n");
            writer.write("<center><table border>\n");
            writer.write("<tr><td>Rank</td><td>Player</td><td>Strategy</td><td>Last turn</td></tr>\n");
            Iterator it = classement.iterator();
            int cpt=1;
            while (it.hasNext()) {
                PlayerIntElement elt = (PlayerIntElement)it.next();
                writer.write("<tr><td>#"+cpt+"</td><td>"+elt.getPlayer()+"</td><td>"+
                elt.getPlayer().getStrategy().getName()+"</td><td>"+elt.getNb()+"</td></tr>\n");
                cpt++;
            }
            writer.write("</table></center>\n");
            writer.write("</body>\n");
            writer.write("</html>\n");
            writer.close();
        }catch(IOException e) {
            System.out.println(e.toString());
        }
    }
    
    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        // TODO add your handling code here:
        JFileChooser chooser = new JFileChooser();
        StrategyFileFilter filter = new StrategyFileFilter("html");
        filter.setDescription("HTML files");
        chooser.setFileFilter(filter);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            String fileName = chooser.getSelectedFile().getPath();
            if (simulations.SimulationParameters.debug) {
                System.out.println(fileName);
            }
            if (!(fileName.substring(fileName.length()-5,fileName.length()).equals(".html"))) {
                fileName=fileName+".html";
            }
            save(new File(fileName));
        }
    }//GEN-LAST:event_saveButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // TODO add your handling code here:
        this.setVisible(false);
        this.dispose();
    }//GEN-LAST:event_okButtonActionPerformed
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel centerPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton okButton;
    private javax.swing.JButton saveButton;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables
    
}
