/*
 * ComposedStrategyDialog.java
 *
 * Created on April 9, 2004, 3:45 AM
 */

package simulations.gui;

import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.completeStrategy.CompleteStrategy;
import simulations.core.strategy.completeStrategy.GenericComposedStrategy;
import simulations.core.strategy.StrategyLoader;
import javax.swing.JFileChooser;
import javax.swing.SpinnerNumberModel;

import java.util.ArrayList;
import java.util.Vector;
import java.util.Iterator;
import java.io.File;
import java.io.FileOutputStream;
import java.io.ObjectOutputStream;

/**
 * This class descibes the dialog box of the edition of
 * a composed strategy
 * @author  tom
 */
public class ComposedStrategyDialog extends javax.swing.JDialog {
    
    /** The return status :
     * 0 if cancel button  has been clicked
     * 1 if ok button has been clicked **/
    private int returnStatus;
        
    /** The strategy loader **/
    private StrategyLoader strategyLoader;
    
    /** The attack strategy list **/
    private ArrayList attackStrategyList;
    
    /** The asking strategy list **/
    private ArrayList askingStrategyList;
    
    /** The decision strategy list **/
    private ArrayList decisionStrategyList;
    
    /** The selected attack strategy list **/
    private ArrayList selectedAttackStrategyList;
    
    /** The selected asking strategy list **/
    private ArrayList selectedAskingStrategyList;
    
    /** The selected decision strategy list **/
    private ArrayList selectedDecisionStrategyList;
    
    /** The edited omplete strategy **/
    private CompleteStrategy editedStrategy;
    
    /** Creates new form ComposedStrategyDialog 
     * @param parent The parent window
     * @param modal True if dialog is modal
     **/
    public ComposedStrategyDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        memoryAttackSpinner.setModel(new SpinnerNumberModel(0,0,100,1));
        memoryAskingSpinner.setModel(new SpinnerNumberModel(0,0,100,1));
        memoryDecisionSpinner.setModel(new SpinnerNumberModel(0,0,100,1));
        selectedAskingStrategyList = new ArrayList();
        selectedAttackStrategyList = new ArrayList();
        selectedDecisionStrategyList = new ArrayList();
        strategyLoader = new StrategyLoader();
        loadStrategy();
        this.setSize(830, 650);
    }
    
    /** This method load the available strategies in the JList **/
    private void loadStrategy() {
        attackStrategyList = strategyLoader.getAllAttackStrategy();
        askingStrategyList = strategyLoader.getAllAskingStrategy();
        decisionStrategyList = strategyLoader.getAllDecisionStrategy();
        attackStrategyJList.setListData(attackStrategyList.toArray());
        askingStrategyJList.setListData(askingStrategyList.toArray());
        decisionStrategyJList.setListData(decisionStrategyList.toArray());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel17 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jPanel18 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        strategyNameTextField = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        saveButton = new javax.swing.JButton();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jPanel11 = new javax.swing.JPanel();
        jScrollPane7 = new javax.swing.JScrollPane();
        attackStrategyJList = new javax.swing.JList();
        jScrollPane8 = new javax.swing.JScrollPane();
        attackStrategyTextArea = new javax.swing.JTextArea();
        jPanel19 = new javax.swing.JPanel();
        addAttackStrategyButton = new javax.swing.JButton();
        jPanel22 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        memoryAttackSpinner = new javax.swing.JSpinner();
        negativeAttackCheckBox = new javax.swing.JCheckBox();
        jPanel9 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        jPanel12 = new javax.swing.JPanel();
        jScrollPane10 = new javax.swing.JScrollPane();
        askingStrategyTextArea = new javax.swing.JTextArea();
        jScrollPane9 = new javax.swing.JScrollPane();
        askingStrategyJList = new javax.swing.JList();
        jPanel20 = new javax.swing.JPanel();
        addAskingStrategyButton = new javax.swing.JButton();
        jPanel23 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        memoryAskingSpinner = new javax.swing.JSpinner();
        negativeAskingCheckBox = new javax.swing.JCheckBox();
        jPanel10 = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        jPanel13 = new javax.swing.JPanel();
        jScrollPane12 = new javax.swing.JScrollPane();
        decisionStrategyTextArea = new javax.swing.JTextArea();
        jScrollPane11 = new javax.swing.JScrollPane();
        decisionStrategyJList = new javax.swing.JList();
        jPanel21 = new javax.swing.JPanel();
        addDecisionStrategyButton = new javax.swing.JButton();
        jPanel24 = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        memoryDecisionSpinner = new javax.swing.JSpinner();
        negativeDecisionCheckBox = new javax.swing.JCheckBox();
        jPanel2 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        attackJList = new javax.swing.JList();
        jPanel14 = new javax.swing.JPanel();
        moveUpAttackButton = new javax.swing.JButton();
        moveDownAttackButton = new javax.swing.JButton();
        removeAttackButton = new javax.swing.JButton();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        askingJList = new javax.swing.JList();
        jPanel15 = new javax.swing.JPanel();
        moveUpAskingButton = new javax.swing.JButton();
        moveDownAskingButton = new javax.swing.JButton();
        removeAskingButton = new javax.swing.JButton();
        jPanel7 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        decisionJList = new javax.swing.JList();
        jPanel16 = new javax.swing.JPanel();
        moveUpDecisionButton = new javax.swing.JButton();
        moveDownDecisionButton = new javax.swing.JButton();
        removeDecisionButton = new javax.swing.JButton();

        setTitle("Strategy editor");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel17.setLayout(new java.awt.BorderLayout());

        jLabel1.setFont(new java.awt.Font("Dialog", 1, 18));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/edit.png")));
        jLabel1.setText("Strategy editor");
        jPanel17.add(jLabel1, java.awt.BorderLayout.NORTH);

        jLabel2.setText("Choose a name for this new strategy : ");
        jPanel18.add(jLabel2);

        strategyNameTextField.setColumns(15);
        strategyNameTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                strategyNameTextFieldKeyTyped(evt);
            }
        });

        jPanel18.add(strategyNameTextField);

        jPanel17.add(jPanel18, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel17, java.awt.BorderLayout.NORTH);

        saveButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/save.png")));
        saveButton.setText("Save");
        saveButton.setEnabled(false);
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        jPanel1.add(saveButton);

        okButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/apply.png")));
        okButton.setText("OK");
        okButton.setEnabled(false);
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        jPanel1.add(okButton);

        cancelButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/button_cancel.png")));
        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel1.add(cancelButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel3.setLayout(new java.awt.BorderLayout());

        jPanel3.setPreferredSize(new java.awt.Dimension(160, 131));
        jPanel4.setLayout(new java.awt.GridLayout(1, 3));

        jPanel8.setLayout(new java.awt.BorderLayout());

        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel5.setText("Attack strategies availables");
        jPanel8.add(jLabel5, java.awt.BorderLayout.NORTH);

        jPanel11.setLayout(new java.awt.BorderLayout());

        attackStrategyJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                attackStrategyJListValueChanged(evt);
            }
        });

        jScrollPane7.setViewportView(attackStrategyJList);

        jPanel11.add(jScrollPane7, java.awt.BorderLayout.NORTH);

        jScrollPane8.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        attackStrategyTextArea.setColumns(15);
        attackStrategyTextArea.setEditable(false);
        attackStrategyTextArea.setLineWrap(true);
        attackStrategyTextArea.setRows(5);
        attackStrategyTextArea.setWrapStyleWord(true);
        jScrollPane8.setViewportView(attackStrategyTextArea);

        jPanel11.add(jScrollPane8, java.awt.BorderLayout.CENTER);

        jPanel8.add(jPanel11, java.awt.BorderLayout.CENTER);

        jPanel19.setLayout(new java.awt.BorderLayout());

        addAttackStrategyButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/down.png")));
        addAttackStrategyButton.setText("Add");
        addAttackStrategyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addAttackStrategyButtonActionPerformed(evt);
            }
        });

        jPanel19.add(addAttackStrategyButton, java.awt.BorderLayout.CENTER);

        jLabel3.setText("Memory :");
        jPanel22.add(jLabel3);

        jPanel22.add(memoryAttackSpinner);

        negativeAttackCheckBox.setText("Negative");
        jPanel22.add(negativeAttackCheckBox);

        jPanel19.add(jPanel22, java.awt.BorderLayout.NORTH);

        jPanel8.add(jPanel19, java.awt.BorderLayout.SOUTH);

        jPanel4.add(jPanel8);

        jPanel9.setLayout(new java.awt.BorderLayout());

        jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel6.setText("Asking strategies availables");
        jPanel9.add(jLabel6, java.awt.BorderLayout.NORTH);

        jPanel12.setLayout(new java.awt.BorderLayout());

        jScrollPane10.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        askingStrategyTextArea.setColumns(15);
        askingStrategyTextArea.setEditable(false);
        askingStrategyTextArea.setLineWrap(true);
        askingStrategyTextArea.setRows(5);
        askingStrategyTextArea.setWrapStyleWord(true);
        jScrollPane10.setViewportView(askingStrategyTextArea);

        jPanel12.add(jScrollPane10, java.awt.BorderLayout.SOUTH);

        askingStrategyJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                askingStrategyJListValueChanged(evt);
            }
        });

        jScrollPane9.setViewportView(askingStrategyJList);

        jPanel12.add(jScrollPane9, java.awt.BorderLayout.CENTER);

        jPanel9.add(jPanel12, java.awt.BorderLayout.CENTER);

        jPanel20.setLayout(new java.awt.BorderLayout());

        addAskingStrategyButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/down.png")));
        addAskingStrategyButton.setText("Add");
        addAskingStrategyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addAskingStrategyButtonActionPerformed(evt);
            }
        });

        jPanel20.add(addAskingStrategyButton, java.awt.BorderLayout.CENTER);

        jLabel4.setText("Memory :");
        jPanel23.add(jLabel4);

        jPanel23.add(memoryAskingSpinner);

        negativeAskingCheckBox.setText("Negative");
        jPanel23.add(negativeAskingCheckBox);

        jPanel20.add(jPanel23, java.awt.BorderLayout.NORTH);

        jPanel9.add(jPanel20, java.awt.BorderLayout.SOUTH);

        jPanel4.add(jPanel9);

        jPanel10.setLayout(new java.awt.BorderLayout());

        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel7.setText("Decision strategies availables");
        jPanel10.add(jLabel7, java.awt.BorderLayout.NORTH);

        jPanel13.setLayout(new java.awt.BorderLayout());

        jScrollPane12.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        decisionStrategyTextArea.setColumns(20);
        decisionStrategyTextArea.setEditable(false);
        decisionStrategyTextArea.setLineWrap(true);
        decisionStrategyTextArea.setRows(5);
        decisionStrategyTextArea.setWrapStyleWord(true);
        jScrollPane12.setViewportView(decisionStrategyTextArea);

        jPanel13.add(jScrollPane12, java.awt.BorderLayout.CENTER);

        decisionStrategyJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                decisionStrategyJListValueChanged(evt);
            }
        });

        jScrollPane11.setViewportView(decisionStrategyJList);

        jPanel13.add(jScrollPane11, java.awt.BorderLayout.NORTH);

        jPanel10.add(jPanel13, java.awt.BorderLayout.CENTER);

        jPanel21.setLayout(new java.awt.BorderLayout());

        addDecisionStrategyButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/down.png")));
        addDecisionStrategyButton.setText("Add");
        addDecisionStrategyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addDecisionStrategyButtonActionPerformed(evt);
            }
        });

        jPanel21.add(addDecisionStrategyButton, java.awt.BorderLayout.CENTER);

        jLabel8.setText("Memory :");
        jPanel24.add(jLabel8);

        jPanel24.add(memoryDecisionSpinner);

        negativeDecisionCheckBox.setText("Negative");
        jPanel24.add(negativeDecisionCheckBox);

        jPanel21.add(jPanel24, java.awt.BorderLayout.NORTH);

        jPanel10.add(jPanel21, java.awt.BorderLayout.SOUTH);

        jPanel4.add(jPanel10);

        jPanel3.add(jPanel4, java.awt.BorderLayout.NORTH);

        jPanel2.setLayout(new java.awt.GridLayout(1, 3));

        jPanel5.setLayout(new java.awt.GridLayout(1, 2));

        jScrollPane1.setViewportView(attackJList);

        jPanel5.add(jScrollPane1);

        jPanel14.setLayout(new java.awt.GridBagLayout());

        moveUpAttackButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/up.png")));
        moveUpAttackButton.setText("Move up");
        moveUpAttackButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                moveUpAttackButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel14.add(moveUpAttackButton, gridBagConstraints);

        moveDownAttackButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/down.png")));
        moveDownAttackButton.setText("Move down");
        moveDownAttackButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                moveDownAttackButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        jPanel14.add(moveDownAttackButton, gridBagConstraints);

        removeAttackButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/button_cancel.png")));
        removeAttackButton.setText("Remove");
        removeAttackButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeAttackButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel14.add(removeAttackButton, gridBagConstraints);

        jPanel5.add(jPanel14);

        jPanel2.add(jPanel5);

        jPanel6.setLayout(new java.awt.GridLayout(1, 0));

        jScrollPane2.setViewportView(askingJList);

        jPanel6.add(jScrollPane2);

        jPanel15.setLayout(new java.awt.GridBagLayout());

        moveUpAskingButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/up.png")));
        moveUpAskingButton.setText("Move up");
        moveUpAskingButton.setEnabled(false);
        moveUpAskingButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                moveUpAskingButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel15.add(moveUpAskingButton, gridBagConstraints);

        moveDownAskingButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/down.png")));
        moveDownAskingButton.setText("Move down");
        moveDownAskingButton.setEnabled(false);
        moveDownAskingButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                moveDownAskingButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        jPanel15.add(moveDownAskingButton, gridBagConstraints);

        removeAskingButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/button_cancel.png")));
        removeAskingButton.setText("Remove");
        removeAskingButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeAskingButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel15.add(removeAskingButton, gridBagConstraints);

        jPanel6.add(jPanel15);

        jPanel2.add(jPanel6);

        jPanel7.setLayout(new java.awt.GridLayout(1, 0));

        jScrollPane3.setViewportView(decisionJList);

        jPanel7.add(jScrollPane3);

        jPanel16.setLayout(new java.awt.GridBagLayout());

        moveUpDecisionButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/up.png")));
        moveUpDecisionButton.setText("Move up");
        moveUpDecisionButton.setEnabled(false);
        moveUpDecisionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                moveUpDecisionButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel16.add(moveUpDecisionButton, gridBagConstraints);

        moveDownDecisionButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/down.png")));
        moveDownDecisionButton.setText("Move down");
        moveDownDecisionButton.setEnabled(false);
        moveDownDecisionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                moveDownDecisionButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        jPanel16.add(moveDownDecisionButton, gridBagConstraints);

        removeDecisionButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/button_cancel.png")));
        removeDecisionButton.setText("Remove");
        removeDecisionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeDecisionButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel16.add(removeDecisionButton, gridBagConstraints);

        jPanel7.add(jPanel16);

        jPanel2.add(jPanel7);

        jPanel3.add(jPanel2, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel3, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        // Add your handling code here:
        strategyNameTextField.setText(strategyNameTextField.getText().replaceAll(" ",""));
        editedStrategy = new GenericComposedStrategy();
        if (strategyNameTextField.getText().equals("")) {
            MsgBox msgBox = new MsgBox(null, true, "Enter a valid strategy name","",false);
            msgBox.setVisible(true);
            return;
        }
        editedStrategy.setName(strategyNameTextField.getText());
        editedStrategy.setAttackStrategyVector(new Vector(selectedAttackStrategyList));
        editedStrategy.setAskingStrategyVector(new Vector(selectedAskingStrategyList));
        editedStrategy.setDecisionStrategyVector(new Vector(selectedDecisionStrategyList));
        JFileChooser chooser = new JFileChooser();
        StrategyFileFilter filter = new StrategyFileFilter();
        filter.addExtension("strat");
        filter.setDescription("Strategy file");
        chooser.setFileFilter(filter);
        int returnVal = chooser.showSaveDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            String fileName = chooser.getSelectedFile().getPath();
            try {
                if (simulations.SimulationParameters.debug) {
                    System.out.println("ext = "+fileName.substring(fileName.length()-6,fileName.length()));
                }
                if (!((fileName.substring(fileName.length()-6,fileName.length()-1)).equals(".strat"))) {
                    fileName=fileName+".strat";
                }
                if (simulations.SimulationParameters.debug) {
                    System.out.println(fileName);
                }
            }catch(IndexOutOfBoundsException e) {
            }
            try {
                File f = new File(fileName);
                FileOutputStream fos = new FileOutputStream(f);
                ObjectOutputStream oos = new ObjectOutputStream(fos);
                oos.writeObject(editedStrategy);
                oos.flush();
                oos.close();
            }catch(Exception e) {
                System.out.println(e.toString());
                MsgBox msgBox = new MsgBox(null, true, "Unable to save strategy","",false);
                msgBox.setVisible(true);
            }
        }
    }//GEN-LAST:event_saveButtonActionPerformed

    private void moveDownDecisionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_moveDownDecisionButtonActionPerformed
        // Add your handling code here:
        if (decisionJList.getSelectedValue()!=null) {
            if (selectedDecisionStrategyList.size()>1) {
                if (decisionJList.getSelectedIndex()<(selectedDecisionStrategyList.size()-1)) {
                    int index = decisionJList.getSelectedIndex();
                    selectedDecisionStrategyList.add(selectedDecisionStrategyList.get(index));
                    selectedDecisionStrategyList.set(index, selectedDecisionStrategyList.get(index+1));
                    selectedDecisionStrategyList.set(index+1, selectedDecisionStrategyList.get(selectedDecisionStrategyList.size()-1));
                    selectedDecisionStrategyList.remove(selectedDecisionStrategyList.size()-1);
                    decisionJList.setListData(selectedDecisionStrategyList.toArray());
                }
            }
        }
    }//GEN-LAST:event_moveDownDecisionButtonActionPerformed

    private void moveDownAskingButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_moveDownAskingButtonActionPerformed
        // Add your handling code here:
        if (askingJList.getSelectedValue()!=null) {
            if (selectedAskingStrategyList.size()>1) {
                if (askingJList.getSelectedIndex()<(selectedAskingStrategyList.size()-1)) {
                    int index = askingJList.getSelectedIndex();
                    selectedAskingStrategyList.add(selectedAskingStrategyList.get(index));
                    selectedAskingStrategyList.set(index, selectedAskingStrategyList.get(index+1));
                    selectedAskingStrategyList.set(index+1, selectedAskingStrategyList.get(selectedAskingStrategyList.size()-1));
                    selectedAskingStrategyList.remove(selectedAskingStrategyList.size()-1);
                    askingJList.setListData(selectedAskingStrategyList.toArray());
                }
            }
        }
    }//GEN-LAST:event_moveDownAskingButtonActionPerformed

    private void moveDownAttackButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_moveDownAttackButtonActionPerformed
        // Add your handling code here:
        if (attackJList.getSelectedValue()!=null) {
            if (selectedAttackStrategyList.size()>1) {
                if (attackJList.getSelectedIndex()<(selectedAttackStrategyList.size()-1)) {
                    int index = attackJList.getSelectedIndex();
                    selectedAttackStrategyList.add(selectedAttackStrategyList.get(index));
                    selectedAttackStrategyList.set(index, selectedAttackStrategyList.get(index+1));
                    selectedAttackStrategyList.set(index+1, selectedAttackStrategyList.get(selectedAttackStrategyList.size()-1));
                    selectedAttackStrategyList.remove(selectedAttackStrategyList.size()-1);
                    attackJList.setListData(selectedAttackStrategyList.toArray());
                }
            }
        }
    }//GEN-LAST:event_moveDownAttackButtonActionPerformed

    private void moveUpDecisionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_moveUpDecisionButtonActionPerformed
        // Add your handling code here:
        if (decisionJList.getSelectedValue()!=null) {
            if (selectedDecisionStrategyList.size()>1) {
                if (decisionJList.getSelectedIndex()>0) {
                    int index = decisionJList.getSelectedIndex();
                    selectedDecisionStrategyList.add(selectedDecisionStrategyList.get(index));
                    selectedDecisionStrategyList.set(index, selectedDecisionStrategyList.get(index-1));
                    selectedDecisionStrategyList.set(index-1, selectedDecisionStrategyList.get(selectedDecisionStrategyList.size()-1));
                    selectedDecisionStrategyList.remove(selectedDecisionStrategyList.size()-1);
                    decisionJList.setListData(selectedDecisionStrategyList.toArray());
                }
            }
        }
    }//GEN-LAST:event_moveUpDecisionButtonActionPerformed

    private void moveUpAskingButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_moveUpAskingButtonActionPerformed
        // Add your handling code here:
        if (askingJList.getSelectedValue()!=null) {
            if (selectedAskingStrategyList.size()>1) {
                if (askingJList.getSelectedIndex()>0) {
                    int index = askingJList.getSelectedIndex();
                    selectedAskingStrategyList.add(selectedAskingStrategyList.get(index));
                    selectedAskingStrategyList.set(index, selectedAskingStrategyList.get(index-1));
                    selectedAskingStrategyList.set(index-1, selectedAskingStrategyList.get(selectedAskingStrategyList.size()-1));
                    selectedAskingStrategyList.remove(selectedAskingStrategyList.size()-1);
                    askingJList.setListData(selectedAskingStrategyList.toArray());
                }
            }
        }
    }//GEN-LAST:event_moveUpAskingButtonActionPerformed

    private void moveUpAttackButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_moveUpAttackButtonActionPerformed
        // Add your handling code here:
        if (attackJList.getSelectedValue()!=null) {
            if (selectedAttackStrategyList.size()>1) {
                if (attackJList.getSelectedIndex()>0) {
                    int index = attackJList.getSelectedIndex();
                    selectedAttackStrategyList.add(selectedAttackStrategyList.get(index));
                    selectedAttackStrategyList.set(index, selectedAttackStrategyList.get(index-1));
                    selectedAttackStrategyList.set(index-1, selectedAttackStrategyList.get(selectedAttackStrategyList.size()-1));
                    selectedAttackStrategyList.remove(selectedAttackStrategyList.size()-1);
                    attackJList.setListData(selectedAttackStrategyList.toArray());
                }
            }
        }
    }//GEN-LAST:event_moveUpAttackButtonActionPerformed

    private void removeDecisionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeDecisionButtonActionPerformed
        // Add your handling code here:
        if (decisionJList.getSelectedValue()!=null) {
            selectedDecisionStrategyList.remove(decisionJList.getSelectedValue());
            if ((selectedAskingStrategyList.size()<=0)||
            (selectedAttackStrategyList.size()<=0)||
            (selectedDecisionStrategyList.size()<=0)||
            (strategyNameTextField.getText().equals(""))) {
                okButton.setEnabled(false);
                saveButton.setEnabled(false);
            }
            decisionJList.setListData(selectedDecisionStrategyList.toArray());
        }
    }//GEN-LAST:event_removeDecisionButtonActionPerformed

    private void removeAskingButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeAskingButtonActionPerformed
        // Add your handling code here:
        if (askingJList.getSelectedValue()!=null) {
            selectedAskingStrategyList.remove(askingJList.getSelectedValue());
            if ((selectedAskingStrategyList.size()<=0)||
            (selectedAttackStrategyList.size()<=0)||
            (selectedDecisionStrategyList.size()<=0)||
            (strategyNameTextField.getText().equals(""))) {
                okButton.setEnabled(false);
                saveButton.setEnabled(false);
            }
            askingJList.setListData(selectedAskingStrategyList.toArray());
        }
    }//GEN-LAST:event_removeAskingButtonActionPerformed

    private void removeAttackButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeAttackButtonActionPerformed
        // Add your handling code here:
        if (attackJList.getSelectedValue()!=null) {
            selectedAttackStrategyList.remove(attackJList.getSelectedValue());
            if ((selectedAskingStrategyList.size()<=0)||
            (selectedAttackStrategyList.size()<=0)||
            (selectedDecisionStrategyList.size()<=0)||
            (strategyNameTextField.getText().equals(""))) {
                okButton.setEnabled(false);
                saveButton.setEnabled(false);
            }
            attackJList.setListData(selectedAttackStrategyList.toArray());
        }
    }//GEN-LAST:event_removeAttackButtonActionPerformed

    private void addDecisionStrategyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addDecisionStrategyButtonActionPerformed
        // Add your handling code here:
        if (decisionStrategyJList.getSelectedValue()!=null) {
            if (!(selectedDecisionStrategyList.contains(decisionStrategyJList.getSelectedValue()))) {
                DecisionSupportStrategy strat = (DecisionSupportStrategy)decisionStrategyJList.getSelectedValue();
                int mem = ((Integer)memoryDecisionSpinner.getValue()).intValue();
                strat.setMemory(mem);
                strat.setNegative(negativeDecisionCheckBox.isSelected());
                selectedDecisionStrategyList.add(strat);
                decisionJList.setListData(selectedDecisionStrategyList.toArray());
                if ((selectedAskingStrategyList.size()>0)&&
                (selectedAttackStrategyList.size()>0)&&
                (selectedDecisionStrategyList.size()>0)&&
                (!(strategyNameTextField.getText().equals("")))) {
                    okButton.setEnabled(true);
                    saveButton.setEnabled(true);
                }
            }
        }
    }//GEN-LAST:event_addDecisionStrategyButtonActionPerformed

    private void addAskingStrategyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addAskingStrategyButtonActionPerformed
        // Add your handling code here:
        if (askingStrategyJList.getSelectedValue()!=null) {
            if (!(selectedAskingStrategyList.contains(askingStrategyJList.getSelectedValue()))) {
                AskingStrategy strat = (AskingStrategy)askingStrategyJList.getSelectedValue();
                int mem = ((Integer)memoryAskingSpinner.getValue()).intValue();
                strat.setMemory(mem);
                strat.setNegative(negativeAskingCheckBox.isSelected());
                selectedAskingStrategyList.add(strat);
                askingJList.setListData(selectedAskingStrategyList.toArray());
                if ((selectedAskingStrategyList.size()>0)&&
                (selectedAttackStrategyList.size()>0)&&
                (selectedDecisionStrategyList.size()>0)&&
                (!(strategyNameTextField.getText().equals("")))) {
                    okButton.setEnabled(true);
                    saveButton.setEnabled(true);
                }
            }
        }
    }//GEN-LAST:event_addAskingStrategyButtonActionPerformed

    private void addAttackStrategyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addAttackStrategyButtonActionPerformed
        // Add your handling code here:
        if (attackStrategyJList.getSelectedValue()!=null) {
            if (!(selectedAttackStrategyList.contains(attackStrategyJList.getSelectedValue()))) {
                AttackStrategy strat = (AttackStrategy)attackStrategyJList.getSelectedValue();
                int mem = ((Integer)memoryAttackSpinner.getValue()).intValue();
                strat.setMemory(mem);
                strat.setNegative(negativeAttackCheckBox.isSelected());
                selectedAttackStrategyList.add(strat);
                attackJList.setListData(selectedAttackStrategyList.toArray());
                if ((selectedAskingStrategyList.size()>0)&&
                (selectedAttackStrategyList.size()>0)&&
                (selectedDecisionStrategyList.size()>0)&&
                (!(strategyNameTextField.getText().equals("")))) {
                    okButton.setEnabled(true);
                    saveButton.setEnabled(true);
                }
            }
        }
    }//GEN-LAST:event_addAttackStrategyButtonActionPerformed

    private void decisionStrategyJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_decisionStrategyJListValueChanged
        // Add your handling code here:
        decisionStrategyTextArea.setText(((DecisionSupportStrategy)decisionStrategyJList.getSelectedValue()).getDescription());
    }//GEN-LAST:event_decisionStrategyJListValueChanged

    private void askingStrategyJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_askingStrategyJListValueChanged
        // Add your handling code here:
        askingStrategyTextArea.setText(((AskingStrategy)askingStrategyJList.getSelectedValue()).getDescription());
    }//GEN-LAST:event_askingStrategyJListValueChanged

    private void attackStrategyJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_attackStrategyJListValueChanged
        // Add your handling code here:
        attackStrategyTextArea.setText(((AttackStrategy)attackStrategyJList.getSelectedValue()).getDescription());
    }//GEN-LAST:event_attackStrategyJListValueChanged

    private void strategyNameTextFieldKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_strategyNameTextFieldKeyTyped
        // Add your handling code here:
        if (evt.getKeyChar()==' ') {
            MsgBox msgBox = new MsgBox(null,true,"No space in the strategy's name","",false);
            msgBox.setVisible(true);
            return;
        }
        if (strategyNameTextField.getText().equals("")) {
            okButton.setEnabled(false);
            saveButton.setEnabled(false);
        } else if ((selectedAskingStrategyList.size()>0)&&(selectedAttackStrategyList.size()>0)&&(selectedDecisionStrategyList.size()>0)) {
            okButton.setEnabled(true);
            saveButton.setEnabled(true);
        } else {
            okButton.setEnabled(false);
            saveButton.setEnabled(false);
        }
    }//GEN-LAST:event_strategyNameTextFieldKeyTyped

    /** Method called on a click on ok button
     * @param evt The event
     **/
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // Add your handling code here:
        strategyNameTextField.setText(strategyNameTextField.getText().replaceAll(" ",""));
        editedStrategy = new GenericComposedStrategy();
        if (strategyNameTextField.getText().equals("")) {
            MsgBox msgBox = new MsgBox(null, true, "Enter a valid strategy name","",false);
            msgBox.setVisible(true);
            return;
        }
        editedStrategy.setName(strategyNameTextField.getText());
        editedStrategy.setAttackStrategyVector(new Vector(selectedAttackStrategyList));
        editedStrategy.setAskingStrategyVector(new Vector(selectedAskingStrategyList));
        editedStrategy.setDecisionStrategyVector(new Vector(selectedDecisionStrategyList));
        returnStatus=1;
        closeDialog(null);
    }//GEN-LAST:event_okButtonActionPerformed

    /** Method called on a click on cancel buttton
     * @param evt The event
     **/
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        // Add your handling code here:
        returnStatus=0;
        closeDialog(null);
    }//GEN-LAST:event_cancelButtonActionPerformed
    
    /** Close the dialog
     * @param evt The event
     **/
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    /** Getter for property returnStatus.
     * @return Value of property returnStatus.
     *
     */
    public int getReturnStatus() {
        return returnStatus;
    }    
        
    /** Setter for property returnStatus.
     * @param returnStatus New value of property returnStatus.
     *
     */
    public void setReturnStatus(int returnStatus) {
        this.returnStatus = returnStatus;
    }
    
    /** Getter for property editedStrategy.
     * @return Value of property editedStrategy.
     *
     */
    public simulations.core.strategy.completeStrategy.CompleteStrategy getEditedStrategy() {
        return editedStrategy;
    }
    
    /** Setter for property editedStrategy.
     * @param editedStrategy New value of property editedStrategy.
     *
     */
    public void setEditedStrategy(simulations.core.strategy.completeStrategy.CompleteStrategy editedStrategy) {
        this.editedStrategy = editedStrategy;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addAskingStrategyButton;
    private javax.swing.JButton addAttackStrategyButton;
    private javax.swing.JButton addDecisionStrategyButton;
    private javax.swing.JList askingJList;
    private javax.swing.JList askingStrategyJList;
    private javax.swing.JTextArea askingStrategyTextArea;
    private javax.swing.JList attackJList;
    private javax.swing.JList attackStrategyJList;
    private javax.swing.JTextArea attackStrategyTextArea;
    private javax.swing.JButton cancelButton;
    private javax.swing.JList decisionJList;
    private javax.swing.JList decisionStrategyJList;
    private javax.swing.JTextArea decisionStrategyTextArea;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel16;
    private javax.swing.JPanel jPanel17;
    private javax.swing.JPanel jPanel18;
    private javax.swing.JPanel jPanel19;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel20;
    private javax.swing.JPanel jPanel21;
    private javax.swing.JPanel jPanel22;
    private javax.swing.JPanel jPanel23;
    private javax.swing.JPanel jPanel24;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane10;
    private javax.swing.JScrollPane jScrollPane11;
    private javax.swing.JScrollPane jScrollPane12;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JSpinner memoryAskingSpinner;
    private javax.swing.JSpinner memoryAttackSpinner;
    private javax.swing.JSpinner memoryDecisionSpinner;
    private javax.swing.JButton moveDownAskingButton;
    private javax.swing.JButton moveDownAttackButton;
    private javax.swing.JButton moveDownDecisionButton;
    private javax.swing.JButton moveUpAskingButton;
    private javax.swing.JButton moveUpAttackButton;
    private javax.swing.JButton moveUpDecisionButton;
    private javax.swing.JCheckBox negativeAskingCheckBox;
    private javax.swing.JCheckBox negativeAttackCheckBox;
    private javax.swing.JCheckBox negativeDecisionCheckBox;
    private javax.swing.JButton okButton;
    private javax.swing.JButton removeAskingButton;
    private javax.swing.JButton removeAttackButton;
    private javax.swing.JButton removeDecisionButton;
    private javax.swing.JButton saveButton;
    private javax.swing.JTextField strategyNameTextField;
    // End of variables declaration//GEN-END:variables
    
}
