/*
 * CreateBigTest3Dialog.java
 *
 * Created on 24 juin 2004, 17:07
 */

package simulations.gui;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Random;
import java.util.GregorianCalendar;
import java.util.Calendar;

import javax.swing.JFileChooser;
import javax.swing.SpinnerNumberModel;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import simulations.core.strategy.StrategyLoader;
import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.completeStrategy.*;
import simulations.xml.XMLGameWriter;

import simulations.core.Player;

/**
 *
 * @author  tom
 */
public class CreateBigTest3Dialog extends javax.swing.JDialog {
    
    private ArrayList strategyList;
    
    private ArrayList playersListList;
    
    /** Creates new form CreateBigTest3Dialog */
    public CreateBigTest3Dialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        strategyList = new ArrayList();
        playersListList = new ArrayList();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        rootFolderTextField = new javax.swing.JTextField();
        rootFolderButton = new javax.swing.JButton();
        jLabel7 = new javax.swing.JLabel();
        nbScriptsTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        targetFolderTextField = new javax.swing.JTextField();
        targetFolderButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        saveButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jLabel2.setText("Root folder : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel2, gridBagConstraints);

        rootFolderTextField.setColumns(25);
        rootFolderTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        jPanel2.add(rootFolderTextField, gridBagConstraints);

        rootFolderButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        rootFolderButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        rootFolderButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rootFolderButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        jPanel2.add(rootFolderButton, gridBagConstraints);

        jLabel7.setText("Nb scripts : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        jPanel2.add(jLabel7, gridBagConstraints);

        nbScriptsTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        nbScriptsTextField.setText("10");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(nbScriptsTextField, gridBagConstraints);

        jLabel3.setText("Target folder : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel3, gridBagConstraints);

        targetFolderTextField.setColumns(25);
        targetFolderTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        jPanel2.add(targetFolderTextField, gridBagConstraints);

        targetFolderButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        targetFolderButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        targetFolderButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                targetFolderButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        jPanel2.add(targetFolderButton, gridBagConstraints);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        jLabel1.setFont(new java.awt.Font("Dialog", 1, 18));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Create Second Big test (more that 6000 tests)");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        saveButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/save.png")));
        saveButton.setText("Save");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        jPanel1.add(saveButton);

        closeButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/button_cancel.png")));
        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void initStrat() {
        strategyList.add(new AdvancedCoalitionalDef1Strategy());
        strategyList.add(new AdvancedCoalitionalDef2Strategy());
        strategyList.add(new AdvancedCoalitionalDef3Strategy());
        strategyList.add(new AdvancedCoalitionalDef4Strategy());
        strategyList.add(new AdvancedCoalitionalDef5Strategy());
        strategyList.add(new SimpleCoalitionalDef1Strategy());
        strategyList.add(new SimpleCoalitionalDef2Strategy());
        strategyList.add(new SimpleCoalitionalDef3Strategy());
        strategyList.add(new SimpleCoalitionalDef4Strategy());
        strategyList.add(new SimpleCoalitionalDef5Strategy());
        strategyList.add(new AltruistStrategy());
        strategyList.add(new BadStrategy());
        strategyList.add(new PersistentStrategyMemory0());
        strategyList.add(new PersistentStrategyMemory5());
        strategyList.add(new PersistentStrategyMemory10());
        strategyList.add(new PersistentStrategy2Memory0());
        strategyList.add(new PersistentStrategy2Memory5());
        strategyList.add(new PersistentStrategy2Memory10());
        strategyList.add(new PowerStrategy());
        strategyList.add(new SpitefulStrategyMemory0());
        strategyList.add(new SpitefulStrategyMemory5());
        strategyList.add(new SpitefulStrategyMemory10());
        strategyList.add(new SpitefulStrategy2Memory0());
        strategyList.add(new SpitefulStrategy2Memory5());
        strategyList.add(new SpitefulStrategy2Memory10());
        strategyList.add(new SpitefulStrategy3Memory0());
        strategyList.add(new SpitefulStrategy3Memory5());
        strategyList.add(new SpitefulStrategy3Memory10());
        strategyList.add(new StupidStrategy());
        strategyList.add(new RandomStrategy());
    }
    
    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        // Add your handling code here:
        initStrat();
        while (strategyList.size()>1) {
            CompleteStrategy strat1 = (CompleteStrategy)strategyList.get(0);
            for(int i=1;i<strategyList.size();i++) {
                CompleteStrategy strat2 = (CompleteStrategy)strategyList.get(i);
                ArrayList playersList = new ArrayList();
                for(int j=0;j<15;j++) {
                    playersList.add(new Player("Player #"+j,50,strat1));
                }
                for(int j=15;j<30;j++) {
                    playersList.add(new Player("Player #"+j,50,strat2));
                }
                playersListList.add(playersList);
            }
            strategyList.remove(0);
        }
        System.out.println("playersListList.size() = "+playersListList.size());
        File targetFolder = new File(targetFolderTextField.getText());
        int nbScripts = new Integer(nbScriptsTextField.getText()).intValue();
        int nbGamesBySerie = playersListList.size()/nbScripts+1;
        System.out.println("nbScripts = "+nbScripts);
        System.out.println("nbGamesBySerie = "+nbGamesBySerie);
        for(int i=1;i<=6;i++) {
            File expFolder = new File(targetFolder.getPath()+"/experimentations"+i);
            expFolder.mkdir();
            int cptGame = 0;
            for(int j=1;j<=nbScripts;j++) {
                File serieFolder = new File(expFolder.getPath()+"/serie"+j);
                serieFolder.mkdir();
                File xmlFolder = new File(serieFolder.getPath()+"/xmlGameFiles");
                xmlFolder.mkdir();
                File historyFolder = new File(serieFolder.getPath()+"/history");
                historyFolder.mkdir();
                File graphFolder = new File(serieFolder.getPath()+"/graph");
                graphFolder.mkdir();
                File scriptFolder = new File(serieFolder.getPath()+"/scripts");
                scriptFolder.mkdir();
                FileWriter writer = null;
                try {
                    writer = new FileWriter(new File(scriptFolder.getPath()+"/script.sh"));
                    writer.write("#!/bin/sh\n");
                }catch(IOException e) {
                    System.out.println(e.toString());
                    System.exit(0);
                }
                for(int k=0;k<nbGamesBySerie;k++) {
                    XMLGameWriter xmlWriter = new XMLGameWriter();
                    File xmlFile = new File(xmlFolder+"/game"+cptGame+".xml");
                    try {
                        xmlWriter.create(xmlFile, i-1, 1, 1, 0, 0, 1, false,
                        new File("../history/history"+cptGame+".txt"),
                        new File("../graph/graph"+cptGame+".png"),
                        (ArrayList)playersListList.get(cptGame));
                    }catch(IndexOutOfBoundsException e) {
                        System.out.println("fini");
                        break;
                    }
                    System.out.println("create "+xmlFile.getPath());
                    cptGame++;
                    try {
                        writer.write("echo \"Launching game "+k+" on "+nbGamesBySerie+"\"\n");
                        writer.write("java -jar ../../simulations.jar ../xmlGameFiles/game"+cptGame+".xml -noHistory\n\n");
                    }catch(IOException e) {
                        System.out.println(e.toString());
                        System.exit(0);
                    }
                }
                try {
                    writer.close();
                }catch(IOException e) {
                    System.out.println(e.toString());
                    System.exit(0);
                }
            }
        }
    }//GEN-LAST:event_saveButtonActionPerformed

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed

    private void targetFolderButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_targetFolderButtonActionPerformed
        // Add your handling code here:
        JFileChooser chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            targetFolderTextField.setText(chooser.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_targetFolderButtonActionPerformed

    private void rootFolderButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rootFolderButtonActionPerformed
        // Add your handling code here:
        JFileChooser chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            rootFolderTextField.setText(chooser.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_rootFolderButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTextField nbScriptsTextField;
    private javax.swing.JButton rootFolderButton;
    private javax.swing.JTextField rootFolderTextField;
    private javax.swing.JButton saveButton;
    private javax.swing.JButton targetFolderButton;
    private javax.swing.JTextField targetFolderTextField;
    // End of variables declaration//GEN-END:variables
    
}
