/*
 * CreateTest1Memory.java
 *
 * Created on 8 novembre 2004, 16:01
 */

package simulations.gui;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Random;
import java.util.GregorianCalendar;
import java.util.Calendar;

import javax.swing.JFileChooser;
import javax.swing.SpinnerNumberModel;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import simulations.core.strategy.StrategyLoader;
import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.completeStrategy.GenericComposedStrategy;
import simulations.xml.XMLGameWriter;

import simulations.core.Player;

/**
 *
 * @author  tom
 */
public class CreateTest1Memory extends javax.swing.JDialog {
    
    private ArrayList strategyList;
    
    private File jarFile;
    
    /** Creates new form CreateTest1Memory */
    public CreateTest1Memory(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        randomSeedSpinner.setModel(new SpinnerNumberModel(0,0,10000000,1));
        nbPlayersSpinner.setModel(new SpinnerNumberModel(50,3,10000000,1));
        strategyList = new ArrayList();
    }
    
    private void init() {
        int seed = ((Integer)randomSeedSpinner.getValue()).intValue();
        int nbPlayers = ((Integer)nbPlayersSpinner.getValue()).intValue();
        int hp = 0;
        int nbScripts = 0;
        try {
            nbScripts = new Integer(nbScriptsTextField.getText()).intValue();
            hp = new Integer(playersHPTextField.getText()).intValue();
        }catch(NumberFormatException e) {
            return;
        }
        int coalDef = 0;
        if (coalDef1RadioButton.isSelected()) {
            coalDef=0;
        } else if (coalDef2RadioButton.isSelected()) {
            coalDef=1;
        } else if (coalDef3RadioButton.isSelected()) {
            coalDef=2;
        } else if (coalDef4RadioButton.isSelected()) {
            coalDef=3;
        } else if (coalDef5RadioButton.isSelected()) {
            coalDef=4;
        }
        StrategyLoader loader = new StrategyLoader();
        ArrayList l1 = loader.getAllAttackStrategy();
        ArrayList l2 = loader.getAllAskingStrategy();
        ArrayList l3 = loader.getAllDecisionStrategy();
        ArrayList l11 = new ArrayList();
        ArrayList l12 = new ArrayList();
        ArrayList l13 = new ArrayList();
        Iterator it = l1.iterator();
        // create structs
        File readMe = new File(rootFolderTextField.getText()+"/description.txt");
        try {
            FileWriter readMeWriter = new FileWriter(readMe);
            readMeWriter.write("This folder contains tests series with all strategies of one filter with 1 memory and no complementary\n");
            readMeWriter.write("Seed = "+seed+"\n");
            readMeWriter.close();
        }catch(IOException e) {
            System.out.println(e.toString());
            return;
        }
        try {
            Runtime runTime=Runtime.getRuntime();
            Process process=runTime.exec("cp "+jarFile.getPath()+" "+
            rootFolderTextField.getText());
        }catch(IOException e) {
            System.out.println(e.toString());
            return;
        }
        for(int i=1;i<=nbScripts;i++) {
            File fDir = null;
            fDir = new File(rootFolderTextField.getText()+"/serie"+i);
            fDir.mkdir();
            fDir = new File(rootFolderTextField.getText()+"/serie"+i+"/scripts");
            fDir.mkdir();
            fDir = new File(rootFolderTextField.getText()+"/serie"+i+"/xmlGameFiles");
            fDir.mkdir();
            fDir = new File(rootFolderTextField.getText()+"/serie"+i+"/history");
            fDir.mkdir();
            fDir = new File(rootFolderTextField.getText()+"/serie"+i+"/graph");
            fDir.mkdir();
        }
        //File f = new File(rootFolderTextField.getText()+"");
        while (it.hasNext()) {
            try {
                AttackStrategy attackStrat = (AttackStrategy)it.next();
                if (attackStrat.getName().indexOf("Coalition")>=0) {
                    continue;
                }
                AttackStrategy newStrat1 = (AttackStrategy)attackStrat.getClass().newInstance();

                newStrat1.setName(attackStrat.getName());
                
                newStrat1.setMemory(10);
                newStrat1.setNegative(false);
                l11.add(newStrat1);
                
            }catch(InstantiationException e) {
                System.out.println(e.toString());
            }catch(IllegalAccessException e) {
                System.out.println(e.toString());
            }
        }
        
        it = l2.iterator();
        
        while (it.hasNext()) {
            try {
                AskingStrategy askingStrat = (AskingStrategy)it.next();
                if (askingStrat.getName().indexOf("Coalition")>=0) {
                    continue;
                }
                AskingStrategy newStrat1 = (AskingStrategy)askingStrat.getClass().newInstance();

                newStrat1.setName(askingStrat.getName());
                
                newStrat1.setMemory(10);
                newStrat1.setNegative(false);
                
                l12.add(newStrat1);
            }catch(InstantiationException e) {
                System.out.println(e.toString());
            }catch(IllegalAccessException e) {
                System.out.println(e.toString());
            }
        }
        
        it = l3.iterator();
        
        while (it.hasNext()) {
            try {
                DecisionSupportStrategy decisionStrat = (DecisionSupportStrategy)it.next();
                if (decisionStrat.getName().indexOf("Coalition")>=0) {
                    continue;
                }
                
                DecisionSupportStrategy newStrat1 = (DecisionSupportStrategy)decisionStrat.getClass().newInstance();

                newStrat1.setName(decisionStrat.getName());
                
                newStrat1.setMemory(10);
                newStrat1.setNegative(false);

                l13.add(newStrat1);
            }catch(InstantiationException e) {
                System.out.println(e.toString());
            }catch(IllegalAccessException e) {
                System.out.println(e.toString());
            }
        }
        int nbComb = l11.size()*l12.size()*l13.size();
        System.out.println("attack = "+l11.size());
        System.out.println("asking = "+l12.size());
        System.out.println("decision = "+l13.size());
        System.out.println("nbComb = "+nbComb);
        for(int i=0;i<l11.size();i++) {
            AttackStrategy attackStrat = (AttackStrategy)l11.get(i);
            for(int j=0;j<l12.size();j++) {
                AskingStrategy askingStrat = (AskingStrategy)l12.get(j);
                for(int k=0;k<l13.size();k++) {
                    DecisionSupportStrategy decisionStrat = (DecisionSupportStrategy)l13.get(k);
                    GenericComposedStrategy completeStrat = new GenericComposedStrategy();
                    completeStrat.getAskingStrategyVector().add(askingStrat);
                    completeStrat.getAttackStrategyVector().add(attackStrat);
                    AttackRandomlyStrategy randomStrat = new AttackRandomlyStrategy();
                    completeStrat.getAttackStrategyVector().add(randomStrat);
                    completeStrat.getDecisionStrategyVector().add(decisionStrat);
                    strategyList.add(completeStrat);
                }
            }
        }
        System.out.println("strategyList.size() = "+strategyList.size());
        
        Random random = new Random(0);
        int nbGamesTh = strategyList.size()/nbPlayers+1;
        System.out.println("nbGamesTh = "+nbGamesTh);
        int nbGamesByScript = (nbGamesTh+1)/nbScripts;
        System.out.println("nbGamesByScript = "+nbGamesByScript);
        int cptGame = 0;
        int cptStrat = 0;
        int currentSerie = 1;
        while (strategyList.size()>nbPlayers) {
            int cptPlayer = 0;
            ArrayList playersList = new ArrayList();
            for(int i=0;i<nbPlayers;i++) {
                int ind = random.nextInt(strategyList.size());
                GenericComposedStrategy strat = (GenericComposedStrategy)strategyList.get(ind);
                strat.setName("Strategy #"+cptStrat);
                Player p = new Player("Player #"+cptPlayer,hp,strat);
                strategyList.remove(ind);
                cptPlayer++;
                cptStrat++;
                playersList.add(p);
            }
            File f = new File(rootFolderTextField.getText()+"/serie"+currentSerie+
            "/xmlGameFiles/game"+cptGame+".xml");
            XMLGameWriter gameWriter = new XMLGameWriter();
            gameWriter.create(f, seed, 1, 1, 0, 0, coalDef, false,
            new File("../history/history"+cptGame+".txt"),
            new File("../graph/graph"+cptGame+".png"),
            playersList);
            cptGame++;
            currentSerie = cptGame/nbGamesByScript+1;
        }
        ArrayList playersList = new ArrayList();
        int cptPlayer = 0;
        for(int i=0;i<strategyList.size();i++) {
            GenericComposedStrategy strat = (GenericComposedStrategy)strategyList.get(i);
            strat.setName("Strategy #"+cptStrat);
            cptStrat++;
            playersList.add(new Player("Player #"+cptPlayer,hp,strat));
            cptPlayer++;
        }
        XMLGameWriter gameWriter = new XMLGameWriter();
        File f = new File(rootFolderTextField.getText()+"/serie"+currentSerie+"/xmlGameFiles/game"+cptGame+".xml");
        gameWriter.create(f, seed, 1, 1, 0, 0, coalDef, false,
        new File("../history/history"+cptGame+".txt"),
        new File("../graph/graph"+cptGame+".png"), playersList);
        int nbGames = (cptGame+1);
        System.out.println("nbGames = "+nbGames);
        int cptScript = 1;
        cptGame = 0;
        currentSerie = 1;
        while (cptScript<nbScripts) {
            try {
                File scriptFile = new File(rootFolderTextField.getText()+
                "/serie"+currentSerie+"/scripts/script"+cptScript+".sh");
                FileWriter writer = new FileWriter(scriptFile);
                writer.write("#!/bin/sh\n\n");
                int cpt = 0;
                while (cpt<nbGamesByScript) {
                    writer.write("echo \"Launching game #"+(cpt+1)+" on "+nbGamesByScript+"\"\n");
                    writer.write("java -jar ../../simulations.jar "+
                    "../xmlGameFiles/game"+cptGame+".xml -noHistory\n\n");
                    cptGame++;
                    cpt++;
                    currentSerie = cptGame/nbGamesByScript+1;
                }
                writer.close();
            }catch(IOException e) {
                System.out.println(e.toString());
                return;
            }
            cptScript++;
        }
        try {
            File scriptFile = new File(rootFolderTextField.getText()+
            "/serie"+currentSerie+"/scripts/script"+cptScript+".sh");
            FileWriter writer = new FileWriter(scriptFile);
            writer.write("#!/bin/sh\n\n");
            int cptEcho = 1;
            int remainingGames = nbGames-cptGame;
            while (cptGame<nbGames) {
                writer.write("echo \"Launching game #"+cptEcho+" on "+remainingGames+"\"\n");
                writer.write("java -jar ../../simulations.jar "+
                "../xmlGameFiles/game"+cptGame+".xml -noHistory\n\n");
                cptGame++;
                cptEcho++;
            }
            writer.close();
        }catch(IOException e) {
            System.out.println(e.toString());
            return;
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        rootFolderTextField = new javax.swing.JTextField();
        rootFolderButton = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        randomSeedSpinner = new javax.swing.JSpinner();
        jLabel4 = new javax.swing.JLabel();
        playersHPTextField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        nbPlayersSpinner = new javax.swing.JSpinner();
        jLabel6 = new javax.swing.JLabel();
        coalDef1RadioButton = new javax.swing.JRadioButton();
        coalDef2RadioButton = new javax.swing.JRadioButton();
        coalDef3RadioButton = new javax.swing.JRadioButton();
        coalDef4RadioButton = new javax.swing.JRadioButton();
        coalDef5RadioButton = new javax.swing.JRadioButton();
        jLabel7 = new javax.swing.JLabel();
        nbScriptsTextField = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jarFileTextField = new javax.swing.JTextField();
        jarFileButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        saveButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jLabel2.setText("Root folder : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel2, gridBagConstraints);

        rootFolderTextField.setColumns(25);
        rootFolderTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        jPanel2.add(rootFolderTextField, gridBagConstraints);

        rootFolderButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        rootFolderButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        rootFolderButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rootFolderButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        jPanel2.add(rootFolderButton, gridBagConstraints);

        jLabel3.setText("Random seed : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(randomSeedSpinner, gridBagConstraints);

        jLabel4.setText("Players HP : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel4, gridBagConstraints);

        playersHPTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        playersHPTextField.setText("50");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(playersHPTextField, gridBagConstraints);

        jLabel5.setText("Nb players : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel5, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(nbPlayersSpinner, gridBagConstraints);

        jLabel6.setText("Coalition def : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(jLabel6, gridBagConstraints);

        coalDef1RadioButton.setText("1");
        buttonGroup1.add(coalDef1RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef1RadioButton, gridBagConstraints);

        coalDef2RadioButton.setSelected(true);
        coalDef2RadioButton.setText("2");
        buttonGroup1.add(coalDef2RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef2RadioButton, gridBagConstraints);

        coalDef3RadioButton.setText("3");
        buttonGroup1.add(coalDef3RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef3RadioButton, gridBagConstraints);

        coalDef4RadioButton.setText("4");
        buttonGroup1.add(coalDef4RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef4RadioButton, gridBagConstraints);

        coalDef5RadioButton.setText("5");
        buttonGroup1.add(coalDef5RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef5RadioButton, gridBagConstraints);

        jLabel7.setText("Nb scripts : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        jPanel2.add(jLabel7, gridBagConstraints);

        nbScriptsTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        nbScriptsTextField.setText("1");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(nbScriptsTextField, gridBagConstraints);

        jLabel8.setText("Jar file : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel8, gridBagConstraints);

        jarFileTextField.setColumns(25);
        jarFileTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 10;
        jPanel2.add(jarFileTextField, gridBagConstraints);

        jarFileButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        jarFileButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jarFileButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jarFileButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 10;
        jPanel2.add(jarFileButton, gridBagConstraints);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        jLabel1.setFont(new java.awt.Font("Dialog", 1, 18));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Create test 1 memory (968 strategies)");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        saveButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/save.png")));
        saveButton.setText("Save");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        jPanel1.add(saveButton);

        closeButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/button_cancel.png")));
        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        // Add your handling code here:
        init();
    }//GEN-LAST:event_saveButtonActionPerformed

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed

    private void jarFileButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jarFileButtonActionPerformed
        // Add your handling code here:
        JFileChooser chooser = new JFileChooser();
        StrategyFileFilter filter = new StrategyFileFilter();
        filter.addExtension("jar");
        filter.setDescription("Jar file");
        chooser.setFileFilter(filter);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            String fileName = chooser.getSelectedFile().getPath();
            try {
                System.out.println(fileName);
            }catch(IndexOutOfBoundsException e) {
            }
            jarFile=new File(fileName);
            jarFileTextField.setText(fileName);
        }
    }//GEN-LAST:event_jarFileButtonActionPerformed

    private void rootFolderButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rootFolderButtonActionPerformed
        // Add your handling code here:
        JFileChooser chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            rootFolderTextField.setText(chooser.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_rootFolderButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton closeButton;
    private javax.swing.JRadioButton coalDef1RadioButton;
    private javax.swing.JRadioButton coalDef2RadioButton;
    private javax.swing.JRadioButton coalDef3RadioButton;
    private javax.swing.JRadioButton coalDef4RadioButton;
    private javax.swing.JRadioButton coalDef5RadioButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton jarFileButton;
    private javax.swing.JTextField jarFileTextField;
    private javax.swing.JSpinner nbPlayersSpinner;
    private javax.swing.JTextField nbScriptsTextField;
    private javax.swing.JTextField playersHPTextField;
    private javax.swing.JSpinner randomSeedSpinner;
    private javax.swing.JButton rootFolderButton;
    private javax.swing.JTextField rootFolderTextField;
    private javax.swing.JButton saveButton;
    // End of variables declaration//GEN-END:variables
    
}
