/*
 * GameSummarySaver.java
 *
 * Created on 31 mai 2004, 14:46
 */

package simulations.gui;

import java.util.ArrayList;
import java.util.Vector;
import java.util.Iterator;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import simulations.core.strategy.PlayerIntElement;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;

/**
 *
 * @author  tom
 */
public class GameSummarySaver {
    
    private ArrayList classement;
    
    /** Creates a new instance of GameSummarySaver */
    public GameSummarySaver(ArrayList classement) {
        this.classement=classement;
    }
    
    public void save(File f) {
        try {
            FileWriter writer = new FileWriter(f);
            Iterator it = classement.iterator();
            int cpt = 1;
            while (it.hasNext()) {
                PlayerIntElement elt = (PlayerIntElement)it.next();
                Vector attackVector = elt.getPlayer().getStrategy().getAttackStrategyVector();
                Vector askingVector = elt.getPlayer().getStrategy().getAskingStrategyVector();
                Vector decisionVector = elt.getPlayer().getStrategy().getDecisionStrategyVector();
                writer.write(cpt+"\n"+elt.getPlayer()+"\n"+elt.getNb()+"\n"+elt.getPlayer().getStrategy()+"\n");
                writer.write("attack : \n");
                Iterator it2 = attackVector.iterator();
                while (it2.hasNext()) {
                    AttackStrategy att = (AttackStrategy)it2.next();
                    writer.write(att.getName()+" "+att.getMemory()+" ");
                    if (att.isNegative()) {
                        writer.write("NEGATIVE\n");
                    } else {
                        writer.write("NON-NEGATIVE\n");
                    }
                }
                writer.write("asking : \n");
                it2 = askingVector.iterator();
                while (it2.hasNext()) {
                    AskingStrategy att = (AskingStrategy)it2.next();
                    writer.write(att.getName()+" "+att.getMemory()+" ");
                    if (att.isNegative()) {
                        writer.write("NEGATIVE\n");
                    } else {
                        writer.write("NON-NEGATIVE\n");
                    }
                }
                writer.write("decision : \n");
                it2 = decisionVector.iterator();
                while (it2.hasNext()) {
                    DecisionSupportStrategy att = (DecisionSupportStrategy)it2.next();
                    writer.write(att.getName()+" "+att.getMemory()+" ");
                    if (att.isNegative()) {
                        writer.write("NEGATIVE\n");
                    } else {
                        writer.write("NON-NEGATIVE\n");
                    }
                }
                writer.write("\n");
                cpt++;
            }
            writer.close();
        }catch(IOException e) {
            System.out.println("unable to write in history file");
        }
    }
    
}
