/*
 * GameView.java
 *
 * Created on 20 janvier 2004, 21:00
 */

package simulations.gui;

import simulations.core.Game;
import simulations.core.Player;
import simulations.core.Judge;
import simulations.gui.coalitions.CoalitionView;

import java.util.Iterator;
import java.util.ArrayList;

/** This class draw the global view of the game.
 * @author tom
 */
public class GameView extends javax.swing.JPanel {
    
    private Judge judge;
    
    /** Creates new form GameView */
    public GameView() {
        initComponents();
        judge = new Judge(null);
    }
    
    /** init the jlist of the gameView (with players and their strategy). */    
    public void initJList() {
        if (judge.getGame()!=null) {
            ArrayList l = new ArrayList();
            Iterator it = judge.getGame().getPlayerList().iterator();
            while (it.hasNext()) {
                Player player = (Player)it.next();
                java.lang.String s = new java.lang.String(player.toString()+" : "+player.getHitPoints()+" HP. Playing with "+player.getStrategy().toString());
                l.add(s);
            }
            jPlayerList.setListData(l.toArray());
        }
    }
    
    /**
     * launch the begin of the game.
     * @return Return false if the game has finshed because of the three last turn rule
     */    
    public boolean playGame() {
        boolean b = judge.playGame();
        return b;
    }
    
    /** set coalition view
     * @param view The coalition view
     */
    public void setCoalitionView(CoalitionView view) {
        judge.setCoalitionView(view);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        centerPanel = new javax.swing.JPanel();
        scrollPane = new javax.swing.JScrollPane();
        jPlayerList = new javax.swing.JList();
        upPanel = new javax.swing.JPanel();
        titleLabel = new javax.swing.JLabel();

        setLayout(new java.awt.BorderLayout());

        centerPanel.setLayout(new java.awt.BorderLayout());

        scrollPane.setViewportView(jPlayerList);

        centerPanel.add(scrollPane, java.awt.BorderLayout.CENTER);

        add(centerPanel, java.awt.BorderLayout.CENTER);

        titleLabel.setFont(new java.awt.Font("Dialog", 1, 16));
        titleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        titleLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/ksmiletris.png")));
        titleLabel.setText("Game view");
        upPanel.add(titleLabel);

        add(upPanel, java.awt.BorderLayout.NORTH);

    }//GEN-END:initComponents

    /** Getter for property judge.
     * @return Value of property judge.
     *
     */
    public simulations.core.Judge getJudge() {
        return judge;
    }    

    /** Setter for property judge.
     * @param judge New value of property judge.
     *
     */
    public void setJudge(simulations.core.Judge judge) {
        this.judge = judge;
    }
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel centerPanel;
    private javax.swing.JList jPlayerList;
    private javax.swing.JScrollPane scrollPane;
    private javax.swing.JLabel titleLabel;
    private javax.swing.JPanel upPanel;
    // End of variables declaration//GEN-END:variables
    
}
