/*
 * MakeDuelsTruels210Dialog.java
 *
 * Created on 17 novembre 2004, 21:44
 */

package simulations.gui;

import java.util.ArrayList;
import java.util.Vector;
import java.util.Iterator;
import java.util.Random;
import java.util.GregorianCalendar;
import java.util.Calendar;

import javax.swing.JFileChooser;
import javax.swing.SpinnerNumberModel;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import simulations.core.strategy.StrategyLoader;
import simulations.core.strategy.attackStrategy.*;
import simulations.core.strategy.askingSupportStrategy.*;
import simulations.core.strategy.decisionSupportStrategy.*;
import simulations.core.strategy.completeStrategy.GenericComposedStrategy;
import simulations.xml.XMLGameWriter;

import simulations.core.Player;

/**
 *
 * @author  tom
 */
public class MakeDuelsTruels210Dialog extends javax.swing.JDialog {
    
    private ArrayList strategyList;
    
    private File jarFile;
    
    /** Creates new form MakeDuelsTruels210Dialog */
    public MakeDuelsTruels210Dialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        randomSeedSpinner.setModel(new SpinnerNumberModel(0,0,10000000,1));
        nbPlayersSpinner.setModel(new SpinnerNumberModel(30,3,10000000,1));
        strategyList = new ArrayList();
    }
    
    private void init() {
        int seed = ((Integer)randomSeedSpinner.getValue()).intValue();
        int nbPlayers = ((Integer)nbPlayersSpinner.getValue()).intValue();
        int hp = 0;
        int nbScripts = 0;
        try {
            nbScripts = new Integer(nbScriptsTextField.getText()).intValue();
            hp = new Integer(playersHPTextField.getText()).intValue();
        }catch(NumberFormatException e) {
            System.out.println(e.toString());
            return;
        }
        int coalDef = 0;
        if (coalDef1RadioButton.isSelected()) {
            coalDef=0;
        } else if (coalDef2RadioButton.isSelected()) {
            coalDef=1;
        } else if (coalDef3RadioButton.isSelected()) {
            coalDef=2;
        } else if (coalDef4RadioButton.isSelected()) {
            coalDef=3;
        } else if (coalDef5RadioButton.isSelected()) {
            coalDef=4;
        }
        StrategyLoader loader = new StrategyLoader();
        ArrayList l1 = new ArrayList();
        ArrayList l2 = new ArrayList();
        ArrayList l3 = new ArrayList();
        AttackStrategy as;
        DecisionSupportStrategy ds;
        AskingStrategy aks;
        as = new simulations.core.strategy.attackStrategy.AttackStrongestThanMeStrategy();
        //as.setName("1-");
        l1.add(as);
        as = new simulations.core.strategy.attackStrategy.AttackWeakestThanMeStrategy();
        //as.setName("2-");
        l1.add(as);
        as = new simulations.core.strategy.attackStrategy.AttackStrongestStrategy();
        //as.setName("3-");
        l1.add(as);
        as = new simulations.core.strategy.attackStrategy.AttackWeakestStrategy();
        //as.setName("4-");
        l1.add(as);
        as = new simulations.core.strategy.attackStrategy.AttackAttackedPlayersStrategy();
        //as.setName("5-");
        l1.add(as);
        as = new simulations.core.strategy.attackStrategy.SpitefulAttackStrategy();
        //as.setName("6-");
        l1.add(as);
        aks = new simulations.core.strategy.askingSupportStrategy.AskingEveryoneStrategy();
        //aks.setName("1-");
        l2.add(aks);
        aks = new simulations.core.strategy.askingSupportStrategy.AskingNoBodyStrategy();
        //aks.setName("2-");
        l2.add(aks);
        aks = new simulations.core.strategy.askingSupportStrategy.AskingPlayersDontAttackMeStrategy();
        //aks.setName("3-");
        l2.add(aks);
        aks = new simulations.core.strategy.askingSupportStrategy.AskingStrongestThanMeStrategy();
        //aks.setName("4-");
        l2.add(aks);
        aks = new simulations.core.strategy.askingSupportStrategy.AskingWeakestThanMeStrategy();
        //aks.setName("5-");
        l2.add(aks);
        ds = new simulations.core.strategy.decisionSupportStrategy.AlwaysAcceptToSupportStrategy();
        //ds.setName("1");
        l3.add(ds);
        ds = new simulations.core.strategy.decisionSupportStrategy.NeverAcceptToSupportStrategy();
        //ds.setName("2");
        l3.add(ds);
        ds = new simulations.core.strategy.decisionSupportStrategy.AcceptAttackedPlayersStrongestThanMeStrategy();
        //ds.setName("3");
        l3.add(ds);
        ds = new simulations.core.strategy.decisionSupportStrategy.AcceptAttackedPlayersWeakestThanMeStrategy();
        //ds.setName("4");
        l3.add(ds);
        ds = new simulations.core.strategy.decisionSupportStrategy.AcceptAskingPlayersStrongestThanMe();
        //ds.setName("5");
        l3.add(ds);
        ds = new simulations.core.strategy.decisionSupportStrategy.AcceptAskingPlayersWeakestThanMeStrategy();
        //ds.setName("6");
        l3.add(ds);
        ds = new simulations.core.strategy.decisionSupportStrategy.AcceptPlayersDontAttackMeStrategy();
        //ds.setName("7");
        l3.add(ds);
        ArrayList l11 = new ArrayList();
        ArrayList l12 = new ArrayList();
        ArrayList l13 = new ArrayList();
        Iterator it = l1.iterator();
        // create structs
        File readMeUnels = new File(rootFolderUnelsTextField.getText()+"/description.txt");
        File readMeDuels = new File(rootFolderDuelsTextField.getText()+"/description.txt");
        File readMeTruels = new File(rootFolderTruelsTextField.getText()+"/description.txt");
        try {
            if (checkUnels.isSelected()) {
                FileWriter readMeUnelsWriter = new FileWriter(readMeUnels);
                readMeUnelsWriter.write("This folder contains tests series with all 210 strategies with unels\n");
                readMeUnelsWriter.write("Seed = "+seed+"\n");
                readMeUnelsWriter.close();
                Runtime runTime=Runtime.getRuntime();
                Process process=runTime.exec("cp "+jarFile.getPath()+" "+
                rootFolderUnelsTextField.getText());
            }
            if (checkDuels.isSelected()) {
                FileWriter readMeDuelsWriter = new FileWriter(readMeDuels);
                readMeDuelsWriter.write("This folder contains tests series with all 210 strategies with duels\n");
                readMeDuelsWriter.write("Seed = "+seed+"\n");
                readMeDuelsWriter.close();
                Runtime runTime=Runtime.getRuntime();
                Process process=runTime.exec("cp "+jarFile.getPath()+" "+
                rootFolderDuelsTextField.getText());
            }
            if (checkTruels.isSelected()) {
                FileWriter readMeTruelsWriter = new FileWriter(readMeTruels);
                readMeTruelsWriter.write("This folder contains tests series with all 210 strategies with truels\n");
                readMeTruelsWriter.write("Seed = "+seed+"\n");
                readMeTruelsWriter.close();
                Runtime runTime=Runtime.getRuntime();
                Process process=runTime.exec("cp "+jarFile.getPath()+" "+
                rootFolderTruelsTextField.getText());
            }
        }catch(IOException e) {
            System.out.println(e.toString());
        }
        if (checkUnels.isSelected()) {
            File fDir = null;
            fDir = new File(rootFolderUnelsTextField.getText()+"/serie1");
            fDir.mkdir();
            fDir = new File(rootFolderUnelsTextField.getText()+"/serie1/scripts");
            fDir.mkdir();
            fDir = new File(rootFolderUnelsTextField.getText()+"/serie1/xmlGameFiles");
            fDir.mkdir();
            fDir = new File(rootFolderUnelsTextField.getText()+"/serie1/history");
            fDir.mkdir();
            fDir = new File(rootFolderUnelsTextField.getText()+"/serie1/graph");
            fDir.mkdir();
        }
        if (checkDuels.isSelected()) {
            for(int i=1;i<=150;i++) {
                File fDir = null;
                fDir = new File(rootFolderDuelsTextField.getText()+"/serie"+i);
                fDir.mkdir();
                fDir = new File(rootFolderDuelsTextField.getText()+"/serie"+i+"/scripts");
                fDir.mkdir();
                fDir = new File(rootFolderDuelsTextField.getText()+"/serie"+i+"/xmlGameFiles");
                fDir.mkdir();
                fDir = new File(rootFolderDuelsTextField.getText()+"/serie"+i+"/history");
                fDir.mkdir();
                fDir = new File(rootFolderDuelsTextField.getText()+"/serie"+i+"/graph");
                fDir.mkdir();
            }
        }
        if (checkTruels.isSelected()) {
            for(int i=1;i<=60;i++) {
                File fDir = null;
                fDir = new File(rootFolderTruelsTextField.getText()+"/serie"+i);
                fDir.mkdir();
                fDir = new File(rootFolderTruelsTextField.getText()+"/serie"+i+"/scripts");
                fDir.mkdir();
                fDir = new File(rootFolderTruelsTextField.getText()+"/serie"+i+"/xmlGameFiles");
                fDir.mkdir();
                fDir = new File(rootFolderTruelsTextField.getText()+"/serie"+i+"/history");
                fDir.mkdir();
                fDir = new File(rootFolderTruelsTextField.getText()+"/serie"+i+"/graph");
                fDir.mkdir();
            }
        }
        while (it.hasNext()) {
            try {
                AttackStrategy attackStrat = (AttackStrategy)it.next();
                if (attackStrat.getName().indexOf("Coalition")>=0) {
                    continue;
                }
                AttackStrategy newStrat1 = (AttackStrategy)attackStrat.getClass().newInstance();
                newStrat1.setName(attackStrat.getName());
                newStrat1.setMemory(0);
                newStrat1.setNegative(false);
                l11.add(newStrat1);
            }catch(InstantiationException e) {
                System.out.println(e.toString());
            }catch(IllegalAccessException e) {
                System.out.println(e.toString());
            }
        }
        
        it = l2.iterator();
        
        while (it.hasNext()) {
            try {
                AskingStrategy askingStrat = (AskingStrategy)it.next();
                if (askingStrat.getName().indexOf("Coalition")>=0) {
                    continue;
                }
                AskingStrategy newStrat1 = (AskingStrategy)askingStrat.getClass().newInstance();

                newStrat1.setName(askingStrat.getName());
                
                newStrat1.setMemory(0);
                newStrat1.setNegative(false);
                l12.add(newStrat1);
            }catch(InstantiationException e) {
                System.out.println(e.toString());
            }catch(IllegalAccessException e) {
                System.out.println(e.toString());
            }
        }
        
        it = l3.iterator();
        
        while (it.hasNext()) {
            try {
                DecisionSupportStrategy decisionStrat = (DecisionSupportStrategy)it.next();
                if (decisionStrat.getName().indexOf("Coalition")>=0) {
                    continue;
                }                
                DecisionSupportStrategy newStrat1 = (DecisionSupportStrategy)decisionStrat.getClass().newInstance();

                newStrat1.setName(decisionStrat.getName());
                
                newStrat1.setMemory(0);
                newStrat1.setNegative(false);
                l13.add(newStrat1);
            }catch(InstantiationException e) {
                System.out.println(e.toString());
            }catch(IllegalAccessException e) {
                System.out.println(e.toString());
            }
        }
        int nbComb = l11.size()*l12.size()*l13.size();
        System.out.println("attack = "+l11.size());
        System.out.println("asking = "+l12.size());
        System.out.println("decision = "+l13.size());
        System.out.println("nbComb = "+nbComb);
        for(int i=0;i<l11.size();i++) {
            AttackStrategy attackStrat = (AttackStrategy)l11.get(i);
            for(int j=0;j<l12.size();j++) {
                AskingStrategy askingStrat = (AskingStrategy)l12.get(j);
                for(int k=0;k<l13.size();k++) {
                    DecisionSupportStrategy decisionStrat = (DecisionSupportStrategy)l13.get(k);
                    GenericComposedStrategy completeStrat = new GenericComposedStrategy();
                    completeStrat.getAskingStrategyVector().add(askingStrat);
                    completeStrat.getAttackStrategyVector().add(attackStrat);
                    AttackRandomlyStrategy randomStrat = new AttackRandomlyStrategy();
                    completeStrat.getAttackStrategyVector().add(randomStrat);
                    completeStrat.getDecisionStrategyVector().add(decisionStrat);
                    completeStrat.setName(getEasyName(completeStrat));
                    strategyList.add(completeStrat);
                }
            }
        }
        System.out.println("strategyList.size() = "+strategyList.size());
        if (checkUnels.isSelected()) {
            makeUnels(hp,coalDef,seed);
        }
        if (checkDuels.isSelected()) {
            makeDuels(hp,coalDef,seed);
        }
        if (checkTruels.isSelected()) {
            makeTruels(hp,coalDef,seed);
        }
    }
    
    private void makeUnels(int hp, int coalDef, long seed) {
        int cptStrat = 0;
        int exSerie = 1;
        int cptGame = 0;
        // cration des parties
        // Construction de la liste des joueurs
        for(int game1=0;game1<strategyList.size();game1++) {
            ArrayList playersList = new ArrayList();
            GenericComposedStrategy strat1 = (GenericComposedStrategy)strategyList.get(game1);
            for(int i=1;i<=20;i++) {
                Player p = new Player("Player #"+i+"("+strat1.getName()+")",hp,strat1);
                playersList.add(p);
            }
            File f = new File(rootFolderUnelsTextField.getText()+"/serie1"+
            "/xmlGameFiles/game"+cptGame+".xml");
            XMLGameWriter gameWriter = new XMLGameWriter();
            gameWriter.create(f,seed, 1, 1, 0, 0, coalDef, false,
            new File("../history/history"+cptGame+".txt"),
            new File("../graph/graph"+cptGame+".png"),
            playersList);
            cptGame++;
        }
        try {
            File testFolder = new File(rootFolderUnelsTextField.getText());
            File series[] = testFolder.listFiles();
            for(int i=0;i<series.length;i++) {
                if (series[i].isDirectory()) {
                    File gamesFolder = new File(series[i].getAbsolutePath()+"/xmlGameFiles");
                    File games[] = gamesFolder.listFiles();
                    File scriptFile = new File(series[i].getAbsolutePath()+"/scripts/script.sh");
                    FileWriter scriptWriter = new FileWriter(scriptFile);
                    scriptWriter.write("#!/bin/sh\n\n");
                    for(int j=0;j<games.length;j++) {
                        scriptWriter.write("echo \"Launching game #"+j+" on "+games.length+"\"\n");
                        scriptWriter.write("java -jar ../../simulations.jar "+
                        "../xmlGameFiles/"+games[j].getName()+" -noHistory\n\n");
                    }
                    scriptWriter.close();
                    Runtime runTime=Runtime.getRuntime();
                    Process process=runTime.exec("chmod +x "+scriptFile.getAbsolutePath());
                }
            }
        }catch(IOException e) {
            System.out.println(e.toString());
            return;
        }
    }
    
    private void makeDuels(int hp, int coalDef, long seed) {
        int cptStrat = 0;
        int currentSerie = 1;
        int exSerie = 1;
        int nbGamesBySerie = (210*210)/150;
        int cptGame = 0;
        // cration des parties
        // Construction de la liste des joueurs
        for(int game1=0;game1<strategyList.size();game1++) {
            for(int game2=0;game2<strategyList.size();game2++) {
               if (game1!=game2) {
                   ArrayList playersList = new ArrayList();
                   GenericComposedStrategy strat1 = (GenericComposedStrategy)strategyList.get(game1);
                   GenericComposedStrategy strat2 = (GenericComposedStrategy)strategyList.get(game2);
                   for(int i=1;i<=10;i++) {
                        Player p = new Player("Player #"+i+"("+strat1.getName()+")",hp,strat1);
                        playersList.add(p);
                   }
                   for(int i=11;i<=20;i++) {
                       Player p = new Player("Player #"+i+"("+strat2.getName()+")",hp,strat2);
                       playersList.add(p);
                   }
                   currentSerie = cptGame/nbGamesBySerie+1;
                   File f = new File(rootFolderDuelsTextField.getText()+"/serie"+currentSerie+
                   "/xmlGameFiles/game"+cptGame+".xml");
                   XMLGameWriter gameWriter = new XMLGameWriter();
                   gameWriter.create(f,seed, 1, 1, 0, 0, coalDef, false,
                   new File("../history/history"+cptGame+".txt"),
                   new File("../graph/graph"+cptGame+".png"),
                   playersList);
                   cptGame++;
                }
            }
        }
        try {
            File testFolder = new File(rootFolderDuelsTextField.getText());
            File series[] = testFolder.listFiles();
            for(int i=0;i<series.length;i++) {
                if (series[i].isDirectory()) {
                    File gamesFolder = new File(series[i].getAbsolutePath()+"/xmlGameFiles");
                    File games[] = gamesFolder.listFiles();
                    File scriptFile = new File(series[i].getAbsolutePath()+"/scripts/script.sh");
                    FileWriter scriptWriter = new FileWriter(scriptFile);
                    scriptWriter.write("#!/bin/sh\n\n");
                    for(int j=0;j<games.length;j++) {
                        scriptWriter.write("echo \"Launching game #"+j+" on "+games.length+"\"\n");
                        scriptWriter.write("java -jar ../../simulations.jar "+
                        "../xmlGameFiles/"+games[j].getName()+" -noHistory\n\n");
                    }
                    scriptWriter.close();
                    Runtime runTime=Runtime.getRuntime();
                    Process process=runTime.exec("chmod +x "+scriptFile.getAbsolutePath());
                }
            }
        }catch(IOException e) {
            System.out.println(e.toString());
            return;
        }
    }
    
    private void makeTruels(int hp, int coalDef, long seed) {
        int cptStrat = 0;
        int currentSerie = 1;
        int exSerie = 1;
        int nbGamesBySerie = (210*209*208)/60;
        int cptGame = 0;
        // cration des parties
        // Construction de la liste des joueurs
        for(int game1=0;game1<strategyList.size();game1++) {
            for(int game2=0;game2<strategyList.size();game2++) {
                for(int game3=0;game3<strategyList.size();game3++) {
                    if ((game1!=game2)&&(game2!=game3)&&(game1!=game3)) {
                        ArrayList playersList = new ArrayList();
                        GenericComposedStrategy strat1 = (GenericComposedStrategy)strategyList.get(game1);
                        GenericComposedStrategy strat2 = (GenericComposedStrategy)strategyList.get(game2);
                        GenericComposedStrategy strat3 = (GenericComposedStrategy)strategyList.get(game3);
                        for(int i=1;i<=10;i++) {
                            Player p = new Player("Player #"+i+"("+strat1.getName()+")",hp,strat1);
                            playersList.add(p);
                       }
                       for(int i=11;i<=20;i++) {
                           Player p = new Player("Player #"+i+"("+strat2.getName()+")",hp,strat2);
                           playersList.add(p);
                       }
                        for(int i=21;i<=30;i++) {
                           Player p = new Player("Player #"+i+"("+strat3.getName()+")",hp,strat3);
                           playersList.add(p);
                       }
                       currentSerie = cptGame/nbGamesBySerie+1;
                       File f = new File(rootFolderTruelsTextField.getText()+"/serie"+currentSerie+
                       "/xmlGameFiles/game"+cptGame+".xml");
                       XMLGameWriter gameWriter = new XMLGameWriter();
                       gameWriter.create(f,seed, 1, 1, 0, 0, coalDef, false,
                       new File("../history/history"+cptGame+".txt"),
                       new File("../graph/graph"+cptGame+".png"),
                       playersList);
                       cptGame++;
                    }
                }
            }
        }
        try {
            File testFolder = new File(rootFolderTruelsTextField.getText());
            File series[] = testFolder.listFiles();
            for(int i=0;i<series.length;i++) {
                if (series[i].isDirectory()) {
                    File gamesFolder = new File(series[i].getAbsolutePath()+"/xmlGameFiles");
                    File games[] = gamesFolder.listFiles();
                    File scriptFile = new File(series[i].getAbsolutePath()+"/scripts/script.sh");
                    FileWriter scriptWriter = new FileWriter(scriptFile);
                    scriptWriter.write("#!/bin/sh\n\n");
                    for(int j=0;j<games.length;j++) {
                        scriptWriter.write("echo \"Launching game #"+j+" on "+games.length+"\"\n");
                        scriptWriter.write("java -jar ../../simulations.jar "+
                        "../xmlGameFiles/"+games[j].getName()+" -noHistory\n\n");
                    }
                    scriptWriter.close();
                    Runtime runTime=Runtime.getRuntime();
                    Process process=runTime.exec("chmod +x "+scriptFile.getAbsolutePath());
                }
            }
        }catch(IOException e) {
            System.out.println(e.toString());
            return;
        }
    }
    
    public String getEasyName(GenericComposedStrategy strat) {
        Vector attVector = strat.getAttackStrategyVector();
        Vector askVector = strat.getAskingStrategyVector();
        Vector decVector = strat.getDecisionStrategyVector();
        String str;
        str = ((AttackStrategy)attVector.get(0)).getAbr()+"-"+
        ((AskingStrategy)askVector.get(0)).getAbr()+"-"+
        ((DecisionSupportStrategy)decVector.get(0)).getAbr();
        return str;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        rootFolderDuelsTextField = new javax.swing.JTextField();
        rootFolderDuelsButton = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        randomSeedSpinner = new javax.swing.JSpinner();
        jLabel4 = new javax.swing.JLabel();
        playersHPTextField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        nbPlayersSpinner = new javax.swing.JSpinner();
        jLabel6 = new javax.swing.JLabel();
        coalDef1RadioButton = new javax.swing.JRadioButton();
        coalDef2RadioButton = new javax.swing.JRadioButton();
        coalDef3RadioButton = new javax.swing.JRadioButton();
        coalDef4RadioButton = new javax.swing.JRadioButton();
        coalDef5RadioButton = new javax.swing.JRadioButton();
        jLabel7 = new javax.swing.JLabel();
        nbScriptsTextField = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jarFileTextField = new javax.swing.JTextField();
        jarFileButton = new javax.swing.JButton();
        jLabel9 = new javax.swing.JLabel();
        rootFolderTruelsTextField = new javax.swing.JTextField();
        rootFolderTruelsButton = new javax.swing.JButton();
        jLabel10 = new javax.swing.JLabel();
        rootFolderUnelsTextField = new javax.swing.JTextField();
        rootFolderUnelsButton = new javax.swing.JButton();
        checkUnels = new javax.swing.JCheckBox();
        checkDuels = new javax.swing.JCheckBox();
        checkTruels = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        saveButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jPanel2.setLayout(new java.awt.GridBagLayout());

        jLabel2.setText("Root folder for duels : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel2, gridBagConstraints);

        rootFolderDuelsTextField.setColumns(25);
        rootFolderDuelsTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        jPanel2.add(rootFolderDuelsTextField, gridBagConstraints);

        rootFolderDuelsButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        rootFolderDuelsButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        rootFolderDuelsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rootFolderDuelsButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        jPanel2.add(rootFolderDuelsButton, gridBagConstraints);

        jLabel3.setText("Random seed : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(randomSeedSpinner, gridBagConstraints);

        jLabel4.setText("Players HP : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel4, gridBagConstraints);

        playersHPTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        playersHPTextField.setText("50");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(playersHPTextField, gridBagConstraints);

        jLabel5.setText("Nb players : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel5, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(nbPlayersSpinner, gridBagConstraints);

        jLabel6.setText("Coalition def : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(jLabel6, gridBagConstraints);

        coalDef1RadioButton.setSelected(true);
        coalDef1RadioButton.setText("1");
        buttonGroup1.add(coalDef1RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef1RadioButton, gridBagConstraints);

        coalDef2RadioButton.setText("2");
        buttonGroup1.add(coalDef2RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef2RadioButton, gridBagConstraints);

        coalDef3RadioButton.setText("3");
        buttonGroup1.add(coalDef3RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef3RadioButton, gridBagConstraints);

        coalDef4RadioButton.setText("4");
        buttonGroup1.add(coalDef4RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef4RadioButton, gridBagConstraints);

        coalDef5RadioButton.setText("5");
        buttonGroup1.add(coalDef5RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef5RadioButton, gridBagConstraints);

        jLabel7.setText("Nb scripts : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(jLabel7, gridBagConstraints);

        nbScriptsTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        nbScriptsTextField.setText("20");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 11;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(nbScriptsTextField, gridBagConstraints);

        jLabel8.setText("Jar file : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 12;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel8, gridBagConstraints);

        jarFileTextField.setColumns(25);
        jarFileTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 12;
        jPanel2.add(jarFileTextField, gridBagConstraints);

        jarFileButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        jarFileButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jarFileButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jarFileButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 12;
        jPanel2.add(jarFileButton, gridBagConstraints);

        jLabel9.setText("Root folder for truels : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel9, gridBagConstraints);

        rootFolderTruelsTextField.setColumns(25);
        rootFolderTruelsTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        jPanel2.add(rootFolderTruelsTextField, gridBagConstraints);

        rootFolderTruelsButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        rootFolderTruelsButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        rootFolderTruelsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rootFolderTruelsButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        jPanel2.add(rootFolderTruelsButton, gridBagConstraints);

        jLabel10.setText("Root folder for unels : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel10, gridBagConstraints);

        rootFolderUnelsTextField.setColumns(25);
        rootFolderUnelsTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        jPanel2.add(rootFolderUnelsTextField, gridBagConstraints);

        rootFolderUnelsButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        rootFolderUnelsButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        rootFolderUnelsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rootFolderUnelsButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        jPanel2.add(rootFolderUnelsButton, gridBagConstraints);

        checkUnels.setText("Unels");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 13;
        jPanel2.add(checkUnels, gridBagConstraints);

        checkDuels.setText("Duels");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 13;
        jPanel2.add(checkDuels, gridBagConstraints);

        checkTruels.setText("Truels");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 13;
        jPanel2.add(checkTruels, gridBagConstraints);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        jLabel1.setFont(new java.awt.Font("Dialog", 1, 18));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Make unels, duels & truels");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        saveButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/save.png")));
        saveButton.setText("Save");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        jPanel1.add(saveButton);

        closeButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/button_cancel.png")));
        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void rootFolderUnelsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rootFolderUnelsButtonActionPerformed
        // TODO add your handling code here:
        JFileChooser chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            rootFolderUnelsTextField.setText(chooser.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_rootFolderUnelsButtonActionPerformed

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        // TODO add your handling code here:
        init();
    }//GEN-LAST:event_saveButtonActionPerformed

    private void jarFileButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jarFileButtonActionPerformed
        // TODO add your handling code here:
        JFileChooser chooser = new JFileChooser();
        StrategyFileFilter filter = new StrategyFileFilter();
        filter.addExtension("jar");
        filter.setDescription("Jar file");
        chooser.setFileFilter(filter);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            String fileName = chooser.getSelectedFile().getPath();
            try {
                System.out.println(fileName);
            }catch(IndexOutOfBoundsException e) {
            }
            jarFile=new File(fileName);
            jarFileTextField.setText(fileName);
        }
    }//GEN-LAST:event_jarFileButtonActionPerformed

    private void rootFolderTruelsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rootFolderTruelsButtonActionPerformed
        // TODO add your handling code here:
        JFileChooser chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            rootFolderTruelsTextField.setText(chooser.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_rootFolderTruelsButtonActionPerformed

    private void rootFolderDuelsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rootFolderDuelsButtonActionPerformed
        // TODO add your handling code here:
        JFileChooser chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            rootFolderDuelsTextField.setText(chooser.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_rootFolderDuelsButtonActionPerformed

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // TODO add your handling code here:
        this.setVisible(false);
        this.dispose();
    }//GEN-LAST:event_closeButtonActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JCheckBox checkDuels;
    private javax.swing.JCheckBox checkTruels;
    private javax.swing.JCheckBox checkUnels;
    private javax.swing.JButton closeButton;
    private javax.swing.JRadioButton coalDef1RadioButton;
    private javax.swing.JRadioButton coalDef2RadioButton;
    private javax.swing.JRadioButton coalDef3RadioButton;
    private javax.swing.JRadioButton coalDef4RadioButton;
    private javax.swing.JRadioButton coalDef5RadioButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton jarFileButton;
    private javax.swing.JTextField jarFileTextField;
    private javax.swing.JSpinner nbPlayersSpinner;
    private javax.swing.JTextField nbScriptsTextField;
    private javax.swing.JTextField playersHPTextField;
    private javax.swing.JSpinner randomSeedSpinner;
    private javax.swing.JButton rootFolderDuelsButton;
    private javax.swing.JTextField rootFolderDuelsTextField;
    private javax.swing.JButton rootFolderTruelsButton;
    private javax.swing.JTextField rootFolderTruelsTextField;
    private javax.swing.JButton rootFolderUnelsButton;
    private javax.swing.JTextField rootFolderUnelsTextField;
    private javax.swing.JButton saveButton;
    // End of variables declaration//GEN-END:variables
    
}
