/*
 * ColorsDialog.java
 *
 * Created on April 5, 2004, 2:45 AM
 */

package simulations.gui.curves;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JLabel;
import java.util.Iterator;
import java.util.Vector;
import simulations.core.Player;

/** This class describes a dialog box to show the colors associations of the
 * player's curves
 * @author tom
 */
public class ColorsDialog extends javax.swing.JDialog {
    
    /** The center panel **/
    private JPanel centerPanel;
    
    /** The center scrollPane **/
    private JScrollPane scrollPane;
    
    /** Creates new form ColorsDialog
     * @param parent The parent window
     * @param modal True if the dialog is modal
     * @param data The data containing the color to display
     */
    public ColorsDialog(java.awt.Frame parent, boolean modal, CurvesData data) {
        super(parent, modal);
        centerPanel = new JPanel();
        scrollPane = new JScrollPane();
        scrollPane.setViewportView(centerPanel);
        this.getContentPane().add(scrollPane, java.awt.BorderLayout.CENTER);
        centerPanel.setLayout(new java.awt.GridLayout(data.getData().size()+1,3));
        centerPanel.setBackground(new java.awt.Color(255, 255, 255));
        //System.out.println("colorVector.size()+1 = "+(colorVector.size()+1));
        centerPanel.add(new JLabel("Player"));
        centerPanel.add(new JLabel("Color"));
        centerPanel.add(new JLabel("Strategy"));
        Iterator it = data.getData().iterator();
        while (it.hasNext()) {
            CurvesPlayerData elt = (CurvesPlayerData)it.next();
            centerPanel.add(new JLabel(((Player)elt.getPlayer()).getName()));
            JLabel colorLabel = new JLabel("----------");
            colorLabel.setForeground(elt.getColor());
            centerPanel.add(colorLabel);
            centerPanel.add(new JLabel(((Player)elt.getPlayer()).getStrategy().toString()));
        }
        scrollPane.setViewportView(centerPanel);
        this.getContentPane().add(scrollPane, java.awt.BorderLayout.CENTER);
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        closeButton = new javax.swing.JButton();

        setTitle("Colors for graph");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        closeButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/button_cancel.png")));
        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
