/*
 * CurvesDialog.java
 *
 * Created on April 2, 2004, 4:43 AM
 */

package simulations.gui.curves;

import simulations.gui.StrategyFileFilter;
import simulations.core.strategy.PlayerIntElement;

import java.util.ArrayList;
import java.util.Iterator;
import java.awt.Graphics;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.SpinnerNumberModel;
import javax.swing.JFileChooser;
import java.io.File;
import java.io.IOException;
import java.awt.Toolkit;
import java.awt.Rectangle;
import javax.imageio.ImageIO;
import java.awt.Image;
import java.awt.image.RenderedImage;
import java.awt.Point;
import java.awt.Cursor;

/**
 * This class describes the view of the curves of differents players points
 * @author  tom
 */
public class CurvesDialog extends javax.swing.JDialog implements Runnable {
    
    /** The canvas containing the curves **/
    //private CurvesCanvas centerCanvas;
    
    private CurvesPanel centerPanel;
    
    /** The cursor to display when zoom in option is enabled **/
    private Cursor zoomInCursor;
    
    /** The cursor to display when zoom out option is enabled **/
    private Cursor zoomOutCursor;
    
    /** The max pts (y) **/
    private int maxPoints;
    
    /** The max turn (x) **/
    private int maxTurn;
    
    /** The list of the selected players **/
    private ArrayList selectedPlayers;
    
    /**
     * Creates new form CurvesDialog
     * @param classement The ordoned players list
     * @param l The list of playerList
     * @param parent The parent window
     * @param modal True if the dialog is modal
     */
    public CurvesDialog(java.awt.Frame parent, boolean modal, ArrayList classement, ArrayList l) {
        super(parent, modal);
        selectedPlayers=new ArrayList();
        initComponents();
        maxTurn=l.size()-1;
        /**centerCanvas = new CurvesCanvas(playerList, l);
         * centerCanvas.addMouseListener(new java.awt.event.MouseAdapter() {
         * public void mouseClicked(java.awt.event.MouseEvent evt) {
         * centerCanvasMouseClicked(evt);
         * }
         * });**/
        if (simulations.SimulationParameters.debug) {
            System.out.println("New CurvesPanel OK");
        }
        //getContentPane().add(centerCanvas, java.awt.BorderLayout.CENTER);
        centerPanel = new CurvesPanel(classement,l);
        initJList(classement);
        centerPanel.setMaxX(l.size()-1);
        centerPanel.setMaxY((int)centerPanel.getMaxPlayersPoints());
        centerPanel.setMinX(0);
        centerPanel.setMinY(0);
        getContentPane().add(centerPanel,java.awt.BorderLayout.CENTER);
        Image zoomInImg = new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/zoomin.png")).getImage();
        zoomInCursor = null;
        Toolkit tk = getToolkit();
        Point point = new Point(5,5);
        zoomInCursor = tk.createCustomCursor(zoomInImg,point, "ZoomIn");
        Image zoomOutImg = new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/zoomout.png")).getImage();
        zoomOutCursor = null;
        zoomOutCursor = tk.createCustomCursor(zoomOutImg, point, "ZoomOut");
        //maxPoints = (int)centerCanvas.getMaxPoints();
        maxPoints = (int)centerPanel.getMaxPlayersPoints();
        try {
            minPointSpinner.setModel(new SpinnerNumberModel(0,0,maxPoints,1));
            maxPointSpinner.setModel(new SpinnerNumberModel(maxPoints,1,maxPoints,1));
            minTurnSpinner.setModel(new SpinnerNumberModel(0,0,l.size()-2,1));
            maxTurnSpinner.setModel(new SpinnerNumberModel(l.size()-1,1,l.size()-1,1));
        }catch(IllegalArgumentException e) {
            
        }
        //this.pack();
        this.setSize(900,680);
    }
    
    /** initialize the players JList **/
    private void initJList(ArrayList l) {
        Iterator it = l.iterator();
        ArrayList l2 = new ArrayList();
        while (it.hasNext()) {
            PlayerIntElement elt = (PlayerIntElement)it.next();
            l2.add(elt.getPlayer());
        }
        playerJList.setListData(l2.toArray());
        playerJList.setSelectionInterval(0, l2.size()-1);
        selectedPlayers=(ArrayList)l2.clone();
        //centerCanvas.setSelectedPlayers(selectedPlayers);
        centerPanel.setSelectedPlayers(selectedPlayers);
    }
    
    /** Method called on a click on the canvas
     * @param evt The event
     */
    public void centerCanvasMouseClicked(java.awt.event.MouseEvent evt) {
        /**int x = evt.getX();
         * int y = evt.getY();
         * System.out.println("Click sur ("+x+","+y+")");
         * // spinner values must be up to date
         * if ((x<50)||(y>550)) {
         * return;
         * }
         * // we know that if x=50 then turn = minSpinnerValue
         * // if x=800 then turn = maxSpinnerValue
         * // if y=0 then point=maxSpinnerValue
         * // if y=550 then point=minSpinnerValue
         * int currentMaxPoint = ((Integer)maxPointSpinner.getValue()).intValue();
         * int currentMinPoint = ((Integer)minPointSpinner.getValue()).intValue();
         * int currentMaxTurn = ((Integer)maxTurnSpinner.getValue()).intValue();
         * int currentMinTurn = ((Integer)minTurnSpinner.getValue()).intValue();
         * int point = new Double((currentMaxPoint*y)/550).intValue();
         * int turn = new Double((currentMaxTurn*x)/750).intValue();
         * if (this.getCursor().equals(zoomInCursor)) {
         * int propPoint = new Double ((currentMaxPoint-currentMinPoint)/4).intValue();
         * int propTurn = new Double((currentMaxTurn-currentMinTurn)/4).intValue();
         * if ((propPoint==0)||(propTurn==0)) {
         * return;
         * }
         * // we take 25% of current echelle and we take limits point+-25%
         * if ((point+propPoint)>maxPoints) {
         * centerCanvas.setMaxY(maxPoints);
         * maxPointSpinner.setValue(new Integer(maxPoints));
         * } else {
         * centerCanvas.setMaxY(point+propPoint);
         * maxPointSpinner.setValue(new Integer(point+propPoint));
         * }
         * if ((point-propPoint)<0) {
         * centerCanvas.setMinY(0);
         * minPointSpinner.setValue(new Integer(0));
         * } else {
         * centerCanvas.setMinY(point-propPoint);
         * minPointSpinner.setValue(new Integer(point-propPoint));
         * }
         * if ((turn+propTurn)>maxTurn) {
         * centerCanvas.setMaxX(maxTurn);
         * maxTurnSpinner.setValue(new Integer(maxTurn));
         * } else {
         * centerCanvas.setMaxX(turn+propTurn);
         * maxTurnSpinner.setValue(new Integer(turn+propTurn));
         * }
         * if ((turn-propTurn)<0) {
         * centerCanvas.setMinX(0);
         * minTurnSpinner.setValue(new Integer(0));
         * } else {
         * centerCanvas.setMinX(turn-propTurn);
         * minTurnSpinner.setValue(new Integer(turn-propTurn));
         * }
         * centerCanvas.repaint();
         * } else {
         * int propPoint = new Double ((currentMaxPoint-currentMinPoint)*1.25).intValue();
         * int propTurn = new Double((currentMaxTurn-currentMinTurn)*1.25).intValue();
         * if ((propPoint==0)||(propTurn==0)) {
         * return;
         * }
         * // we take 125% of current echelle and we take limits point+-125%
         * if ((point+propPoint)>maxPoints) {
         * centerCanvas.setMaxY(maxPoints);
         * maxPointSpinner.setValue(new Integer(maxPoints));
         * } else {
         * centerCanvas.setMaxY(point+propPoint);
         * maxPointSpinner.setValue(new Integer(point+propPoint));
         * }
         * if ((point-propPoint)<0) {
         * centerCanvas.setMinY(0);
         * minPointSpinner.setValue(new Integer(0));
         * } else {
         * centerCanvas.setMinY(point-propPoint);
         * minPointSpinner.setValue(new Integer(point-propPoint));
         * }
         * if ((turn+propTurn)>maxTurn) {
         * centerCanvas.setMaxX(maxTurn);
         * maxTurnSpinner.setValue(new Integer(maxTurn));
         * } else {
         * centerCanvas.setMaxX(turn+propTurn);
         * maxTurnSpinner.setValue(new Integer(turn+propTurn));
         * }
         * if ((turn-propTurn)<0) {
         * centerCanvas.setMinX(0);
         * minTurnSpinner.setValue(new Integer(0));
         * } else {
         * centerCanvas.setMinX(turn-propTurn);
         * minTurnSpinner.setValue(new Integer(turn-propTurn));
         * }
         * centerCanvas.repaint();
         * }**/
    }
    
    /** Repaint the graph
     * @param classement The ordoned players list
     * @param l The players list list
     **/
    public void repaintGraph(ArrayList classement, ArrayList l) {
        selectedPlayers=new ArrayList();
        maxTurn=l.size()-1;
        /**centerCanvas = new CurvesCanvas(playerList, l);
         * centerCanvas.addMouseListener(new java.awt.event.MouseAdapter() {
         * public void mouseClicked(java.awt.event.MouseEvent evt) {
         * centerCanvasMouseClicked(evt);
         * }
         * });**/
        //getContentPane().add(centerCanvas, java.awt.BorderLayout.CENTER);
        getContentPane().remove(centerPanel);
        centerPanel = new CurvesPanel(classement,l);
        initJList(classement);
        centerPanel.setMaxX(l.size()-1);
        centerPanel.setMaxY((int)centerPanel.getMaxPlayersPoints());
        centerPanel.setMinX(0);
        centerPanel.setMinY(0);
        getContentPane().add(centerPanel,java.awt.BorderLayout.CENTER);
        /**Image zoomInImg = new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/zoomin.png")).getImage();
        zoomInCursor = null;
        Toolkit tk = getToolkit();
        Point point = new Point(5,5);
        zoomInCursor = tk.createCustomCursor(zoomInImg,point, "ZoomIn");
        Image zoomOutImg = new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/zoomout.png")).getImage();
        zoomOutCursor = null;
        zoomOutCursor = tk.createCustomCursor(zoomOutImg, point, "ZoomOut");**/
        //maxPoints = (int)centerCanvas.getMaxPoints();
        maxPoints = (int)centerPanel.getMaxPlayersPoints();
        minPointSpinner.setModel(new SpinnerNumberModel(0,0,maxPoints,1));
        maxPointSpinner.setModel(new SpinnerNumberModel(maxPoints,1,maxPoints,1));
        minTurnSpinner.setModel(new SpinnerNumberModel(0,0,l.size()-2,1));
        maxTurnSpinner.setModel(new SpinnerNumberModel(l.size()-1,1,l.size()-1,1));
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel2 = new javax.swing.JPanel();
        saveButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();
        colorsButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        minTurnSpinner = new javax.swing.JSpinner();
        jLabel2 = new javax.swing.JLabel();
        maxTurnSpinner = new javax.swing.JSpinner();
        jLabel3 = new javax.swing.JLabel();
        minPointSpinner = new javax.swing.JSpinner();
        jLabel4 = new javax.swing.JLabel();
        maxPointSpinner = new javax.swing.JSpinner();
        displayButton = new javax.swing.JButton();
        zoomOutButton = new javax.swing.JButton();
        crossButton = new javax.swing.JToggleButton();
        gridButton = new javax.swing.JToggleButton();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        playerJList = new javax.swing.JList();

        setTitle("Curves of the game");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));
        saveButton.setBackground(new java.awt.Color(255, 255, 255));
        saveButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/save.png")));
        saveButton.setText("Save");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        jPanel2.add(saveButton);

        closeButton.setBackground(new java.awt.Color(255, 255, 255));
        closeButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/button_cancel.png")));
        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel2.add(closeButton);

        colorsButton.setBackground(new java.awt.Color(255, 255, 255));
        colorsButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/colors.png")));
        colorsButton.setText("Colors");
        colorsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                colorsButtonActionPerformed(evt);
            }
        });

        jPanel2.add(colorsButton);

        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));
        jLabel1.setText("min turn");
        jPanel1.add(jLabel1);

        jPanel1.add(minTurnSpinner);

        jLabel2.setText("max turn");
        jPanel1.add(jLabel2);

        jPanel1.add(maxTurnSpinner);

        jLabel3.setText("min points");
        jPanel1.add(jLabel3);

        jPanel1.add(minPointSpinner);

        jLabel4.setText("max points");
        jPanel1.add(jLabel4);

        jPanel1.add(maxPointSpinner);

        displayButton.setBackground(new java.awt.Color(255, 255, 255));
        displayButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/screen.png")));
        displayButton.setText("Display");
        displayButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                displayButtonActionPerformed(evt);
            }
        });

        jPanel1.add(displayButton);

        zoomOutButton.setBackground(new java.awt.Color(255, 255, 255));
        zoomOutButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/zoomout.png")));
        zoomOutButton.setToolTipText("Zoom out 125%");
        zoomOutButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        zoomOutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zoomOutButtonActionPerformed(evt);
            }
        });

        jPanel1.add(zoomOutButton);

        crossButton.setBackground(new java.awt.Color(255, 255, 255));
        crossButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/cross.png")));
        crossButton.setSelected(true);
        crossButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        crossButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                crossButtonActionPerformed(evt);
            }
        });

        jPanel1.add(crossButton);

        gridButton.setBackground(new java.awt.Color(255, 255, 255));
        gridButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/inserttable.png")));
        gridButton.setSelected(true);
        gridButton.setToolTipText("Dispaly the grid on the graph");
        gridButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        gridButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gridButtonActionPerformed(evt);
            }
        });

        jPanel1.add(gridButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.NORTH);

        jPanel3.setLayout(new java.awt.BorderLayout());

        playerJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                playerJListValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(playerJList);

        jPanel3.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel3, java.awt.BorderLayout.WEST);

        pack();
    }//GEN-END:initComponents

    private void gridButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_gridButtonActionPerformed
        // TODO add your handling code here:
        centerPanel.setGrid(!(centerPanel.isGrid()));
        centerPanel.repaint();
    }//GEN-LAST:event_gridButtonActionPerformed
    
    private void crossButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_crossButtonActionPerformed
        // TODO add your handling code here:
        centerPanel.setCross(!(centerPanel.isCross()));
        centerPanel.repaint();
    }//GEN-LAST:event_crossButtonActionPerformed
    
    private void playerJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_playerJListValueChanged
        // TODO add your handling code here:
        Object[] objs = playerJList.getSelectedValues();
        selectedPlayers.clear();
        for(int i=0;i<objs.length;i++) {
            selectedPlayers.add(objs[i]);
        }
        centerPanel.setSelectedPlayers(selectedPlayers);
        centerPanel.setRepaintCurveNeeded(true);
    }//GEN-LAST:event_playerJListValueChanged
    
    /** Save the graph in graphFile
     * @param graphFile The file to save
     **/
    public void save(File graphFile) {
        try {
            Rectangle r = centerPanel.getBounds();
            if (simulations.SimulationParameters.debug) {
                System.out.println("r.width = "+r.width+" height = "+r.height);
            }
            Image image = centerPanel.createImage(r.width, r.height);
            Graphics g = image.getGraphics();
            g.setColor(java.awt.Color.WHITE);
            g.fillRect(0,0, r.width,r.height);
            g.setColor(java.awt.Color.BLACK);
            centerPanel.drawCurves(g);
            ImageIO.write((RenderedImage)image, "png", graphFile);
        }catch (IOException ioe) {
            ioe.printStackTrace();
            System.out.println(ioe.toString());
        }
        try {
            Image image = centerPanel.createImage(600, centerPanel.getData().getData().size()*15);
            Graphics g = image.getGraphics();
            drawColors(g);
            String name = graphFile.getPath().substring(0,graphFile.getPath().length()-4);
            name=name+"_color.png";
            ImageIO.write((RenderedImage)image, "png", new File(name));
        }catch (IOException ioe) {
            ioe.printStackTrace();
        }
    }
    
    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        // Add your handling code here:
        JFileChooser chooser = new JFileChooser();
        StrategyFileFilter filter = new StrategyFileFilter("png");
        filter.setDescription("PNG files");
        chooser.setFileFilter(filter);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            String fileName = chooser.getSelectedFile().getPath();
            if (simulations.SimulationParameters.debug) {
                System.out.println(fileName);
            }
            if (!(fileName.substring(fileName.length()-4,fileName.length()).equals(".png"))) {
                fileName=fileName+".png";
            }
            /**
            try {
                Rectangle r = centerPanel.getBounds();
                Image image = centerPanel.createImage(r.width, r.height);
                Graphics g = image.getGraphics();
                g = centerPanel.getOffscreen().getGraphics();
                ImageIO.write((RenderedImage)image, "png", new File(fileName));
            }catch (IOException ioe) {
                ioe.printStackTrace();
            }
            try {
                Image image = centerPanel.createImage(400, centerPanel.getData().getData().size()*15);
                Graphics g = image.getGraphics();
                drawColors(g);
                String name = fileName.substring(0,fileName.length()-4);
                name=name+"_color.png";
                ImageIO.write((RenderedImage)image, "png", new File(name));
            }catch (IOException ioe) {
                ioe.printStackTrace();
            }**/
            save(new File(fileName));
        }
    }//GEN-LAST:event_saveButtonActionPerformed
    
    /** draw colors associated to player in Graphics g
     * @param g The Graphics
     **/
    public void drawColors(Graphics g) {
        g.setColor(java.awt.Color.WHITE);
        g.fillRect(0,0, 600, centerPanel.getData().getData().size()*15);
        g.setColor(java.awt.Color.BLACK);
        Iterator it = centerPanel.getData().getData().iterator();
        int px = 15;
        while (it.hasNext()) {
            CurvesPlayerData data = (CurvesPlayerData)it.next();
            g.setColor(java.awt.Color.BLACK);
            g.drawString(data.getPlayer().toString(), 0, px);
            g.drawString(data.getPlayer().getStrategy().getName(), 250, px);
            g.setColor(data.getColor());
            g.fillRect(550, px-5, 50, 5);
            px+=15;
        }
        g.setColor(java.awt.Color.BLACK);
    }
    
    private void zoomOutButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zoomOutButtonActionPerformed
        // Add your handling code here:
        int currentMaxPoint = centerPanel.getMaxY();
        int currentMinPoint = centerPanel.getMinY();
        int currentMaxTurn = centerPanel.getMaxX();
        int currentMinTurn = centerPanel.getMinX();
        int propPoint = new Double((currentMaxPoint-currentMinPoint)*1.25).intValue();
        int propTurn = new Double((currentMaxTurn-currentMinTurn)*1.25).intValue();
        if ((propPoint==0)||(propTurn==0)) {
            return;
        }
        if ((currentMaxPoint+propPoint)>centerPanel.getMaxMaxY()) {
            centerPanel.setMaxY(centerPanel.getMaxMaxY());
        } else {
            centerPanel.setMaxY(currentMaxPoint+propPoint);
        }
        if ((currentMinPoint-propPoint)<0) {
            centerPanel.setMinY(0);
        } else {
            centerPanel.setMinY(currentMinPoint-propPoint);
        }
        if ((currentMaxTurn+propTurn)>centerPanel.getMaxMaxX()) {
            centerPanel.setMaxX(centerPanel.getMaxMaxX());
        } else {
            centerPanel.setMaxX(currentMaxTurn+propTurn);
        }
        if ((currentMinTurn-propTurn)<0) {
            centerPanel.setMinX(0);
        } else {
            centerPanel.setMinX(currentMinTurn-propTurn);
        }
        minPointSpinner.setValue(new Integer(centerPanel.getMinY()));
        maxPointSpinner.setValue(new Integer(centerPanel.getMaxY()));
        minTurnSpinner.setValue(new Integer(centerPanel.getMinX()));
        maxTurnSpinner.setValue(new Integer(centerPanel.getMaxX()));
        centerPanel.setRepaintCurveNeeded(true);
        centerPanel.repaint();
    }//GEN-LAST:event_zoomOutButtonActionPerformed
    
    private void displayButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_displayButtonActionPerformed
        // Add your handling code here:
        int minX = ((Integer)minTurnSpinner.getValue()).intValue();
        int minY = ((Integer)minPointSpinner.getValue()).intValue();
        int maxX = ((Integer)maxTurnSpinner.getValue()).intValue();
        int maxY = ((Integer)maxPointSpinner.getValue()).intValue();
        centerPanel.setMaxX(maxX);
        centerPanel.setMaxY(maxY);
        centerPanel.setMinX(minX);
        centerPanel.setMinY(minY);
        centerPanel.setRepaintCurveNeeded(true);
        centerPanel.repaint();
    }//GEN-LAST:event_displayButtonActionPerformed
    
    private void colorsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_colorsButtonActionPerformed
        // Add your handling code here:
        ColorsDialog dialog = new ColorsDialog(null, false, centerPanel.getData());
        dialog.setVisible(true);
    }//GEN-LAST:event_colorsButtonActionPerformed
    
    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        if ((this.getCursor()==zoomInCursor)||(this.getCursor()==zoomOutCursor)) {
            this.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        }
        dispose();
    }//GEN-LAST:event_closeDialog

    public void run() {
        this.setVisible(true);
    }    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JButton colorsButton;
    private javax.swing.JToggleButton crossButton;
    private javax.swing.JButton displayButton;
    private javax.swing.JToggleButton gridButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSpinner maxPointSpinner;
    private javax.swing.JSpinner maxTurnSpinner;
    private javax.swing.JSpinner minPointSpinner;
    private javax.swing.JSpinner minTurnSpinner;
    private javax.swing.JList playerJList;
    private javax.swing.JButton saveButton;
    private javax.swing.JButton zoomOutButton;
    // End of variables declaration//GEN-END:variables
    
}
