/*
 * CurvesData.java
 *
 * Created on April 25, 2004, 12:06 AM
 */

package simulations.gui.curves;

import java.util.ArrayList;
import java.util.Iterator;

import java.awt.Color;

import simulations.core.Player;


/**
 * This class stores the data of a player curve
 * @author tom
 */
public class CurvesPlayerData {
    
    /** The player **/
    private Player player;
    
    /** The data of this player **/
    private Double[] data;
    
    /** The associated color of this player **/
    private Color color;
    
    /**
     * Creates a new instance of CurvesPlayerData
     * @param player The player
     * @param l The players list list
     * @param color The color associated to this player
     */
    public CurvesPlayerData(Player player, ArrayList l, Color color) {
        this.player=player;
        this.color=color;
        data = new Double[l.size()];
        setData(l);
    }
    
    /** Constructs the data from the list l
     * @param l The players turn list
     **/
    private void setData(ArrayList l) {
        int turn=0;
        Iterator it = l.iterator();
        while (it.hasNext()) {
            ArrayList tmp = (ArrayList)it.next();
            Iterator it2 = tmp.iterator();
            while (it2.hasNext()) {
                Player p = (Player)it2.next();
                if (p.equals(player)) {
                    data[turn]=new Double(p.getHitPoints());
                    turn++;
                }
            }
        }
        while (turn<l.size()) {
            data[turn]=new Double(0);
            turn++;
        }
    }
    
    /**
     * Getter for property color.
     * @return Value of property color.
     */
    public java.awt.Color getColor() {
        return color;
    }
    
    /**
     * Setter for property color.
     * @param color New value of property color.
     */
    public void setColor(java.awt.Color color) {
        this.color = color;
    }
    
    /**
     * Getter for property data.
     * @return Value of property data.
     */
    public java.lang.Double[] getData() {
        return this.data;
    }
    
    /**
     * Setter for property data.
     * @param data New value of property data.
     */
    public void setData(java.lang.Double[] data) {
        this.data = data;
    }
    
    /**
     * Getter for property player.
     * @return Value of property player.
     */
    public simulations.core.Player getPlayer() {
        return player;
    }
    
    /**
     * Setter for property player.
     * @param player New value of property player.
     */
    public void setPlayer(simulations.core.Player player) {
        this.player = player;
    }
    
}
