/*
 * CoalitionCurvesDialog.java
 *
 * Created on May 19, 2004, 2:34 AM
 */

package simulations.gui.curves;

import java.util.ArrayList;

import java.io.File;
import java.io.IOException;

import java.awt.Rectangle;
import java.awt.Image;
import java.awt.image.RenderedImage;
import java.awt.Graphics;

import javax.swing.JFileChooser;
import javax.swing.SpinnerNumberModel;
import javax.imageio.ImageIO;

import simulations.gui.StrategyFileFilter;

/**
 * This class decribes the dialog to contains the coalitions curves panel
 * @author  tom
 */
public class GenericCurvesDialog extends javax.swing.JDialog {
    
    /** The panel containing graph **/
    private GenericCurvesPanel centerPanel;
    
    /** Creates new form CoalitionCurvesDialog
     * @param parent The parent frame
     * @param modal True if the dialog is modal
     * @param data The data
     * @param title The title
     **/
    public GenericCurvesDialog(java.awt.Frame parent, boolean modal, double[] data, String title) {
        super(parent, modal);
        initComponents();
        titleLabel.setText(title);
        this.setTitle(title);
        centerPanel = new GenericCurvesPanel(data);
        this.getContentPane().add(centerPanel,java.awt.BorderLayout.CENTER);
        // if no coalitions are formed...
        try {
            minPointSpinner.setModel(new SpinnerNumberModel(0,0,centerPanel.getMaxMaxY(),1));
            maxPointSpinner.setModel(new SpinnerNumberModel(centerPanel.getMaxMaxY(),1,centerPanel.getMaxMaxY(),1));
            minTurnSpinner.setModel(new SpinnerNumberModel(0,0,data.length-2,1));
            maxTurnSpinner.setModel(new SpinnerNumberModel(data.length-1,1,data.length-1,1));
        }catch(IllegalArgumentException e) {
            
        }
        centerPanel.repaint();
        this.repaint();
        this.setSize(900,800);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        titleLabel = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        minTurnSpinner = new javax.swing.JSpinner();
        jLabel3 = new javax.swing.JLabel();
        maxTurnSpinner = new javax.swing.JSpinner();
        jLabel4 = new javax.swing.JLabel();
        minPointSpinner = new javax.swing.JSpinner();
        jLabel5 = new javax.swing.JLabel();
        maxPointSpinner = new javax.swing.JSpinner();
        displayButton = new javax.swing.JButton();
        zoomOutButton = new javax.swing.JButton();
        crossButton = new javax.swing.JToggleButton();
        gridButton = new javax.swing.JToggleButton();
        jPanel2 = new javax.swing.JPanel();
        saveButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("");
        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));
        titleLabel.setBackground(new java.awt.Color(255, 255, 255));
        titleLabel.setFont(new java.awt.Font("Dialog", 1, 16));
        titleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        titleLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/chart2.png")));
        titleLabel.setText("Coalition curves");
        titleLabel.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        jPanel1.add(titleLabel, java.awt.BorderLayout.NORTH);

        jPanel3.setBackground(new java.awt.Color(255, 255, 255));
        jPanel3.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        jLabel2.setText("min turn");
        jPanel3.add(jLabel2);

        jPanel3.add(minTurnSpinner);

        jLabel3.setText("max turn");
        jPanel3.add(jLabel3);

        jPanel3.add(maxTurnSpinner);

        jLabel4.setText("min points");
        jPanel3.add(jLabel4);

        jPanel3.add(minPointSpinner);

        jLabel5.setText("max points");
        jPanel3.add(jLabel5);

        jPanel3.add(maxPointSpinner);

        displayButton.setBackground(new java.awt.Color(255, 255, 255));
        displayButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/screen.png")));
        displayButton.setText("Display");
        displayButton.setToolTipText("Display the curve with this values");
        displayButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                displayButtonActionPerformed(evt);
            }
        });

        jPanel3.add(displayButton);

        zoomOutButton.setBackground(new java.awt.Color(255, 255, 255));
        zoomOutButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/zoomout.png")));
        zoomOutButton.setToolTipText("Zoom out 125%");
        zoomOutButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        zoomOutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zoomOutButtonActionPerformed(evt);
            }
        });

        jPanel3.add(zoomOutButton);

        crossButton.setBackground(new java.awt.Color(255, 255, 255));
        crossButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/cross.png")));
        crossButton.setSelected(true);
        crossButton.setToolTipText("Display the mouse cross ");
        crossButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        crossButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                crossButtonActionPerformed(evt);
            }
        });

        jPanel3.add(crossButton);

        gridButton.setBackground(new java.awt.Color(255, 255, 255));
        gridButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/inserttable.png")));
        gridButton.setSelected(true);
        gridButton.setToolTipText("Dispaly the grid on the graph");
        gridButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        gridButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gridButtonActionPerformed(evt);
            }
        });

        jPanel3.add(gridButton);

        jPanel1.add(jPanel3, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.NORTH);

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));
        jPanel2.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        saveButton.setBackground(new java.awt.Color(255, 255, 255));
        saveButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/save.png")));
        saveButton.setText("Save");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        jPanel2.add(saveButton);

        closeButton.setBackground(new java.awt.Color(255, 255, 255));
        closeButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/button_cancel.png")));
        closeButton.setText("Close");
        closeButton.setToolTipText("Close the dialog");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel2.add(closeButton);

        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    /** Save the graph in graphFile
     * @param graphFile The file to save
     **/
    public void save(File graphFile) {
        try {
            Rectangle r = centerPanel.getBounds();
            if (simulations.SimulationParameters.debug) {
                System.out.println("r.width = "+r.width+" height = "+r.height);
            }
            Image image = centerPanel.createImage(r.width, r.height);
            Graphics g = image.getGraphics();
            g.setColor(java.awt.Color.WHITE);
            g.fillRect(0,0, r.width,r.height);
            g.setColor(java.awt.Color.BLACK);
            centerPanel.drawCurves(g);
            ImageIO.write((RenderedImage)image, "png", graphFile);
        }catch (IOException ioe) {
            ioe.printStackTrace();
            System.out.println(ioe.toString());
        }
    }
    
    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        // TODO add your handling code here:
        JFileChooser chooser = new JFileChooser();
        StrategyFileFilter filter = new StrategyFileFilter("png");
        filter.setDescription("PNG files");
        chooser.setFileFilter(filter);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            String fileName = chooser.getSelectedFile().getPath();
            if (simulations.SimulationParameters.debug) {
                System.out.println(fileName);
            }
            if (!(fileName.substring(fileName.length()-4,fileName.length()).equals(".png"))) {
                fileName=fileName+".png";
            }
            save(new File(fileName));
        }
    }//GEN-LAST:event_saveButtonActionPerformed

    private void gridButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_gridButtonActionPerformed
        // TODO add your handling code here:
        centerPanel.setGrid(!(centerPanel.isGrid()));
        centerPanel.repaint();
    }//GEN-LAST:event_gridButtonActionPerformed

    private void crossButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_crossButtonActionPerformed
        // TODO add your handling code here:
        centerPanel.setCross(!(centerPanel.isCross()));
        centerPanel.repaint();
    }//GEN-LAST:event_crossButtonActionPerformed

    private void zoomOutButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zoomOutButtonActionPerformed
        // TODO add your handling code here:
        int currentMaxPoint = centerPanel.getMaxY();
        int currentMinPoint = centerPanel.getMinY();
        int currentMaxTurn = centerPanel.getMaxX();
        int currentMinTurn = centerPanel.getMinX();
        int propPoint = new Double((currentMaxPoint-currentMinPoint)*1.25).intValue();
        int propTurn = new Double((currentMaxTurn-currentMinTurn)*1.25).intValue();
        if ((propPoint==0)||(propTurn==0)) {
            return;
        }
        if ((currentMaxPoint+propPoint)>centerPanel.getMaxMaxY()) {
            centerPanel.setMaxY(centerPanel.getMaxMaxY());
        } else {
            centerPanel.setMaxY(currentMaxPoint+propPoint);
        }
        if ((currentMinPoint-propPoint)<0) {
            centerPanel.setMinY(0);
        } else {
            centerPanel.setMinY(currentMinPoint-propPoint);
        }
        if ((currentMaxTurn+propTurn)>centerPanel.getMaxMaxX()) {
            centerPanel.setMaxX(centerPanel.getMaxMaxX());
        } else {
            centerPanel.setMaxX(currentMaxTurn+propTurn);
        }
        if ((currentMinTurn-propTurn)<0) {
            centerPanel.setMinX(0);
        } else {
            centerPanel.setMinX(currentMinTurn-propTurn);
        }
        minPointSpinner.setValue(new Integer(centerPanel.getMinY()));
        maxPointSpinner.setValue(new Integer(centerPanel.getMaxY()));
        minTurnSpinner.setValue(new Integer(centerPanel.getMinX()));
        maxTurnSpinner.setValue(new Integer(centerPanel.getMaxX()));
        centerPanel.setRepaintCurveNeeded(true);
        centerPanel.repaint();
    }//GEN-LAST:event_zoomOutButtonActionPerformed

    private void displayButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_displayButtonActionPerformed
        // TODO add your handling code here:
        int minX = ((Integer)minTurnSpinner.getValue()).intValue();
        int minY = ((Integer)minPointSpinner.getValue()).intValue();
        int maxX = ((Integer)maxTurnSpinner.getValue()).intValue();
        int maxY = ((Integer)maxPointSpinner.getValue()).intValue();
        centerPanel.setMaxX(maxX);
        centerPanel.setMaxY(maxY);
        centerPanel.setMinX(minX);
        centerPanel.setMinY(minY);
        centerPanel.setRepaintCurveNeeded(true);
        centerPanel.repaint();
    }//GEN-LAST:event_displayButtonActionPerformed

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // TODO add your handling code here:
        this.setVisible(false);
        this.dispose();
    }//GEN-LAST:event_closeButtonActionPerformed
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JToggleButton crossButton;
    private javax.swing.JButton displayButton;
    private javax.swing.JToggleButton gridButton;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JSpinner maxPointSpinner;
    private javax.swing.JSpinner maxTurnSpinner;
    private javax.swing.JSpinner minPointSpinner;
    private javax.swing.JSpinner minTurnSpinner;
    private javax.swing.JButton saveButton;
    private javax.swing.JLabel titleLabel;
    private javax.swing.JButton zoomOutButton;
    // End of variables declaration//GEN-END:variables
    
}
